#include "moso.h"
#include "dig.h"
#include "menu.h"
#include "happysnd.h"
#include "save.h"

void digTick(CMoso* pMe)
{
	// 丮  ..
	if( pMe->gameMode == GAMEMODE_STORY)
	{
		// ù̸ Ʃ丮 ش.
		if( pMe->story_day == 0 && pMe->tutorial_digShowed == FALSE )
		{
			pMe->tutorial_digShowed = TRUE;

			SETSTATE(pMe,STATE_TUTORIAL);
			return;
		}
	}


	//  ޴ ȣ (  ð   ʴٸ..    ٸ Ű Է  ʴ´.)
	if( pMe->keyCurr & GKEY_BACK && pMe->dig_state != DSTATE_END)
	{
		//   Ҹ ִٸ ߰.
		sfx_stop(pMe);


		gotoMenu(pMe,MSTATE_GAMEMENU);
		SETSTATE(pMe,STATE_MENU);	


		// ⼭ FALSE   ƿ  ٽ ׷..
		pMe->dig_backDraw = FALSE;


		pMe->keyCurr = GKEY_NONE;
		return;
	}

#if CHEAT_ENDLESS_LEVELJUMP
	if( pMe->gameMode == GAMEMODE_ENDLESS) 
	{
		// Ѹ_ġƮŰ   ׳ ö󰡹.
		if( pMe->keyCurr & GKEY_SOFT3 )
		{					
			pMe->endless_diglv++;

			if( pMe->endless_diglv < ENDLESS_LEVELEND ) 
			{
				digInit(pMe);
				gotoDig(pMe,DSTATE_READY);
			}
			else
			{
				pMe->endless_diglv = 0;

				gotoMenu(pMe,MSTATE_MAIN);
				SETSTATE(pMe,STATE_MENU);
			}
		}
	}
#endif


	switch(pMe->dig_state)
	{
		case DSTATE_READY:
			{
				uint32	tickTime;
				int x,y,dx,dy;

				setScreen(pMe);
				digDrawBg(pMe);
				digDrawTime(pMe);
				digDrawDay(pMe);
				digDrawDirt(pMe);

				tickTime = GET_UPTIMEMS();

				x = pMe->canvas_midx;
				y = pMe->canvas_midy;

				dx = pMe->imgGame[IMG_START].info.cx;
				dy = pMe->imgGame[IMG_START].info.cy;

				if( pMe->dig_ready == FALSE )
				{
					pMe->dig_temp		= tickTime;
					pMe->dig_ready		= TRUE;
					pMe->dig_startAni	= 1;
					break;
				}
				if( tickTime - pMe->dig_temp > 300 && pMe->dig_startAni == 1 )
				{
					pMe->dig_temp		= tickTime;
					pMe->dig_startAni	= 2;

					setClip(pMe,x-dx/2,y-dy/2,dx,dy);					
					drawImage(pMe,IMG_START,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);			
				}
				else if( tickTime - pMe->dig_temp > 300 && pMe->dig_startAni == 2 )
				{
					pMe->dig_temp		= tickTime;
					pMe->dig_startAni	= 3;

					setClip(pMe,x-dx/2,y-dy/2,dx,dy);					
					pMe->dig_backDraw = FALSE;
					digDrawBg(pMe);
				}
				else if( tickTime - pMe->dig_temp > 300 && pMe->dig_startAni == 3 )
				{
					pMe->dig_temp		= tickTime;
					pMe->dig_startAni	= 4;

					setClip(pMe,x-dx/2,y-dy/2,dx,dy);					
					drawImage(pMe,IMG_START,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);			
				}
				else if( tickTime - pMe->dig_temp > 300 && pMe->dig_startAni == 4 )
				{
					pMe->dig_temp		= tickTime;
					pMe->dig_startAni	= 5;

					setClip(pMe,x-dx/2,y-dy/2,dx,dy);					
					pMe->dig_backDraw = FALSE;
					digDrawBg(pMe);
				}
				else if( pMe->dig_startAni == 5 )
				{
					gotoDig(pMe,DSTATE_START);
				}
			}
			break;

		case DSTATE_START:
			{
				uint32 tickTime = GET_UPTIMEMS();
				int rand;
				int i;

				//  ׷ְ..
				setScreen(pMe);
				digDrawBg(pMe);

				//  ó ߴٸ..
				if( pMe->dig_startTime == 0 )
				{
					pMe->dig_startTime	= tickTime;
					pMe->dig_guardStart = tickTime;
				}

				// get current time
				pMe->dig_currTime = tickTime - pMe->dig_startTime;

				//  ð  Ǿ  or   ų...
				if( pMe->dig_currTime > pMe->dig_wholeTime )
				{
					//   Ҹ ִٸ ش.
					sfx_stop(pMe);
					gotoDig(pMe,DSTATE_RESULT);

					digDrawTime(pMe);
					break;
				}

				//  ɷȴٸ гƼ..
				if( pMe->dig_caught )
				{
					if( tickTime - pMe->dig_caughtTime <= 200 )
					{
						//   ĥֱ
						setScreen(pMe);
						fillRect(pMe,0,0,pMe->canvas_width,pMe->dig_status_y,RGB(0,0,0));
					}
					else if( tickTime - pMe->dig_caughtTime > 200 && tickTime - pMe->dig_caughtTime <= 1000 )
					{
						// ´ ȭ ֱ
						drawImage(pMe,IMG_DIGCAUGHT1,0,0,GFX_LEFT);

						if( pMe->dig_hitsndPlay1 == FALSE )
						{
							pMe->dig_hitsndPlay1 = TRUE;
							sfx_play(pMe,SND_DIGHIT,FALSE);
						}
					}
					else if( tickTime - pMe->dig_caughtTime > 1000 && tickTime - pMe->dig_caughtTime <= 2000 )
					{
						// ´ ȭ ֱ
						drawImage(pMe,IMG_DIGCAUGHT2,pMe->canvas_width,pMe->dig_status_y,GFX_RIGHT|GFX_BOTTOM);						

						if( pMe->dig_hitsndPlay2 == FALSE )
						{
							pMe->dig_hitsndPlay2 = TRUE;
							sfx_play(pMe,SND_DIGHIT,FALSE);
						}
					}

					//  ¾Ҵٸ. -_-;;
					// story mode   ϰ
					// endless mode   .
					else if( tickTime - pMe->dig_caughtTime > 2000 )
					{
						if( pMe->gameMode == GAMEMODE_STORY )
						{
							pMe->dig_caught = FALSE;

							pMe->dig_positionPoster = 0;

							setClip(pMe,0,0,pMe->canvas_width,pMe->dig_status_y);
							pMe->dig_backDraw = FALSE;
							digDrawBg(pMe);

							pMe->dig_hitsndPlay1	= FALSE;
							pMe->dig_hitsndPlay2	= FALSE;
						}
						else if( pMe->gameMode == GAMEMODE_ENDLESS )
						{
							pMe->dig_caught = FALSE;

							//   Ҹ ִٸ ش.
							sfx_stop(pMe);
							gotoDig(pMe,DSTATE_RESULT);
							break;
						}
					}

					digDrawTime(pMe);
					break;
				}
		
				//  ̴° ð  α..
				if( tickTime - pMe->dig_guardStart > pMe->dig_guardGap )
				{
					pMe->dig_guardStart = tickTime;

					//   ..
					for(i=0;i<pMe->dig_numGuard;i++)
					{
						//  ٲٴ 󵵼..
						rand = getRand(pMe,7);
						if( rand == 0 )
						{
							if( pMe->dig_frequent[i] == 1 )
							{
								pMe->dig_frequent[i] = 0;
								pMe->dig_directionGuard[i] = pMe->dig_directionGuard[i] * -1;
							}
							else 
								pMe->dig_frequent[i]++;
						}
						

#if !(CHEAT_DIG_GUARDSTOP)
						//  ź  ٸ   ƾ.
						if( !pMe->dig_bombUsed )
							pMe->dig_positionGuard[i] += pMe->dig_directionGuard[i];
#endif


						//   ٸ  ٲش.
						if( pMe->dig_positionGuard[i] >= DIG_DISTANCE)
						{
							
							pMe->dig_positionGuard[i]	= DIG_DISTANCE-1;
							pMe->dig_directionGuard[i]	= -1;					
						}
						else if( pMe->dig_positionGuard[i] < 0 )
						{
							pMe->dig_positionGuard[i]	= 0;
							pMe->dig_directionGuard[i]	= 1;
						}
					}
				}

				// ź   ɸ ʴ´.
				if( !pMe->dig_bombUsed ) 
				{
					//   ..
					for(i=0;i<pMe->dig_numGuard;i++)
					{		
						//  Դµ..
						if( pMe->dig_positionGuard[i] < DIG_CAUGHTDIS )
						{	
							//     ±..
							if( pMe->dig_positionPoster !=0 )//> 0 && pMe->dig_positionPoster < 3 )
							{
								//   ִٸ гƼ  .
								pMe->dig_caught		= TRUE;
								pMe->dig_caughtTime	= tickTime;
								return;
							}
						}	
					}
				}

				//  ı..
				if( pMe->keyCurr & GKEY_3 )
				{
					if(pMe->dig_positionPoster == 3)
					{
						int temp = GET_UPTIMEMS();
						//  ð     ְ Ѵ.
						if( temp - pMe->dig_digGap > 250 ) 
						{ 
							//   Ѹ      ϴ ̴.
							pMe->endless_digscore += 10;

							pMe->dig_digGap = temp;
							sfx_play(pMe,SND_DIGDIG,FALSE);

							//  ĳ.
							pMe->dig_currDirt -= pMe->dig_oneShot;			
							

							//  Ƣ frame  ÷ְ,  ٲش.
							pMe->dig_framePiece = 1;
							pMe->dig_whichPiece = !pMe->dig_whichPiece;

							//   ̴   ش.
							pMe->dig_frameMinus = 1;

							//   ʹٸ..
							if( pMe->dig_currDirt <= 0) {
								pMe->dig_currDirt = 0;
								gotoDig(pMe,DSTATE_RESULT);
							}

							//  Ĵ  ٲְ.
							pMe->dig_ani1P++;
							if( pMe->dig_ani1P == 2 )
								pMe->dig_ani1P = 0;
						}
					}
					else
					{
						pMe->dig_frameWarning = 1;


					}
					//    ʾҴµ ȷ ϸ  ..
					// ׷ 1 .
//					else if( pMe->dig_positionPoster != 0 ) 
//					{
//						pMe->dig_life--;						
//					}

				}
				//  
				else if( pMe->keyCurr & GKEY_1 )
				{
					pMe->dig_positionPoster += pMe->dig_directionPoster;

					//   ..
					if( pMe->dig_positionPoster <= 0 )
					{
						pMe->dig_positionPoster = 0;
						pMe->dig_directionPoster = 1;

						pMe->dig_sleepsndPlayed = FALSE;
					}
					else if( pMe->dig_positionPoster >= 3 )
					{
						pMe->dig_positionPoster = 3;
						pMe->dig_directionPoster = -1;
					}
				}

				else if( pMe->keyCurr & GKEY_STAR )
				{
					// 丮  ..
					if( pMe->gameMode == GAMEMODE_STORY )
					{
						//  ְ   ƴ϶.
						if( pMe->story_itemNum > 0 &&
							pMe->dig_timeUsed == FALSE && 
							pMe->dig_drillUsed == FALSE && 
							pMe->dig_bombUsed == FALSE )							
						{
							int item = pMe->story_item[pMe->story_itemNum-1];

							if( item == 3 ) //  ̸
								item = getRand(pMe,3); // ƹų ش.

							switch(item)
							{
								case 0: // ð
									pMe->dig_timeUsed	= TRUE;
									pMe->dig_timeTime	= GET_UPTIMEMS();									
									break;
								case 1: // 帱
									pMe->dig_drillUsed		= TRUE;
									pMe->dig_drillFrame		= 4;
									pMe->dig_drillAni		= -1;
									gotoDig(pMe,DSTATE_DRILLITEM);

									//  ߰
									sfx_stop(pMe);
									break;
								case 2: // ź
									pMe->dig_bombFrame	= 4;
									gotoDig(pMe,DSTATE_BOMBITEM);

									//  ߰
									sfx_stop(pMe);
									break;
							}

							//  ְ.
							pMe->story_itemNum--;
						}
					}
				}
#if CHEAT_STORY_USEITEM
				//  
				else if( pMe->keyCurr & GKEY_4 ) 
				{
					// ð 
					pMe->dig_timeUsed	= TRUE;
					pMe->dig_timeTime	= GET_UPTIMEMS();
				}
				else if( pMe->keyCurr & GKEY_5 ) 
				{
					// 帱 
					pMe->dig_drillUsed		= TRUE;
					pMe->dig_drillFrame		= 4;
					pMe->dig_drillAni		= -1;
					gotoDig(pMe,DSTATE_DRILLITEM);

					//  ߰
					sfx_stop(pMe);
				}
				else if( pMe->keyCurr & GKEY_6 ) 
				{
					///*
					// ź 
					pMe->dig_bombFrame	= 4;
					gotoDig(pMe,DSTATE_BOMBITEM);

					sfx_stop(pMe);
				}
				else if( pMe->keyCurr & GKEY_7 ) 
				{
					switch(getRand(pMe,3))
					{
						case 0: // ð
							pMe->dig_timeUsed	= TRUE;
							pMe->dig_timeTime	= GET_UPTIMEMS();									
							break;
						case 1: // 帱
							pMe->dig_drillUsed		= TRUE;
							pMe->dig_drillFrame		= 4;
							pMe->dig_drillAni		= -1;
							gotoDig(pMe,DSTATE_DRILLITEM);

							//  ߰
							sfx_stop(pMe);
							break;
						case 2: // ź
							pMe->dig_bombFrame	= 4;
							gotoDig(pMe,DSTATE_BOMBITEM);
							break;
					}
				}
#endif
			


#if CHEAT_STORY_STAGECLEAR
				// ӽð Ҵµ  ߾ٸ .
				if( pMe->gameMode == GAMEMODE_STORY) 
				{
					if( pMe->keyCurr == GKEY_SOFT3 ) 
					{
						sfx_stop(pMe);

						pMe->dig_end = FALSE;
						pMe->dig_currDirt = 0;
						gotoDig(pMe,DSTATE_RESULT);
					}
				}
#endif

				//  ׷ְ..	
				digErase(pMe);
				
				digDrawPoster(pMe);				
				digDraw1P(pMe);				
				digDrawPiece(pMe);
				digDrawMinus(pMe);
				digDrawGuard(pMe);		
				digDrawDirt(pMe);
				digDrawTime(pMe);
				digDrawDay(pMe);
				digDrawWarning(pMe);

				digDrawItem(pMe);
			}
			break;

		case DSTATE_BOMBITEM:
			if( pMe->dig_bombFrame > 0 )
			{


				int x,y,dx,dy,img,i;
				int ox,oy; // ruler position
				Image bomb;


				// ź  Ҹ 
				if( pMe->dig_bombFrame == 4 ) {
					sfx_play(pMe,SND_ITEMBOMB,FALSE);
				}

				bomb.bitmap		= NULL;
				bomb.src		= NULL;
				img = IDB_DIGBOMB4 - (pMe->dig_bombFrame-1);
				loadImage(pMe,&bomb,MOSO_RES_FILE,img);
				dx	= bomb.info.cx;
				dy	= bomb.info.cy;

				
				// draw bomb animation for each guard.
				ox = pMe->dig_cm_x; 
				oy = pMe->dig_cm_y;

				// draw guard icon
				for(i=0;i<pMe->dig_numGuard;i++)
				{
					x = ox + pMe->dig_positionGuard[i]*(pMe->imgGame[IMG_DIGCM].info.cx/DIG_DISTANCE);
					y = oy;
					
					x -= 7;
					y -= 3;
					setClip(pMe,x,y,dx,dy);
					drawImage2(pMe,&bomb,x,y,GFX_LEFT);
				}	

				// â   ź  ׷ش.
				for(i=0;i<pMe->dig_numGuard;i++) 
				{
					if( pMe->dig_positionGuard[i] <= DIG_CAUGHTDIS ) 
					{
						// position of window on bg
						x = pMe->dig_guard_x;
						y = pMe->dig_guard_y;

						x += 8;

						setClip(pMe,x-dx,y-dy,dx,dy);
						drawImage2(pMe,&bomb,x,y,GFX_RIGHT|GFX_BOTTOM);

						// ⼭ ѳ̵ γ̵  ִϸ̼  ׷ ʿ ̾.
						break;
					}
				}

				freeImage(pMe,&bomb);


				pMe->dig_bombFrame--;

				pMe->dig_bombUsed		= TRUE;
			}
			else if( pMe->dig_bombFrame == 0 )
			{		
				pMe->dig_bombTime		= GET_UPTIMEMS();
				gotoDig(pMe,DSTATE_START);
			}		
			break;


		case DSTATE_DRILLITEM:
			if( pMe->dig_drillFrame > 0 )
			{
				int x,y,dx,dy,img;
				Image smoke;

				smoke.bitmap	= NULL;
				smoke.src		= NULL;

				img = IDB_DIGSMOKE4 - (pMe->dig_drillFrame-1);
				loadImage(pMe,&smoke,MOSO_RES_FILE,img);

				x	= pMe->dig_1p_x;
				y	= pMe->dig_1p_y;
				dx	= smoke.info.cx;
				dy	= smoke.info.cy;

				x -= 25;
				y -= 20;


				pMe->dig_backDraw = FALSE;
				setClip(pMe,x,y,dx,dy);	
				digDrawBg(pMe);
				setClip(pMe,x,y,dx,dy);	
				digDrawPoster(pMe);
				setClip(pMe,x,y,dx,dy);	
				drawImage2(pMe,&smoke,x,y,GFX_LEFT);
				freeImage(pMe,&smoke);				

				pMe->dig_drillFrame--;
			}
			else if( pMe->dig_drillFrame == 0 )
			{				
				int x,y,dx,dy;

				x	= pMe->dig_1p_x;
				y	= pMe->dig_1p_y;
				dx	= 84;	//  ׸ ũ.. ⼭ εϸ ٴϱ  .
				dy	= 70;

				x -= 25;
				y -= 20;

				// 켱 ׷ .
				pMe->dig_backDraw = FALSE;
				setClip(pMe,x,y,dx,dy);	
				digDrawBg(pMe);

				pMe->dig_drillPoster	= pMe->dig_positionPoster;
				pMe->dig_positionPoster = 3;

				setClip(pMe,x,y,dx,dy);	
				digDrawPoster(pMe);

				//  ϸ̼ ׸  ְ
				// 帱 ϸ̼ ش.
				pMe->dig_drillFrame = -1;
				pMe->dig_drillAni = 6;

			}

			if( pMe->dig_drillAni >= 0 )
			{
				int x,y,dx,dy,img;
				Image drill;


				// 帱  
				if( pMe->dig_drillAni == 6 ) 					
					sfx_play(pMe,SND_ITEMDRILL,FALSE);

				// 帱 ִϸ̼   ..
				if( pMe->dig_drillAni == 0 ) {
					pMe->dig_drillUsed = FALSE;

					pMe->dig_positionPoster = pMe->dig_drillPoster;
					gotoDig(pMe,DSTATE_START);

					break;
				}

				drill.bitmap	= NULL;
				drill.src		= NULL;
				
				img = (pMe->dig_drillAni % 2 == 0) ? IDB_DIGDRILL1 : IDB_DIGDRILL2;
				loadImage(pMe,&drill,MOSO_RES_FILE,img);

				x	= pMe->dig_1p_x;
				y	= pMe->dig_1p_y;
				dx	= drill.info.cx;
				dy	= drill.info.cy;
				x	-= 15;

				// 帱 ĳ  ׷ش.
				pMe->dig_backDraw = FALSE;
				setClip(pMe,x,y,dx,dy);
				digDrawBg(pMe);
				setClip(pMe,x,y,dx,dy);
				digDrawPoster(pMe);
				setClip(pMe,x,y,dx,dy);
				drawImage2(pMe,&drill,x,y,GFX_LEFT);
				freeImage(pMe,&drill);


				//  ĳ.
				// 帱 ũ 5  ..
				pMe->dig_drillOneshot = pMe->dig_oneShot*5;
				pMe->dig_currDirt -= pMe->dig_drillOneshot;
			

				//  Ƣ frame  ÷ְ,  ٲش.
				pMe->dig_framePiece = 1;
				pMe->dig_whichPiece = !pMe->dig_whichPiece;
				

				//   ̴   ش.
				pMe->dig_frameMinus = 1;
				
				//   ʹٸ..
				if( pMe->dig_currDirt <= 0) {


					pMe->dig_drillUsed = FALSE;

					pMe->dig_currDirt = 0;
					gotoDig(pMe,DSTATE_RESULT);



				}

				digDrawPiece(pMe);
				digDrawMinus(pMe);
				digDrawDirt(pMe);
				
				pMe->dig_drillAni--;
			}

			break;		

		case DSTATE_RESULT:
			gotoDig(pMe,DSTATE_END);
			break;

		case DSTATE_END:
			{
				uint32 tickTime;
				int x,y,dx,dy;

				//  ׷ְ..
				digDrawBg(pMe);
				digDrawDirt(pMe);
				digDrawTime(pMe);
				digDrawDay(pMe);
				digDrawItem(pMe);

				tickTime = GET_UPTIMEMS();

				if( pMe->dig_end == FALSE )
				{
					pMe->dig_temp = tickTime;
					pMe->dig_end = TRUE;
					break;
				}

				if( pMe->gameMode == GAMEMODE_STORY )
				{
					//  ð   ش.
					if( tickTime - pMe->dig_temp < 1000 )
					{
						x = pMe->canvas_midx;
						y = pMe->canvas_midy;

						dx = pMe->imgGame[IMG_TXTFAILURE].info.cx;
						dy = pMe->imgGame[IMG_TXTFAILURE].info.cy;

						setClip(pMe,x-dx/2,y-dy/2,dx,dy);				
						pMe->dig_backDraw = FALSE;
						digDrawBg(pMe);

						if( pMe->dig_currTime > pMe->dig_wholeTime || pMe->dig_currDirt != 0 )
							drawImage(pMe,IMG_TXTFAILURE,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);						
						else
							drawImage(pMe,IMG_TXTSUCCESS,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);				
					}
					else
					{
						// ڰ   𸣴ϱ Ҹ ߰
						sfx_stop(pMe);

						// ߴٸ.
						if( pMe->dig_currDirt <= 0 ) {
							pMe->story_stage++;
							// Ϸ  Ѿ.
							SETSTATE(pMe,STATE_DAILY);
						}

						// ߴٸ ׸  ѼҸ ´.
						else
						{
							//  Ǽҵ ׸ڰ   Ķ ٱġ Ŵ.
							episodeInit(pMe,10);
							SETSTATE(pMe,STATE_EPISODE);
						}
					}

				}
				else if( pMe->gameMode == GAMEMODE_ENDLESS )
				{
					//  ð   ش.
					if( tickTime - pMe->dig_temp < 1000 )
					{
						x = pMe->canvas_midx;
						y = pMe->canvas_midy;

						dx = pMe->imgGame[IMG_TXTFAILURE].info.cx;
						dy = pMe->imgGame[IMG_TXTFAILURE].info.cy;

						setClip(pMe,x-dx/2,y-dy/2,dx,dy);				
						pMe->dig_backDraw = FALSE;
						digDrawBg(pMe);

						if( pMe->dig_currTime > pMe->dig_wholeTime || pMe->dig_currDirt != 0 )
							drawImage(pMe,IMG_TXTFAILURE,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);						
						else
							drawImage(pMe,IMG_TXTSUCCESS,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);				
					}
					else
					{
						// ߴٸ.
						if( pMe->dig_currDirt <= 0 )
						{
							// level ̰
							pMe->endless_diglv++;
							saveData(pMe);

							//     ٸ..
							if( pMe->endless_diglv == ENDLESS_LEVELEND )
							{
								pMe->endless_diglv = 0;
								saveData(pMe);

								// ŷ  Ȯâ .
								gotoMenu(pMe,MSTATE_PUTRANKINGCONFIRM);
								SETSTATE(pMe,STATE_MENU);
							}
							else
							{
								digReset(pMe);
								gotoDig(pMe,DSTATE_READY);
							}
						}
						// ߴٸ.
						else
						{
							// ŷ  Ȯâ .
							gotoMenu(pMe,MSTATE_PUTRANKINGCONFIRM);
							SETSTATE(pMe,STATE_MENU);
						}
					}
				}
			}
			break;
	}

	pMe->keyCurr = GKEY_NONE;
}

void digDraw(CMoso* pMe)
{
	switch(pMe->dig_state)
	{
		case DSTATE_READY:
			break;
		case DSTATE_START:
			break;
		case DSTATE_RESULT:
			break;
		case DSTATE_END:
			break;
	}
}

void digDrawItem(CMoso* pMe)
{
	if( pMe->gameMode == GAMEMODE_STORY )
	{
		if( pMe->canvas_height < 160 ) {	// LCDSIZE  120  .
			int item,img,x,y,dx,dy;
			
			x	= pMe->canvas_width - 1;
			y	= 1;
			dx	= 18;//pMe->imgGame[img].info.cx;
			dy	= 18;//pMe->imgGame[img].info.cy;

			pMe->dig_backDraw = FALSE;
			setClip(pMe,x-dx,y,dx,dy);
			digDrawBg(pMe);

			if( pMe->story_itemNum > 0 ) {
				item	= pMe->story_item[pMe->story_itemNum-1];
				img		= IMG_DIGICONITEM1 + item;

				drawImage(pMe,img,x,y,GFX_RIGHT|GFX_TOP);
			}
		}
		else {
			int item,img,x,y,dx,dy;

			x	= pMe->canvas_midx - 10;
			y	= pMe->dig_status_y - 3;
			dx	= 60;
			dy	= 20;

			setClip(pMe,x-dx/2,y-dy,dx,dy);
			fillRect(pMe,x-dx/2,y-dy,dx,dy,RGB(0,0,0));
			
			if(pMe->story_itemNum>0) {
				item	= pMe->story_item[pMe->story_itemNum-1];
				img		= IMG_DIGICONITEM1 + item;
				
				setColor(pMe,255,255,255);
				drawString(pMe,"Item: ",x+10,y-3,GFX_RIGHT|GFX_BOTTOM);
				drawImage(pMe,img,x+10,y,GFX_LEFT|GFX_BOTTOM);
			}
		}
	}
}


void digInit(CMoso* pMe)
{
	//  ʱȭ
	pMe->endless_digscore	= 0;

	// Ҷ Ʈ ġ .
	pMe->dig_1p_x			= 36;
	pMe->dig_1p_y			= pMe->canvas_height - STATUS_HEIGHT - pMe->imgGame[IMG_DIGCM].info.cy - pMe->imgGame[IMG_DIGDIG1].info.cy - 10;
	pMe->dig_poster_x		= 15;
	pMe->dig_poster_y		= pMe->canvas_height - STATUS_HEIGHT - pMe->imgGame[IMG_DIGCM].info.cy - pMe->imgGame[IMG_DIGPOSTER1].info.cy - 20;
	pMe->dig_guard_x		= 114;
	pMe->dig_guard_y		= pMe->canvas_height - STATUS_HEIGHT - 41; // 41 :  ׸   â   Ÿ̴.
	pMe->dig_cm_x			= 1;
	pMe->dig_cm_y			= pMe->canvas_height - STATUS_HEIGHT - pMe->imgGame[IMG_DIGCM].info.cy - 5;

	// set character's position
	if( pMe->canvas_height > 160 )
	{
		pMe->dig_1p_x			+= 25;
		pMe->dig_1p_y			-= 35;
		pMe->dig_poster_x		+= 25;
		pMe->dig_poster_y		-= 35;
		pMe->dig_guard_x		+= 25;
		pMe->dig_guard_y		-= 35;
		pMe->dig_cm_x			+= 25;
		pMe->dig_cm_y			-= 35;
	}


	// status bar ġ ..
	pMe->dig_status_x		= 0;
	pMe->dig_status_y		= pMe->canvas_height-STATUS_HEIGHT;

	// ȭ  
	if( pMe->canvas_height > 160 )
		pMe->dig_status_x += 20;

	pMe->dig_stone_x		= pMe->dig_status_x;
	pMe->dig_stone_y		= pMe->dig_status_y + 4;
	pMe->dig_remain_x		= pMe->dig_status_x + 50;
	pMe->dig_remain_y		= pMe->dig_status_y + 3;

	pMe->dig_percent_x		= pMe->dig_status_x + 51;
	pMe->dig_percent_y		= pMe->dig_status_y + 10;


	// ȭ  
	if( pMe->canvas_height > 160 )
		pMe->dig_status_x += 10;


	pMe->dig_time_x			= pMe->dig_status_x + 63;
	pMe->dig_time_y			= pMe->dig_status_y + 3;
	pMe->dig_clock_x		= pMe->dig_status_x + 70;
	pMe->dig_clock_y		= pMe->dig_status_y + 18;
	pMe->dig_point_x		= pMe->dig_status_x + 92;
	pMe->dig_point_y		= pMe->dig_status_y + 18;

	// ȭ  
	if( pMe->canvas_height > 160 )
		pMe->dig_status_x += 15;

	pMe->dig_calendar_x		= pMe->dig_status_x + 96;
	pMe->dig_calendar_y		= pMe->dig_status_y + 3;
	pMe->dig_day_x			= pMe->dig_status_x + 113;
	pMe->dig_day_y			= pMe->dig_status_y + 10;
	pMe->dig_lv_x			= pMe->dig_status_x + 118;
	pMe->dig_lv_y			= pMe->dig_status_y + 13;


	pMe->dig_timeUsed		= FALSE;
	pMe->dig_drillUsed		= FALSE;
	pMe->dig_bombUsed		= FALSE;


	// reset varibles
	digReset(pMe);

	gotoDig(pMe,DSTATE_READY);
}

void digReset(CMoso* pMe)
{	
	int lv,weight;
	int p,w;
	int i;

	// level value setting
	switch(pMe->gameMode)
	{
		case GAMEMODE_STORY:
			// ѹ ĳ  
			// Ŀ  ũ ٸ ũ ⸦ Ƽ Ŀ ش.
			//   µ ũ   ٴ  ֱ ..
			p = pMe->story_power;
			w = pMe->story_weapon;
			pMe->dig_oneShot = ( p < w ) ? p + (int)((p+w)*0.5) : p + w;

			lv = pMe->story_stage;

			pMe->dig_wholeTime		= pMe->endless_digFactor[lv][DIG_WHOLETIME];
			pMe->dig_guardGap		= pMe->endless_digFactor[lv][DIG_GUARDGAP];			
			pMe->dig_numGuard		= pMe->endless_digFactor[lv][DIG_GUARDNUM];	
			pMe->dig_destDirt		= pMe->endless_digFactor[lv][DIG_DESTDIRT];	

			// ĳ¾ ũ Ŀ ༭ Ѵ.
			// story      ϱ ̴.
			// ( 忡 ִ  ũ Ŀ 1   ̴.)
			pMe->dig_destDirt		= pMe->dig_destDirt * pMe->dig_oneShot;
			pMe->dig_currDirt		= pMe->dig_destDirt;

			break;

		case GAMEMODE_ENDLESS:
			// ѹ     
			pMe->dig_oneShot = 1;

			weight	= (int)(pMe->endless_diglv / 20);
			lv		= pMe->endless_diglv % 20;

			pMe->dig_wholeTime		= pMe->endless_digFactor[lv][DIG_WHOLETIME];
			pMe->dig_guardGap		= pMe->endless_digFactor[lv][DIG_GUARDGAP];			
			pMe->dig_numGuard		= pMe->endless_digFactor[lv][DIG_GUARDNUM];	
			pMe->dig_destDirt		= pMe->endless_digFactor[lv][DIG_DESTDIRT];	
			pMe->dig_currDirt		= pMe->dig_destDirt;
			pMe->dig_wholeTime		-= weight * 5000;	// 5ʾ ش.	
			break;
	}

#if CHEAT_ENDLESS_ONESECOND
	pMe->dig_wholeTime = CHEAT_ENDLESS_ONESECOND;
#endif


	pMe->dig_startTime		= 0;
	pMe->dig_currTime		= 0;

	// READY ۽ ð  ÷ ʱȭ 
	pMe->dig_ready			= FALSE;
	pMe->dig_end			= FALSE;

	pMe->dig_guardStart		= 0;	//  ̴ ð  ..


	//  ..
	for(i=0;i<pMe->dig_numGuard;i++)
	{
		pMe->dig_positionGuard[i]	= (DIG_DISTANCE-1) - i*2;	//
		pMe->dig_directionGuard[i]	= 1;
		pMe->dig_frequent[i]		= 0;
	}

	pMe->dig_ani1P			= 0;	// Ĵ ִϸ̼  .

	//  ѹ ÷ ǰ..
	pMe->dig_sleepsndPlayed	= FALSE;
	pMe->dig_hitsndPlay1	= FALSE;
	pMe->dig_hitsndPlay2	= FALSE;

	//  ġ, 
	pMe->dig_positionPoster	= 0;
	pMe->dig_directionPoster= 1;


	//  ̴   ִϸ̼ 0 .
	pMe->dig_frameMinus	= 0;


	//   ø   warning ߴ° ִϸ̼ 0 
	pMe->dig_frameWarning = 0;


	pMe->dig_caught = FALSE;


	pMe->dig_digGap = 0;
}


void gotoDig(CMoso* pMe,byte state)
{
	pMe->dig_state		= state;
	pMe->dig_backDraw	= FALSE;
}


// Ͷ ΰ̶ ׷  ƿ  ش.
// ٽ ׷ κи  ٷ ߴµ 
// ѹ ִ° ӵ  ̵  .
void digErase(CMoso* pMe)
{
	int x,y,dx,dy;

	x	= pMe->dig_poster_x;
	y	= pMe->dig_poster_y;
	dx	= (pMe->dig_1p_x + pMe->imgGame[IMG_DIGDIG1].info.cx) - x;
	dy	= (pMe->dig_1p_y + pMe->imgGame[IMG_DIGDIG1].info.cy) - y;

	setClip(pMe,x,y,dx,dy);
	pMe->dig_backDraw = FALSE;
	digDrawBg(pMe);
}


void digDrawBg(CMoso* pMe)
{
	if( pMe->dig_backDraw == FALSE )
	{
		pMe->dig_backDraw = TRUE;

		//    redraw Ǵ  ..
		fillRect(pMe,0,0,pMe->canvas_width,pMe->canvas_height,RGB(0,0,0));

		if( pMe->canvas_height < 160 )
			drawImage(pMe,IMG_DIGBG,0,pMe->canvas_height-STATUS_HEIGHT,GFX_LEFT|GFX_BOTTOM);
		else
			drawImage(pMe,IMG_DIGBG,25,pMe->canvas_height-STATUS_HEIGHT-35,GFX_LEFT|GFX_BOTTOM);


		digDrawStatus(pMe);

		// ȭ  
		if( pMe->canvas_height > 160 )
		{
			drawImage(pMe,IMG_DIGBGTOP1,0,0,GFX_LEFT);
			drawImage(pMe,IMG_DIGBGTOP2,pMe->canvas_width,0,GFX_RIGHT);
			drawImage(pMe,IMG_DIGBGBOTTOM1,0,pMe->canvas_height- STATUS_HEIGHT,GFX_LEFT|GFX_BOTTOM);
			drawImage(pMe,IMG_DIGBGBOTTOM2,pMe->canvas_width,pMe->canvas_height- STATUS_HEIGHT,GFX_RIGHT|GFX_BOTTOM);
		}
	}
}


void digDrawStatus(CMoso* pMe)
{
	int i;
	int dx,dy;
	int nx;

	int x,y;

	//  ġ
	x = 0;
	y = pMe->canvas_height - STATUS_HEIGHT;

	dx = pMe->imgGame[IMG_STATUSBG].info.cx;
	dy = pMe->imgGame[IMG_STATUSBG].info.cy;

	nx = pMe->canvas_width / dx;

	for(i=0;i<=nx;++i)
		drawImage(pMe,IMG_STATUSBG,x+i*dx,y,GFX_LEFTTOP);


	// draw stone
	x = pMe->dig_stone_x; y = pMe->dig_stone_y;
	drawImage(pMe,IMG_DIGSTONE,x,y,GFX_LEFTTOP);


	// draw percent img.
	x = pMe->dig_percent_x; y = pMe->dig_percent_y;
	drawImage(pMe,IMG_PERCENT,x,y,GFX_LEFTTOP);


	// draw time
	x = pMe->dig_time_x; y = pMe->dig_time_y;
	drawImage(pMe,IMG_TIME,x,y,GFX_LEFTTOP);


	// draw time guage
	x = pMe->dig_clock_x; y = pMe->dig_clock_y-1;
	dx = pMe->dig_point_x - pMe->dig_clock_x;
	dy = 2;
	fillRect(pMe,x,y,dx,dy,RGB(255,255,255));


	// draw clock
	x = pMe->dig_clock_x; y = pMe->dig_clock_y;
	drawImage(pMe,IMG_CLOCK,x,y,GFX_CENTER);


	switch(pMe->gameMode)
	{
		case GAMEMODE_STORY:
			x = pMe->dig_calendar_x; y = pMe->dig_calendar_y;
			drawImage(pMe,IMG_CALENDAR,x,y,GFX_LEFTTOP);
			break;

		case GAMEMODE_ENDLESS:
			x = pMe->dig_calendar_x; y = pMe->dig_calendar_y;
			drawImage(pMe,IMG_TXTLV,x,y,GFX_LEFTTOP);
			break;
	}
}


void digDrawGuard(CMoso* pMe)
{
	int i;
	int ox,oy;
	int x,y,dx,dy;

	ox = pMe->dig_cm_x; 
	oy = pMe->dig_cm_y;
	dx = pMe->imgGame[IMG_DIGCM].info.cx;
	dy = pMe->imgGame[IMG_DIGCM].info.cy;


	setClip(pMe,ox,oy,dx,dy);


	// redraw bg 
	pMe->dig_backDraw = FALSE;
	digDrawBg(pMe);

	// draw ruler & 1p icon.
	x = ox; y = oy;
	drawImage(pMe,IMG_DIGCM,x,y,GFX_LEFT);
	drawImage(pMe,IMG_DIGICON1P,x+4,y,GFX_LEFT);


	// draw guard icon
	for(i=0;i<pMe->dig_numGuard;i++)
	{
		x = ox + pMe->dig_positionGuard[i]*(dx/DIG_DISTANCE);
		if( pMe->dig_bombUsed == TRUE ) // ź   ̹.
			drawImage(pMe,IMG_DIGICONBOMB1,x,y,GFX_LEFT);
		else
			drawImage(pMe,IMG_DIGICONGUARD1+i,x,y,GFX_LEFT);

	}	

	// position of window on bg
	x = pMe->dig_guard_x;
	y = pMe->dig_guard_y;
	dx = 18;	//  ̹ â ̴.
	dy = 31;


	// redraw bg
	setClip(pMe,x-dx,y-dy,dx,dy);
	pMe->dig_backDraw = FALSE;
	digDrawBg(pMe);

	// if guard comes, draw guard.
	setClip(pMe,x-dx,y-dy,dx,dy);
	for(i=0;i<pMe->dig_numGuard;i++) 
	{
		if( pMe->dig_positionGuard[i] <= DIG_CAUGHTDIS ) 
		{
			if( pMe->dig_bombUsed == TRUE ) // ź   ̹.
				drawImage(pMe,IMG_DIGICONBOMB2,x+3,y+1,GFX_RIGHT|GFX_BOTTOM);
			else
				drawImage(pMe,IMG_DIGGUARD1+i,x+5,y+1,GFX_RIGHT|GFX_BOTTOM);
		}
	}

	//  ð ٵƴٸ false  ְ. 
	if( pMe->dig_bombUsed == TRUE ) 
	{
		if( GET_UPTIMEMS() - pMe->dig_bombTime > 3000 ) {
			pMe->dig_bombUsed = FALSE;

		}
	}
}

void digDrawPoster(CMoso* pMe)
{
	int x,y,dx,dy;
	int img = IMG_DIGPOSTER1 + pMe->dig_positionPoster;

	x = pMe->dig_poster_x;
	y = pMe->dig_poster_y;
	dx = pMe->imgGame[IMG_DIGPOSTER1].info.cx;
	dy = pMe->imgGame[IMG_DIGPOSTER1].info.cy;

	//  ׷ֱ.
	setClip(pMe,x,y,dx,dy);
	drawImage(pMe,img,x,y,GFX_LEFT);
}

void digDrawDirt(CMoso* pMe)
{
	int x,y,percent;
	int dx,dy;

	if( pMe->dig_destDirt == 0 ) return;
	percent = (pMe->dig_currDirt << 8) / pMe->dig_destDirt; 
	percent = (percent * 100) >> 8;

	if( percent == 0 )
		percent = 0;
	if( percent == 100 )
		percent = 99;
	if( percent == 0 && pMe->dig_currDirt != 0 )
		percent = 1;

	dx = pMe->imgGame[IMG_NUMBER1].info.cx/10;
	dy = pMe->imgGame[IMG_NUMBER1].info.cy;



	x = pMe->dig_remain_x; y = pMe->dig_remain_y;	
	setClip(pMe,x-dx*2,y,dx*2,dy);	//  2  µȴٰ .
	pMe->dig_backDraw = FALSE;
	digDrawBg(pMe);	
	drawGNumber(pMe,percent,x,y,GNUM_TYPE1);
}

void digDrawTime(CMoso* pMe)
{
	int x,y,dx,dy;
	int percent;
	int timeguage_width = pMe->dig_point_x - pMe->dig_clock_x;


	//     ȭ.
	if( pMe->dig_timeUsed )
	{
		uint32 tickTime;
		tickTime = GET_UPTIMEMS();

		// 10  ð .
		if( tickTime - pMe->dig_timeTime < 5000 )
		{
			int x,y,dx,dy;

			x = pMe->dig_time_x;
			y = pMe->dig_status_y;
			dx = pMe->imgGame[IMG_DIGTIMELOCK].info.cx;
			dy = pMe->imgGame[IMG_DIGTIMELOCK].info.cy;

			setClip(pMe,x,y,dx,dy);
			drawImage(pMe,IMG_DIGTIMELOCK,x,y,GFX_LEFT);
		}
		// 10  󺹱
		else
		{
			// ð  ְ
			pMe->dig_startTime += tickTime - pMe->dig_timeTime;

			// get current time
			pMe->dig_currTime = tickTime - pMe->dig_startTime;



			pMe->dig_timeUsed = FALSE;

			if( pMe->dig_wholeTime == 0 ) return;
			percent = (pMe->dig_currTime << 8) / pMe->dig_wholeTime; 
			percent = (percent * timeguage_width) >> 8;
			if( percent > timeguage_width ) 
				percent = timeguage_width;

			// redraw bg
			x = pMe->dig_time_x; y = pMe->dig_status_y;	
			dx = pMe->imgGame[IMG_DIGTIMELOCK].info.cx;
			dy = pMe->imgGame[IMG_DIGTIMELOCK].info.cy;

			pMe->dig_backDraw = FALSE;
			setClip(pMe,x,y,dx,dy);			
			digDrawBg(pMe);	

			// draw point
			x = pMe->dig_point_x - percent; y = pMe->dig_clock_y;
			drawImage(pMe,IMG_POINT,x,y,GFX_CENTER);

			// ð ٽ ׷ش. ׷ִ  ׳ ~~~ .
//			setClip(pMe,pMe->dig_time_x,pMe->dig_time_y,30,20);
//			pMe->dig_backDraw = FALSE;
//			digDrawBg(pMe);			
//			digDrawTime(pMe);
		}
	}

	else {
		if( pMe->dig_wholeTime == 0 ) return;
		percent = (pMe->dig_currTime << 8) / pMe->dig_wholeTime; 
		percent = (percent * timeguage_width) >> 8;

		// redraw bg
		x = pMe->dig_clock_x-5; y = pMe->dig_clock_y-5;	
		dx = 33;
		dy = 10;
		setClip(pMe,x,y,dx,dy);
		pMe->dig_backDraw = FALSE;
		digDrawBg(pMe);	

		// draw point
		x = pMe->dig_point_x - percent; y = pMe->dig_clock_y;
		drawImage(pMe,IMG_POINT,x,y,GFX_CENTER);
	}
}

void digDrawDay(CMoso* pMe)
{
	int x,y,dx,dy;
	int num;


	if( pMe->gameMode == GAMEMODE_STORY )
	{
		x = pMe->dig_day_x;
		y = pMe->dig_day_y;
		num = pMe->story_day+1;
	}
	else// if( pMe->gameMode == GAMEMODE_ENDLESS )
	{
		x = pMe->dig_lv_x;
		y = pMe->dig_lv_y;
		num = pMe->endless_diglv+1;
	}
	dx = pMe->imgGame[IMG_NUMBER2].info.cx/10;
	dy = pMe->imgGame[IMG_NUMBER2].info.cy;


	// redraw bg
	setClip(pMe,x-dx*2,y,dx*2,dy);
	pMe->dig_backDraw = FALSE;
	digDrawBg(pMe);


	// draw number
	drawGNumber(pMe,num,x,y,GNUM_TYPE2);
}



void digDraw1P(CMoso* pMe)
{
	int x,y,dx,dy;
	int img;

	int x1,y1,dx1,dy1;
	int img1;

	x = pMe->dig_1p_x;
	y = pMe->dig_1p_y;

	// Ͱ  پ  .. ڰ ִô Ѵ.
	if( pMe->dig_positionPoster == 0 )
	{
		img = IMG_DIGZZZ;

		dx = pMe->imgGame[IMG_DIGDIG1].info.cx;
		dy = pMe->imgGame[IMG_DIGDIG1].info.cy;

		// 1p ׸
		setClip(pMe,x,y,dx,dy);
		drawImage(pMe,img,x,y,GFX_LEFT);
	}

	// ƴ  Ĵ ִϸ̼.
	else
	{
		//   ..
		if( pMe->dig_ani1P == 0 )
		{
			img = IMG_DIGDIG1;
			dx = pMe->imgGame[IMG_DIGDIG1].info.cx;
			dy = pMe->imgGame[IMG_DIGDIG1].info.cy;

			// ũ   ̹ ٸ ϰ ġ ޶.
			// 伥 ȼ   Ѵٰ    ̤ .
			if( pMe->story_weapon <= 2 ) {
				img1 = IMG_DIGWEAPON1_1;
				x1	= x - 9;
				y1	= y + 22;
				dx1 = pMe->imgGame[IMG_DIGWEAPON1_1].info.cx;
				dy1 = pMe->imgGame[IMG_DIGWEAPON1_1].info.cy;
			}
			else if( pMe->story_weapon <= 4 ) {
				img1 = IMG_DIGWEAPON2_1;
				x1	= x - 14;
				y1	= y + 25;
				dx1 = pMe->imgGame[IMG_DIGWEAPON2_1].info.cx;
				dy1 = pMe->imgGame[IMG_DIGWEAPON2_1].info.cy;
			}
			else if( pMe->story_weapon <= 6 ) {
				img1 = IMG_DIGWEAPON3_1;
				x1	= x - 19;
				y1	= y + 17;
				dx1 = pMe->imgGame[IMG_DIGWEAPON3_1].info.cx;
				dy1 = pMe->imgGame[IMG_DIGWEAPON3_1].info.cy;
			}
			else if( pMe->story_weapon <= 8 ) {
				img1 = IMG_DIGWEAPON4_1;
				x1	= x - 21;
				y1	= y + 24;
				dx1 = pMe->imgGame[IMG_DIGWEAPON4_1].info.cx;
				dy1 = pMe->imgGame[IMG_DIGWEAPON4_1].info.cy;
			}
			else /*if( pMe->story_weapon <= 10 )*/ {
				img1 = IMG_DIGWEAPON5_1;
				x1	= x - 21;
				y1	= y + 14;
				dx1 = pMe->imgGame[IMG_DIGWEAPON5_1].info.cx;
				dy1 = pMe->imgGame[IMG_DIGWEAPON5_1].info.cy;
			}
		}

		//   ..
		else //if( pMe->dig_ani1P == 1 )
		{
			img = IMG_DIGDIG2;
			dx = pMe->imgGame[IMG_DIGDIG1].info.cx;
			dy = pMe->imgGame[IMG_DIGDIG1].info.cy;

			// ũ   ̹ ٸ ϰ ġ ޶.
			// 伥 ȼ   Ѵٰ    ̤ .
			if( pMe->story_weapon <= 2 ) {
				img1 = IMG_DIGWEAPON1_2;
				x1	= x - 2;
				y1	= y + 5;
				dx1 = pMe->imgGame[IMG_DIGWEAPON1_2].info.cx;
				dy1 = pMe->imgGame[IMG_DIGWEAPON1_2].info.cy;
			}
			else if( pMe->story_weapon <= 4 ) {
				img1 = IMG_DIGWEAPON2_2;
				x1	= x - 0;
				y1	= y + 2;
				dx1 = pMe->imgGame[IMG_DIGWEAPON2_2].info.cx;
				dy1 = pMe->imgGame[IMG_DIGWEAPON2_2].info.cy;
			}
			else if( pMe->story_weapon <= 6 ) {
				img1 = IMG_DIGWEAPON3_2;
				x1	= x - 0;
				y1	= y - 3;
				dx1 = pMe->imgGame[IMG_DIGWEAPON3_2].info.cx;
				dy1 = pMe->imgGame[IMG_DIGWEAPON3_2].info.cy;
			}
			else if( pMe->story_weapon <= 8 ) {
				img1 = IMG_DIGWEAPON4_2;
				x1	= x - 3;
				y1	= y - 10;
				dx1 = pMe->imgGame[IMG_DIGWEAPON4_2].info.cx;
				dy1 = pMe->imgGame[IMG_DIGWEAPON4_2].info.cy;
			}
			else /*if( pMe->story_weapon <= 10 )*/ {
				img1 = IMG_DIGWEAPON5_2;
				x1	= x - 4;
				y1	= y - 11;
				dx1 = pMe->imgGame[IMG_DIGWEAPON5_2].info.cx;
				dy1 = pMe->imgGame[IMG_DIGWEAPON5_2].info.cy;
			}
		}

		// ũ ׸
		setClip(pMe,x1,y1,dx1,dy1);
		drawImage(pMe,img1,x1,y1,GFX_LEFT);

		// 1p ׸
		setClip(pMe,x,y,dx,dy);
		drawImage(pMe,img,x,y,GFX_LEFT);
	}
}


//  Ƣ° ׸.
void digDrawPiece(CMoso* pMe)
{
	if( pMe->dig_framePiece != 0 ) {
		int img,x,y,dx,dy;

		img = (pMe->dig_whichPiece == 0) ? IMG_DIGPIECE1 : IMG_DIGPIECE2;
		x	= pMe->dig_1p_x;
		y	= pMe->dig_1p_y;
		x	-= 10;
		y	+= 3;
		dx	= pMe->imgGame[img].info.cx;
		dy	= pMe->imgGame[img].info.cy;
		setClip(pMe,x,y,dx,dy);
		drawImage(pMe,img,x,y,GFX_LEFT);

		pMe->dig_framePiece--;
	}
}

//   ̴  ش.
void digDrawMinus(CMoso* pMe)
{
	if( pMe->dig_frameMinus != 0 ) {
		int x,y,dx,dy,hyphenWidth,numWidth,wholeWidth;
		int figure; // ڸ.
		int value = pMe->dig_oneShot * 3;

		SPRINTF(pMe->tempStr,"%d",value);
		figure = STRLEN(pMe->tempStr);

		//  ġ 
		x	= pMe->dig_1p_x+10;
		y	= pMe->dig_1p_y;
		dx	= pMe->imgGame[IMG_NUMBER3].info.cx/10;
		dy	= pMe->imgGame[IMG_NUMBER3].info.cy;

		numWidth	= pMe->imgGame[IMG_HYPHEN].info.cx;
		hyphenWidth = dx*figure;
		wholeWidth	= numWidth+hyphenWidth;

		setClip(pMe,x-wholeWidth,y,wholeWidth,dy);
		// draw hyphen
		drawImage(pMe,IMG_HYPHEN,x-wholeWidth,y+2,GFX_LEFT);
		// draw number
		drawGNumber(pMe,value,x,y,GNUM_TYPE3);

		pMe->dig_frameMinus--;
	}
}

void digDrawWarning(CMoso* pMe)
{
	if( pMe->dig_frameWarning != 0 ) {
		int x,y,dx,dy;

		//  ġ 
		x	= pMe->dig_1p_x-5;
		y	= pMe->dig_1p_y-5;
		dx	= pMe->imgGame[IMG_DIGWARNING].info.cx;
		dy	= pMe->imgGame[IMG_DIGWARNING].info.cy;

		setClip(pMe,x,y,dx,dy);
		drawImage(pMe,IMG_DIGWARNING,x,y,GFX_LEFT);

		pMe->dig_frameWarning--;
	}
}