// Happy Mobile Sound Player
// Brew Sound Play Library
//		
//		Version : 1.0
//		date	: 2005/09/01
//		author	: Kwak Byeong Chan(kbckbc@postech.ac.kr)
//
// * if you found some bugs, plz let me know. :)
//
// 1. Description.
//	Playing mmf files on brew.
//
// 2. How to use.
//		a. call sfx_init() in InitAppData() function
//
//			void Sndtest_InitAppData(CMoso* pMe) 
//			{
//				..
//				sfx_init(pMe);
//				..
//			}
//
//		b. then just call sfx_play(). if you wanna repeat, set the flag.
//
//		c. call sfx_suspend() when receiving call.
//
//			boolean Sndtest_HandleEvent(IApplet* pi, AEEEvent eCode, uint16 wParam, uint32 dwParam)
//			{
//				..
//				case EVT_APP_SUSPEND:
//					sfx_suspend(pMe);
//					return TRUE;
//				..
//			}
//
//		d. call sfx_resume() when hang up the call.
//
//			boolean Sndtest_HandleEvent(IApplet* pi, AEEEvent eCode, uint16 wParam, uint32 dwParam)
//			{
//				..
//				case EVT_APP_RESUME:
//					sfx_resume(pMe);
//					return TRUE;
//				..
//			}
//
//		e. call sfx_free() in FreeAppData() funtion
//
//			void Sndtest_FreeAppData(CMoso* pMe) 
//			{
//				sfx_free(pMe);
//			}
//
// 2. Test phones.
//	SPH-E1100,SPH-V4300,SPH-E1800,SPH-E3200
//
// 3. Some bugs. 
//	On some handsets, repeating sound doesn't work correctly. 
//	Cause they don't send AEE_SOUNDPLAYER_DONE or AEE_SOUNDPLAYER_ABORTED to callback function.
//	the only way that I know is check the time of each sound file and then play it again by checking time.
//
// 4. History
//	2005. 09. 07
//		kbckbc made First version.

#ifndef _HAPPYSND_H_
#define _HAPPYSND_H_


// MMF file header information
#define		RES_HEADER_SIZE			12
#define		MMF_HEADER_SIZE			8
#define		SIZE_INFO_OFFSET		4
#define		GET_DWORD_FROM_PTR(p)	((byte)(*(p))<<24 | (byte)(*(p+1))<<16 |(byte)(*(p+2))<<8 | (byte)(*(p+3)))


void sfx_init(CMoso* pMe);
void sfx_free(CMoso* pMe);

void sfx_play(CMoso* pMe, int num, boolean repeat);
void sfx_stop(CMoso* pMe);

void sfx_suspend(CMoso* pMe);
void sfx_resume(CMoso* pMe);

void sfx_vib(CMoso* pMe,int sec);

// do not call these function directly.
void sfx_pending(CMoso* pMe);
void sfx_callback(void* pUser, AEESoundPlayerCmd eCBType, AEESoundPlayerStatus eStatus, uint32 dwParam);

#endif	// _HAPPYSND_H_
