#include "moso.h"
#include "save.h"
#include "happysnd.h"

#include "menu.h"
#include "trash.h"
#include "find.h"
#include "dig.h"


// program starts here.
int AEEClsCreateInstance(AEECLSID ClsId, IShell* pIShell, IModule* po, void** ppObj)
{
	*ppObj = NULL;

	if( ClsId == AEECLSID_MOKJANG ) 
	{
		if( AEEApplet_New(sizeof(CMoso),
						  ClsId,
						  pIShell,
						  po,
						  (IApplet**)ppObj,
						  (AEEHANDLER)moso_HandleEvent,
						  (PFNFREEAPPDATA)moso_FreeAppData) )
		{
			moso_InitAppData((IApplet*)*ppObj);
			return(AEE_SUCCESS);
		}
	}

	return (EFAILED);
}

void moso_InitAppData(IApplet* pi)
{
	CMoso *pMe = (CMoso*)pi;

	//GameSound_InitAppData(pMe);
	sfx_init(pMe);
	moso_init(pMe);
	
	// ISound  ϱ..
	ISHELL_CreateInstance(pMe->a.m_pIShell, AEECLSID_SOUND, (void **)&pMe->m_pISound);

	// set global game state;
#if CHEAT_DIRECTLY_MENULOAD
	SETSTATE(pMe,STATE_MENULOAD);	
#else
	SETSTATE(pMe,STATE_NAMO);	
#endif
}

void moso_FreeAppData(IApplet* pi)
{
	int i;
	CMoso *pMe = (CMoso*)pi;

	for(i=0;i<pMe->imgNum;++i)
		freeImage(pMe,&pMe->imgGame[i]);


	freeImage(pMe,&pMe->imgTemp);

	freeImage(pMe,&pMe->episode_leftImage);
	freeImage(pMe,&pMe->episode_rightImage);

	freeImage(pMe,&pMe->imgLoading);
	freeImage(pMe,&pMe->imgLoadbar);
	freeImage(pMe,&pMe->imgLoadbarBg);
	freeImage(pMe,&pMe->imgLoadBg);


	freeImage(pMe,&pMe->menu_imgKeyInfo);

	//GameSound_FreeAppData(pMe);	
	sfx_free(pMe);

	// ISound ϱ..
	if( pMe->m_pISound ) ISOUND_Release(pMe->m_pISound);
}

boolean moso_HandleEvent(IApplet* pi, AEEEvent eCode, uint16 wParam, uint32 dwParam)
{
	CMoso *pMe = (CMoso*)pi;

	switch(eCode) 
	{
		case EVT_APP_START:
			run(pMe);
			return TRUE;

		case EVT_APP_STOP:
			return TRUE;

		case EVT_KEY:	      
			keyEvent(pMe,wParam);
			//pMe->updateDisplay = TRUE; // enable redraw.
			return(TRUE);


		case EVT_KEY_PRESS:
			return(TRUE);


		case EVT_KEY_RELEASE:
			pMe->keyCurr = GKEY_NONE;
			return TRUE;


		case EVT_APP_SUSPEND:
			sfx_suspend(pMe);

			// Ÿ̸ 
			ISHELL_CancelTimer( pMe->a.m_pIShell, NULL,  pi );
			return TRUE;

		case EVT_APP_RESUME:
			sfx_resume(pMe);

			//  ٽ ׷ ϱ⶧  
			pMe->load_backDraw		= FALSE;
			pMe->menu_backDraw		= FALSE;
			pMe->menu_panDraw		= FALSE;
			pMe->trash_redraw		= TRUE;
			pMe->trash_backDraw		= FALSE;
			pMe->find_backDraw		= FALSE;
			pMe->dig_backDraw		= FALSE;
			pMe->anistory_backDraw	= FALSE;
			pMe->text_Draw			= FALSE;
			pMe->episode_backDraw	= FALSE;
			pMe->tutorial_backDraw	= FALSE;
			pMe->select_backDraw	= FALSE;
			pMe->daily_backDraw		= FALSE;


			//
			if( pMe->gState == STATE_TRASH )
			{
				//  ޴ ȣ  ִٸ  ð ٽ ش.
				if( pMe->trash_startTime != 0 )
				{
					pMe->trash_startTime = GET_UPTIMEMS();
					pMe->trash_startTime -= pMe->trash_currTime;
				}

				// READY   ޴   ٽ READY  ưش.
				if(pMe->trash_state == TSTATE_READY)
				{
					trashInit(pMe);
				}
				else
				{
					gotoTrash(pMe,pMe->trash_state);
				}
			}
			else if( pMe->gState == STATE_FIND )
			{
				//  ޴ ȣ  ִٸ  ð ٽ ش.
				if( pMe->find_startTime != 0 )
				{
					pMe->find_startTime = GET_UPTIMEMS();
					pMe->find_startTime -= pMe->find_currTime;
				}


				// ˿ END  ƴҶ  READY  .
				if( pMe->find_state != FSTATE_END ) {
					findReset(pMe);								
					gotoFind(pMe,FSTATE_READY);
				}
				else {
					gotoFind(pMe,FSTATE_END);
				}
			}
			else if( pMe->gState == STATE_DIG )
			{
				//  ޴ ȣ  ִٸ  ð ٽ ش.
				if( pMe->dig_startTime != 0 )
				{
					pMe->dig_startTime = GET_UPTIMEMS();
					pMe->dig_startTime -= pMe->dig_currTime;
				}

				// READY   ޴   ٽ READY  ưش.
				if(pMe->dig_state == DSTATE_READY)
				{
					digInit(pMe);
				}
				else
				{
					gotoDig(pMe,pMe->dig_state);
				}
			}


			run(pMe);
			return TRUE;

		default:
			break;	
	}

	return FALSE;	
}

// Ű ̺Ʈ  ׳ Ű  س´.
void keyEvent(CMoso *pMe,uint16 key)
{
	pMe->key = key;
}

// Ű ̺Ʈ ޾Ƴ  мϴ Լ.
void updateKey(CMoso* pMe)
{
	if( pMe->key != GKEY_NONE )
	{
		switch( pMe->gState )
		{
			case STATE_NAMO:
			case STATE_DAUM:
			case STATE_INTRO:
			case STATE_MENULOAD:
			case STATE_MENU:
			case STATE_ANISTORY:
			case STATE_STARTDAY:
			case STATE_TUTORIAL:
			case STATE_DAILY:
			case STATE_SELECT:
				// ޴ ϸ̼ ̸ Ű Է  ޴´.
				if( pMe->menu_Ani != 0 ) 
					break;

				switch (pMe->key)
				{
					case AVK_4:
					case AVK_LEFT:
						pMe->keyCurr &= ~GKEY_RIGHT;
						pMe->keyCurr |= GKEY_LEFT;
						break;

					case AVK_6:
					case AVK_RIGHT:						
						pMe->keyCurr &= ~GKEY_LEFT;
						pMe->keyCurr |= GKEY_RIGHT;
						break;	

					case AVK_2:
					case AVK_UP:						
						pMe->keyCurr &= ~GKEY_DOWN;
						pMe->keyCurr |= GKEY_UP;
						break;	

					case AVK_8:
					case AVK_DOWN:						
						pMe->keyCurr &= ~GKEY_UP;
						pMe->keyCurr |= GKEY_DOWN;
						break;	

					case AVK_5:
					case AVK_SELECT:						
						//   Ҹ  
						if( pMe->gState == STATE_MENU && 
							pMe->menu_State != MSTATE_RANKINGTRANSFER &&
							pMe->menu_State != MSTATE_SETTING )
							sfx_play(pMe,SND_MENUSELECT,FALSE);

						pMe->keyCurr |= GKEY_SOFT3;
						break;	

					case AVK_MENU:	
					case AVK_CLR:
						pMe->keyCurr |= GKEY_SOFT1;
						break;

					case AVK_SOFT1:		
						//   Ҹ  
						if( pMe->gState == STATE_MENU && 
							pMe->menu_State != MSTATE_RANKINGTRANSFER &&
							pMe->menu_State != MSTATE_SETTING )
							sfx_play(pMe,SND_MENUSELECT,FALSE);
						
						pMe->keyCurr |= GKEY_SOFT2;
						break;

					case AVK_STAR:
						pMe->keyCurr |= GKEY_STAR;
						break;

					case AVK_POUND:
						pMe->keyCurr |= GKEY_POUND;
						break;
				}
				break;

			case STATE_EPISODE:
				switch (pMe->key)
				{
					case AVK_SOFT1:
					case AVK_5:
					case AVK_SELECT:						
						pMe->keyCurr |= GKEY_SOFT3;
						break;	
				}
				break;

			case STATE_TRASH:
			case STATE_FIND:
			case STATE_DIG:
				switch (pMe->key)
				{
					case AVK_0:
						pMe->keyCurr |= GKEY_0;
						break;

					case AVK_1:
						pMe->keyCurr |= GKEY_1;
						break;

					case AVK_2:
						pMe->keyCurr |= GKEY_2;
						break;

					case AVK_3:
						pMe->keyCurr |= GKEY_3;
						break;

					case AVK_4:
						pMe->keyCurr |= GKEY_4;
						break;

					case AVK_5:
						pMe->keyCurr |= GKEY_5;
						break;

					case AVK_6:
						pMe->keyCurr |= GKEY_6;
						break;

					case AVK_7:
						pMe->keyCurr |= GKEY_7;
						break;

					case AVK_8:
						pMe->keyCurr |= GKEY_8;
						break;

					case AVK_9:
						pMe->keyCurr |= GKEY_9;
						break;

					case AVK_LEFT:
						pMe->keyCurr &= ~GKEY_RIGHT;
						pMe->keyCurr |= GKEY_LEFT;
						break;

					case AVK_RIGHT:						
						pMe->keyCurr &= ~GKEY_LEFT;
						pMe->keyCurr |= GKEY_RIGHT;
						break;

					case AVK_UP:						
						pMe->keyCurr &= ~GKEY_DOWN;
						pMe->keyCurr |= GKEY_UP;
						break;	

					case AVK_DOWN:						
						pMe->keyCurr &= ~GKEY_UP;
						pMe->keyCurr |= GKEY_DOWN;
						break;	

					case AVK_SELECT:						
						pMe->keyCurr |= GKEY_SOFT3;
						break;	

					case AVK_MENU:	
					case AVK_CLR:
						pMe->keyCurr |= GKEY_SOFT1;
						break;

					case AVK_SOFT1:						
						pMe->keyCurr |= GKEY_SOFT2;
						break;

					case AVK_STAR:
						pMe->keyCurr |= GKEY_STAR;
						break;

					case AVK_POUND:
						pMe->keyCurr |= GKEY_POUND;
						break;
				}
				break;
		}

		// key event handling when drawText.
		// prevent key event showing text animation
		if( pMe->text_init == TRUE && pMe->anitext_init == FALSE )
		{
			// Move page.
			if ((pMe->keyCurr & (GKEY_RIGHT | GKEY_6)) != 0 ||
				pMe->keyCurr & GKEY_SELECT
				)
			{
				// if page will change, redraw text.
				pMe->menu_panDraw	= FALSE;
				pMe->text_Draw		= FALSE;


				pMe->tutorial_backDraw	= FALSE;
//				pMe->episode_backDraw	= FALSE;

				++pMe->text_currpage;
				//if(pMe->text_currpage == pMe->text_wholepage)
				//	--pMe->text_currpage;

			}
			else if ((pMe->keyCurr & (GKEY_LEFT | GKEY_4)) != 0) 			
			{
				// if page will change, redraw text.
				pMe->menu_panDraw	= FALSE;
				pMe->text_Draw		= FALSE;


				pMe->tutorial_backDraw	= FALSE;
//				pMe->episode_backDraw	= FALSE;


				--pMe->text_currpage;
				//if(pMe->text_currpage == -1)
				//	pMe->text_currpage = 0;
			}
		}

		pMe->key = GKEY_NONE;
	}
}

// thread funtion, call run funtion constantly.
void run(CMoso *pMe)
{	
	mosoTick(pMe);
	mosoDraw(pMe);


	if (pMe->waitTime != 0) 
	{
		ISHELL_SetTimer(pMe->a.m_pIShell, pMe->waitTime, (PFNNOTIFY)(run), pMe);
		pMe->waitTime = 0;
	} 
	else 
	{
		ISHELL_SetTimer(pMe->a.m_pIShell, 1, (PFNNOTIFY)(run), pMe);
	}
}

void mosoTick(CMoso* pMe)
{
	updateKey(pMe);

	switch(pMe->gState)
	{
		case STATE_NAMO:
			namoTick(pMe);
			break;

		case STATE_DAUM:
			daumTick(pMe);
			break;

		case STATE_INTRO:
			introTick(pMe);
			break;

		case STATE_MENULOAD:
			menuloadTick(pMe);
			break;

		case STATE_MENU:
			menuTick(pMe);
			break;

		case STATE_TRASH:
			trashTick(pMe);
			break;

		case STATE_FIND:
			findTick(pMe);
			break;

		case STATE_DIG:
			digTick(pMe);
			break;

		case STATE_ANISTORY:
			anistoryTick(pMe);
			break;

		case STATE_EPISODE:
			episodeTick(pMe);
			break;

		case STATE_MORNINGEPISODE:
			morningepisodeTick(pMe);
			break;

		case STATE_NIGHTEPISODE:
			nightepisodeTick(pMe);
			break;

		case STATE_STARTDAY:
			startdayTick(pMe);
			break;

		case STATE_SELECT:
			selectTick(pMe);
			break;

		case STATE_DAILY:
			dailyTick(pMe);
			break;

		case STATE_TUTORIAL:
			tutorialTick(pMe);
			break;
	}
}

void mosoDraw(CMoso* pMe)
{
	switch(pMe->gState)
	{
		case STATE_NAMO:
			namoDraw(pMe);
			break;

		case STATE_DAUM:
			daumDraw(pMe);
			break;

		case STATE_INTRO:
			introDraw(pMe);
			break;

		case STATE_MENULOAD:
			menuloadDraw(pMe);
			break;

		case STATE_MENU:
			menuDraw(pMe);
			break;

		case STATE_TRASH:
			trashDraw(pMe);
			break;

		case STATE_FIND:
			findDraw(pMe);
			break;

		case STATE_DIG:
			digDraw(pMe);
			break;

		case STATE_ANISTORY:
			anistoryDraw(pMe);
			break;

		case STATE_EPISODE:
			episodeDraw(pMe);
			break;

		case STATE_MORNINGEPISODE:
			morningepisodeDraw(pMe);
			break;

		case STATE_NIGHTEPISODE:
			nightepisodeDraw(pMe);
			break;

		case STATE_STARTDAY:
			startdayDraw(pMe);
			break;

		case STATE_SELECT:
			selectDraw(pMe);
			break;

		case STATE_DAILY:
			dailyDraw(pMe);
			break;

		case STATE_TUTORIAL:
			tutorialDraw(pMe);
			break;
	}

#ifdef DEBUG_SOUND
	setScreen(pMe);
	setColor(pMe,255,0,0);	

	SPRINTF(pMe->DEBUG,"CBType:%d,Status:%d",pMe->eCBType,pMe->eStatus);
	fillRect(pMe,0,pMe->canvas_height-pMe->font_h,pMe->canvas_width,pMe->font_h,RGB(255,255,255));
	drawString(pMe,pMe->DEBUG,0,pMe->canvas_height-pMe->font_h,GFX_LEFT);
#endif

	// send paint message.
	IDISPLAY_Update(pMe->a.m_pIDisplay);
}

// initiate CMoso's variable.
void moso_init(CMoso* pMe)
{
	int i;
	AECHAR* temp = (AECHAR*)"a";

	// ũ ϸ̼
	pMe->menuHand = 2;
	pMe->forkTime = 0;


	//   ʱȭ.
	pMe->logoTimeGap			= 50;
	pMe->logoState1Frame		= 8;	// logo state 1  8 frame  ȴ.
	pMe->logoState2Frame		= 7;	// logo state 2  8 frame  ȴ.
	pMe->logoState3Frame		= 2;	// logo state 3  8 frame  ȴ.
	pMe->logoHeight				= 15;	// happy mobile ΰ 

	pMe->imgHappyLogo1.bitmap	= NULL;
	pMe->imgHappyLogo2.bitmap	= NULL;
	pMe->imgHappyLogo3.bitmap	= NULL;
	pMe->imgHappyLogo4.bitmap	= NULL;
	pMe->imgHappyLogo5.bitmap	= NULL;


	// backlight always on.
	IDISPLAY_Backlight(pMe->a.m_pIDisplay,TRUE);


	// get device info.
	ISHELL_GetDeviceInfo(pMe->a.m_pIShell, &pMe->dm);
	pMe->canvas_width	= pMe->dm.cxScreen;
	pMe->canvas_height	= pMe->dm.cyScreen;
	pMe->canvas_midx	= pMe->canvas_width/2;
	pMe->canvas_midy	= pMe->canvas_height/2;


	ISHELL_CreateInstance(pMe->a.m_pIShell, AEECLSID_HEAP, (void**)&pMe->pIHeap);

	
	// set default value to sd
	pMe->config_isSound		= 1;
	pMe->config_isVibration	= 1;

	pMe->story_2guard		= FALSE;
	pMe->story_3guard		= FALSE;

	pMe->story_day			= 0;
	pMe->story_stage		= 0;
	pMe->story_trashstage	= 0;
	pMe->story_findstage	= 0;
	pMe->story_power		= 1;
	pMe->story_weapon		= 1;
	pMe->story_itemNum		= 0; //  0  .
	MEMSET(pMe->story_item,0,sizeof(byte)*GAME_STORY_DAY);

	pMe->endless_trashlv	= 0;
	pMe->endless_findlv		= 0;
	pMe->endless_diglv		= 0;

	pMe->endless_trashscore	= 0;
	pMe->endless_findscore	= 0;
	pMe->endless_digscore	= 0;

	// load saved data from file.
	// if there is a SAVE_FILE sd will be change.
	loadData(pMe);




	// font initiation.
	pMe->font	= AEE_FONT_NORMAL;
	pMe->font_h	= IDISPLAY_GetFontMetrics(pMe->a.m_pIDisplay,pMe->font,NULL,NULL);
	pMe->font_w = IDISPLAY_MeasureText(pMe->a.m_pIDisplay,pMe->font,temp); //  ʺ صд. ׶׶ ٸ..


	// thread sec initiation.
	pMe->waitTime		= 0;

	// temp wstr initiation.
	MEMSET(pMe->tempWStr,0,100);



	// ̹  . 176 ̶ ƴѰŶ Ʋ.
	pMe->imgNum = NUM_GAMEIMG;
	if( pMe->canvas_height < 160 )
		pMe->imgNum -= 14;


	// Image initiation.
	pMe->imgTemp.src	= NULL;
	pMe->imgTemp.bitmap	= NULL;	


	pMe->imgLoading.src			= NULL;
	pMe->imgLoading.bitmap		= NULL;	
	pMe->imgLoadbar.src			= NULL;
	pMe->imgLoadbar.bitmap		= NULL;	
	pMe->imgLoadbarBg.src		= NULL;
	pMe->imgLoadbarBg.bitmap	= NULL;	
	pMe->imgLoadBg.src			= NULL;
	pMe->imgLoadBg.bitmap		= NULL;	


	pMe->menu_imgKeyInfo.src		= NULL;
	pMe->menu_imgKeyInfo.bitmap		= NULL;	

	pMe->episode_leftImage.src		= NULL;
	pMe->episode_leftImage.bitmap	= NULL;
	pMe->episode_rightImage.src		= NULL;
	pMe->episode_rightImage.bitmap	= NULL;

	for(i=0;i<pMe->imgNum;++i)
	{
		pMe->imgGame[i].src		= NULL;
		pMe->imgGame[i].bitmap	= NULL;
	}
	//============================================

	// 
//	pMe->updateDisplay	= FALSE;

	// 
	pMe->key			= GKEY_NONE;



	// set IMG_GAMEBACK to IDB_INTRO so we can access game img by calling pMe->imgTextList[IMG_GAMEBACK]
	//  ٲ .

	// common
	pMe->resIDGame[IMG_NUMBER1]			= IDB_NUMBER1;
	pMe->resIDGame[IMG_NUMBER2]			= IDB_NUMBER2;
	pMe->resIDGame[IMG_NUMBER3]			= IDB_NUMBER3;
	pMe->resIDGame[IMG_HYPHEN]			= IDB_HYPHEN;
	pMe->resIDGame[IMG_GAUGEPONG]		= IDB_GAUGEPONG;
	pMe->resIDGame[IMG_GAUGELEVEL]		= IDB_GAUGELEVEL;
	pMe->resIDGame[IMG_GAUGELEVELBG]	= IDB_GAUGELEVELBG;
	pMe->resIDGame[IMG_STATUSBG]		= IDB_STATUSBG;
	pMe->resIDGame[IMG_TIME]			= IDB_TIME;
	pMe->resIDGame[IMG_START]			= IDB_START;
	pMe->resIDGame[IMG_CALENDAR]		= IDB_CALENDAR;
	pMe->resIDGame[IMG_CLOCK]			= IDB_CLOCK;
	pMe->resIDGame[IMG_POINT]			= IDB_POINT;
	pMe->resIDGame[IMG_PERCENT]			= IDB_PERCENT;
	pMe->resIDGame[IMG_TXTFAILURE]		= IDB_TXTFAILURE;
	pMe->resIDGame[IMG_TXTSUCCESS]		= IDB_TXTSUCCESS;
	pMe->resIDGame[IMG_TXTDAY]			= IDB_TXTDAY;
	pMe->resIDGame[IMG_TXTSKIP]			= IDB_TXTSKIP;
	pMe->resIDGame[IMG_TXTSCORE]		= IDB_TXTSCORE;
	pMe->resIDGame[IMG_TXTLV]			= IDB_TXTLV;
	pMe->resIDGame[IMG_TXTPOWERLV]		= IDB_TXTPOWERLV;
	pMe->resIDGame[IMG_TXTWEAPONLV]		= IDB_TXTWEAPONLV;
	pMe->resIDGame[IMG_BIGPAN]			= IDB_BIGPAN;
	pMe->resIDGame[IMG_MINIPAN]			= IDB_MINIPAN;
	pMe->resIDGame[IMG_LEFTARROW]		= IDB_LEFTARROW;
	pMe->resIDGame[IMG_RIGHTARROW]		= IDB_RIGHTARROW;
	pMe->resIDGame[IMG_GAUGELOADINGBG]	= IDB_GAUGELOADINGBG;
	pMe->resIDGame[IMG_GAUGELOADING]	= IDB_GAUGELOADING;


	

	// menu
	pMe->resIDGame[IMG_MENUSTORY]		= IDB_MENUSTORY;
	pMe->resIDGame[IMG_MENUENDLESS]		= IDB_MENUENDLESS;
	pMe->resIDGame[IMG_MENUFEE]			= IDB_MENUFEE;
	pMe->resIDGame[IMG_MENUINFO]		= IDB_MENUINFO;
	pMe->resIDGame[IMG_MENUEXIT]		= IDB_MENUEXIT;
	pMe->resIDGame[IMG_MENUSETTING]		= IDB_MENUSETTING;
	pMe->resIDGame[IMG_MENURANKING]		= IDB_MENURANKING;
	pMe->resIDGame[IMG_TXTSTORYMODE]	= IDB_TXTSTORYMODE;
	pMe->resIDGame[IMG_TXTENDLESSMODE]	= IDB_TXTENDLESSMODE;
	pMe->resIDGame[IMG_TXTFEE]			= IDB_TXTFEE;
	pMe->resIDGame[IMG_TXTINFO]			= IDB_TXTINFO;
	pMe->resIDGame[IMG_TXTEXIT]			= IDB_TXTEXIT;
	pMe->resIDGame[IMG_TXTSETTING]		= IDB_TXTSETTING;
	pMe->resIDGame[IMG_TXTRANKING]		= IDB_TXTRANKING;
	pMe->resIDGame[IMG_TXTMENU]			= IDB_TXTMENU;
	pMe->resIDGame[IMG_TXTSTORY]		= IDB_TXTSTORY;
	pMe->resIDGame[IMG_TXTKEYHOWTO]		= IDB_TXTKEYHOWTO;
	pMe->resIDGame[IMG_TXTABOUT]		= IDB_TXTABOUT;
	pMe->resIDGame[IMG_TXTBACK]			= IDB_TXTBACK;
	pMe->resIDGame[IMG_TXTTUTORIAL]		= IDB_TXTTUTORIAL;
	pMe->resIDGame[IMG_MENUHAND]		= IDB_MENUHAND;
	pMe->resIDGame[IMG_MENUON]			= IDB_MENUON;
	pMe->resIDGame[IMG_MENUOFF]			= IDB_MENUOFF;


	// trash
	pMe->resIDGame[IMG_TRASHSON0]		= IDB_TRASHSON0;
	pMe->resIDGame[IMG_TRASHSON1]		= IDB_TRASHSON1;
	pMe->resIDGame[IMG_TRASHSON2]		= IDB_TRASHSON2;
	pMe->resIDGame[IMG_TRASHBUG1]		= IDB_TRASHBUG1;
	pMe->resIDGame[IMG_TRASHBUG2]		= IDB_TRASHBUG2;
	pMe->resIDGame[IMG_TRASHBUG3]		= IDB_TRASHBUG3;
	pMe->resIDGame[IMG_TRASHWIN1]		= IDB_TRASHWIN1;
	pMe->resIDGame[IMG_TRASHWIN2]		= IDB_TRASHWIN2;
	pMe->resIDGame[IMG_TRASHWIN3]		= IDB_TRASHWIN3;
	pMe->resIDGame[IMG_TRASHWIN4]		= IDB_TRASHWIN4;
	pMe->resIDGame[IMG_TRASHBG]			= IDB_TRASHBG;
	pMe->resIDGame[IMG_TRASHMINIWIN]	= IDB_TRASHMINIWIN;
	pMe->resIDGame[IMG_TRASHMULTIPLY]	= IDB_TRASHMULTIPLY;
	pMe->resIDGame[IMG_TRASHPONG1]		= IDB_TRASHPONG1;
	pMe->resIDGame[IMG_TRASHPONG2]		= IDB_TRASHPONG2;

	// find
	pMe->resIDGame[IMG_FINDCHA1]		= IDB_FINDCHA1;
	pMe->resIDGame[IMG_FINDMINICHA1]	= IDB_FINDMINICHA1;
	pMe->resIDGame[IMG_FINDREMAINCHA]	= IDB_FINDREMAINCHA;
	pMe->resIDGame[IMG_FINDCHECK]		= IDB_FINDCHECK;

	// dig
	pMe->resIDGame[IMG_DIGBG]			= IDB_DIGBG;
	pMe->resIDGame[IMG_DIGCM]			= IDB_DIGCM;
	pMe->resIDGame[IMG_DIGDIG1]			= IDB_DIGDIG1;
	pMe->resIDGame[IMG_DIGDIG2]			= IDB_DIGDIG2;
	pMe->resIDGame[IMG_DIGWEAPON1_1]	= IDB_DIGWEAPON1_1;
	pMe->resIDGame[IMG_DIGWEAPON1_2]	= IDB_DIGWEAPON1_2;
	pMe->resIDGame[IMG_DIGWEAPON2_1]	= IDB_DIGWEAPON2_1;
	pMe->resIDGame[IMG_DIGWEAPON2_2]	= IDB_DIGWEAPON2_2;
	pMe->resIDGame[IMG_DIGWEAPON3_1]	= IDB_DIGWEAPON3_1;
	pMe->resIDGame[IMG_DIGWEAPON3_2]	= IDB_DIGWEAPON3_2;
	pMe->resIDGame[IMG_DIGWEAPON4_1]	= IDB_DIGWEAPON4_1;
	pMe->resIDGame[IMG_DIGWEAPON4_2]	= IDB_DIGWEAPON4_2;
	pMe->resIDGame[IMG_DIGWEAPON5_1]	= IDB_DIGWEAPON5_1;
	pMe->resIDGame[IMG_DIGWEAPON5_2]	= IDB_DIGWEAPON5_2;
	pMe->resIDGame[IMG_DIGPOSTER1]		= IDB_DIGPOSTER1;
	pMe->resIDGame[IMG_DIGPOSTER2]		= IDB_DIGPOSTER2;
	pMe->resIDGame[IMG_DIGPOSTER3]		= IDB_DIGPOSTER3;
	pMe->resIDGame[IMG_DIGPOSTER4]		= IDB_DIGPOSTER4;
	pMe->resIDGame[IMG_DIGPIECE1]		= IDB_DIGPIECE1;
	pMe->resIDGame[IMG_DIGPIECE2]		= IDB_DIGPIECE2;
	pMe->resIDGame[IMG_DIGZZZ]			= IDB_DIGZZZ;
	pMe->resIDGame[IMG_DIGGUARD1]		= IDB_DIGGUARD1;
	pMe->resIDGame[IMG_DIGGUARD2]		= IDB_DIGGUARD2;
	pMe->resIDGame[IMG_DIGGUARD3]		= IDB_DIGGUARD3;
	pMe->resIDGame[IMG_DIGICON1P]		= IDB_DIGICON1P;
	pMe->resIDGame[IMG_DIGICONGUARD1]	= IDB_DIGICONGUARD1;
	pMe->resIDGame[IMG_DIGICONGUARD2]	= IDB_DIGICONGUARD2;
	pMe->resIDGame[IMG_DIGICONGUARD3]	= IDB_DIGICONGUARD3;
	pMe->resIDGame[IMG_DIGSTONE]		= IDB_DIGSTONE;
	pMe->resIDGame[IMG_DIGCAUGHT1]		= IDB_DIGCAUGHT1;
	pMe->resIDGame[IMG_DIGCAUGHT2]		= IDB_DIGCAUGHT2;
	pMe->resIDGame[IMG_DIGWARNING]		= IDB_DIGWARNING;
	pMe->resIDGame[IMG_DIGICONBOMB1]	= IDB_DIGICONBOMB1;
	pMe->resIDGame[IMG_DIGICONBOMB2]	= IDB_DIGICONBOMB2;
	pMe->resIDGame[IMG_DIGICONITEM1]	= IDB_DIGICONITEM1;
	pMe->resIDGame[IMG_DIGICONITEM2]	= IDB_DIGICONITEM2;
	pMe->resIDGame[IMG_DIGICONITEM3]	= IDB_DIGICONITEM3;
	pMe->resIDGame[IMG_DIGICONITEM4]	= IDB_DIGICONITEM4;
	pMe->resIDGame[IMG_DIGTIMELOCK]		= IDB_DIGTIMELOCK;


	// daily
	pMe->resIDGame[IMG_DAILYLV]			= IDB_DAILYLV;
	pMe->resIDGame[IMG_DAILYPROGRESS]	= IDB_DAILYPROGRESS;


	// box
	pMe->resIDGame[IMG_BOXVERT]			= IDB_BOXVERT;
	pMe->resIDGame[IMG_BOXHORZ]			= IDB_BOXHORZ;
	pMe->resIDGame[IMG_BOXEDGELT]		= IDB_BOXEDGELT;
	pMe->resIDGame[IMG_BOXEDGERT]		= IDB_BOXEDGERT;
	pMe->resIDGame[IMG_BOXEDGELB]		= IDB_BOXEDGELB;
	pMe->resIDGame[IMG_BOXEDGERB]		= IDB_BOXEDGERB;


	// staff
	pMe->resIDGame[IMG_STAFFDAUM]		= IDB_STAFFDAUM;
	pMe->resIDGame[IMG_STAFFLSW]		= IDB_STAFFLSW;
	pMe->resIDGame[IMG_STAFFSPARKDH]	= IDB_STAFFSPARKDH;
	pMe->resIDGame[IMG_STAFFFRONTA]		= IDB_STAFFFRONTA;
	pMe->resIDGame[IMG_STAFFKBCKBC]		= IDB_STAFFKBCKBC;
	pMe->resIDGame[IMG_STAFFKYH]		= IDB_STAFFKYH;
	pMe->resIDGame[IMG_STAFFNCH]		= IDB_STAFFNCH;

	// fork
	pMe->resIDGame[IMG_LFORK]			= IDB_LFORK;
	pMe->resIDGame[IMG_RFORK]			= IDB_RFORK;

	// 176   ҷ ϴ ̹.
	if( pMe->canvas_height > 160 ) {	
		pMe->resIDGame[IMG_FINDBGLEFT]		= IDB_FINDBGLEFT;
		pMe->resIDGame[IMG_FINDBGRIGHT]		= IDB_FINDBGRIGHT;
		pMe->resIDGame[IMG_FINDBGTOP]		= IDB_FINDBGTOP;
		pMe->resIDGame[IMG_FINDBGBOTTOM]	= IDB_FINDBGBOTTOM;

		pMe->resIDGame[IMG_DIGBGTOP1]		= IDB_DIGBGTOP1;
		pMe->resIDGame[IMG_DIGBGTOP2]		= IDB_DIGBGTOP2;
		pMe->resIDGame[IMG_DIGBGBOTTOM1]	= IDB_DIGBGBOTTOM1;
		pMe->resIDGame[IMG_DIGBGBOTTOM2]	= IDB_DIGBGBOTTOM2;


		pMe->resIDGame[IMG_TRASHBGLEFT]		= IDB_TRASHBGLEFT;
		pMe->resIDGame[IMG_TRASHBGLEFT1]	= IDB_TRASHBGLEFT1;
		pMe->resIDGame[IMG_TRASHBGRIGHT]	= IDB_TRASHBGRIGHT;
		pMe->resIDGame[IMG_TRASHBGRIGHT1]	= IDB_TRASHBGRIGHT1;
		pMe->resIDGame[IMG_TRASHBGTOP]		= IDB_TRASHBGTOP;
		pMe->resIDGame[IMG_TRASHBGDOOR]		= IDB_TRASHBGDOOR;
	}

	// snd

	pMe->sndID[SND_TRASHCLEAN]			= IDS_TRASHCLEAN;
	pMe->sndID[SND_TRASHGLASS1]			= IDS_TRASHGLASS1;
	pMe->sndID[SND_TRASHGLASS2]			= IDS_TRASHGLASS2;
	pMe->sndID[SND_TRASHHO]				= IDS_TRASHHO;
	pMe->sndID[SND_TRASHWATER]			= IDS_TRASHWATER;

	pMe->sndID[SND_DIGDIG]				= IDS_DIGDIG;
	pMe->sndID[SND_DIGHIT]				= IDS_DIGHIT;

	pMe->sndID[SND_FINDSELECT]			= IDS_FINDSELECT;

	pMe->sndID[SND_ITEMBOMB]			= IDS_ITEMBOMB;
	pMe->sndID[SND_ITEMDRILL]			= IDS_ITEMDRILL;

	pMe->sndID[SND_MENUMOVE]			= IDS_MENUMOVE;
	pMe->sndID[SND_MENUSELECT]			= IDS_MENUSELECT;


	
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// loadTick() & loadDraw() 
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	pMe->loadState = 0;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// menuTick() & menuDraw() 
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	pMe->menu_Numitem = 0;

	// get random numbers
//	GET_RAND(pMe->rand,20);
	

	for(i=0;i<10;i++)
		GET_RAND(pMe->rand + i*20,20);
	pMe->randi = 0;


//	pMe->menu_about		= " :\\Ŀ´̼\\\\ȭ :\\(02)6003-8482\\\\ :\\reaper@\\daumcorp.com\\\\ȹ :\\ڵȣ\\\\׸ :\\űԼ\\\\뷱 :\\âȣ\\\\˼ :\\ȭ\\\\ :\\\\\\ :\\1.0.0\\մϴ.";

	pMe->vstr = "ver 1.0.2";
	SPRINTF(pMe->menu_about," :\\Ŀ´̼\\\\ȭ :\\(02)6003-8482\\\\ :\\reaper@\\daumcorp.com\\\\ȹ :\\ڵȣ\\\\׸ :\\űԼ\\\\뷱 :\\âȣ\\\\˼ :\\ȭ\\\\ :\\\\\\%s\\մϴ.",pMe->vstr);

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// gauge
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	pMe->gauge_flag	= 0;


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// anistory
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	pMe->anistory_backDraw	= FALSE;	
	pMe->anistory_type		= 0;
	pMe->anistory_img		= 0;
	pMe->anistory_story		= NULL;


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// tutorial
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	pMe->tutorial_trashstory	= "â\\    ǹ â ۴ Դϴ.   â   ۾ƾ ϴµ     â  찡 ֽϴ. â   ۴ Ƚ Ʋϴ. ̳  â ȣ ŸϿ  ۽ϴ. ۰ԵǸ  پµ 0 Ű ŸϿ    ֽϴ.   . â  Ǹ ̻   ʾ Ͽ   ˴ϴ.";
	pMe->tutorial_findstory		= "˿\\ ٸ  ο ¸ üũϴ Դϴ.  ߴ   캸 ޾Ƴ ༮  Դϴ. ޾Ƴ ༮  ȣ    ֽϴ.   ѹ ƾ ϴ  Ʋϴ. Ѵ  ! ޾Ƴ  ϴ.";
	pMe->tutorial_digstory		= "ı\\    ġä ʰ  ľ մϴ. 1Ű   ͸   3Ű   ļ. ,  Ϸ   Ĵ ۾ ߰ ͸   ڴ ô Ͽ ؾ մϴ. 丮 忡 ȹ  * Ű   ֽϴ. ѵ 30 ȿ  20  վ մϴ.";

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// story
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	// set story
	pMe->main_story = "ȣ̿ Բ  ̷  ϴ ȣ̿  ̺ ϰ      뵵÷   쿬    Ǿ 忡 ϰ Ǿ.  Ͽ      Ż ȹϰ Ǿ.   â ۰ 嵵 ϸ鼭  Ǿ ȯ  㿡    츮 Żϱ   վ Ż ϴµ..";
	pMe->fee_story	= "  Ʈ Ÿ 뷮  ⺻ŷ  1Ŷ(512byte) 0 ߰  ̿ᰡ ΰ˴ϴ.";
	



////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// startday
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	pMe->startday_init = FALSE;




////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// episode
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	// episode #1
	pMe->episode_caption1[0]	= "\\   ϸ Ű±.    ʰ.  ̻    .  ư ȣ̿ 糪 .";
	pMe->episode_caption1[1]	= "\\  ⼭  ְ.â ۾ְ   ϴ 鵵 ְԳ";
	pMe->episode_caption1[2]	= "\\   ?";
	pMe->episode_caption1[3]	= "\\ ͵   ׷... ˴ Ⱦϰ ...";

	// episode #2
	pMe->episode_caption2[0]	= "\\... ";
	pMe->episode_caption2[1]	= "׸\\ 𸣳    ڴ.";
	pMe->episode_caption2[2]	= "\\-_-";
	pMe->episode_caption2[3]	= "׸\\ȹڰ 󸶳    ° ....ư ְڳ.  ̰   Ϸ Դ ϰ    30Ŀ  忡 ȷ Ѵٳ";
	pMe->episode_caption2[4]	= "\\̷....";
	pMe->episode_caption2[5]	= "׸\\ ġ ë   ...ϴ  ũ ް  ġä ʰ   ĺԳ.ϰ Ǵ  ϰ Ǹ Ĵ ų ò";


	// episode #3
	pMe->episode_caption3[0]	= "׸\\! ̶ ϰ -_- ǥ  ߰....";
	pMe->episode_caption3[1]	= "\\-_-";
	pMe->episode_caption3[2]	= "׸\\̹  ڳ׸ ҽ   ̺Ʈ ѹ  Ҵٳ ׸ ÿƵ ȹڰ θԴ° ƴѰͿ ϰԳ.";
	pMe->episode_caption3[3]	= "\\-_-";

	// episode #4
	pMe->episode_caption4[0]	= "\\...";
	pMe->episode_caption4[1]	= "׸\\.... ߹  ϴ ϸ  ʾҴ? ٷ ѵ";
	pMe->episode_caption4[2]	= "\\-_-";
	pMe->episode_caption4[3]	= "׸\\׷ ڳ״ ׷ ǥ⸸ ϰԳ. п  ϴٺ   ϳ.  ƴ϶  ٽ غԳ. λ ֳ.־ 30̳ 20 ı⿡ ؾ Ѵٳ ׷  ڳ״  ȯϰ ɲ~";


	// episode #5
	pMe->episode_caption5[0]	= "׸\\ϼ~ ";
	pMe->episode_caption5[1]	= "\\ ̼?";
	pMe->episode_caption5[2]	= "׸\\ȸ ڸ źָ  ٶ...~";
	pMe->episode_caption5[3]	= "\\-_-";
	pMe->episode_caption5[4]	= "׸\\  Ҹ ٳ...׳  ôٳ";
	pMe->episode_caption5[5]	= "\\-_-";
	pMe->episode_caption5[6]	= "׸\\... 忡 Ż ־  ϳ þ. ϰԳ.";

	// episode #6
	pMe->episode_caption6[0]	= "\\̼?";
	pMe->episode_caption6[1]	= "׸\\-_-";
	pMe->episode_caption6[2]	= "\\ ¨ ̶?";
	pMe->episode_caption6[3]	= "׸\\ϳ  Ϸ Գ.   ߹   ̹  ܴ  վ";
	pMe->episode_caption6[4]	= "\\׷.....װ  ̿!!";
	pMe->episode_caption6[5]	= "׸\\ ġ ëٳ. Ƹ   ܴ 츮 Ű״ ̸ ϴ° ɼ";

	// episode #7
	pMe->episode_caption7[0]	= "׸\\ Ĵ±";
	pMe->episode_caption7[1]	= "\\   ܾ ͼ";
	pMe->episode_caption7[2]	= "׸\\׷? ̰ Żϸ   ܾ. ϰŸ  ȼ~";
	pMe->episode_caption7[3]	= "\\׷ÿ";
	pMe->episode_caption7[4]	= "׸\\   ſ Լ. ð   ʾ  ؼ  ȯ Żؼ ⿡  Դٴ ȣ̸  ٶ.   ġ æ  ð  . ϰԳ.";
	pMe->episode_caption7[5]	= "\\  ߿ ̾߱⸦   ϴٴ!!";

	// episode #8
	pMe->episode_caption8[0]	= "\\ ݸ  ĸ !!";
	pMe->episode_caption8[1]	= "׸\\ݲ  ....׷ ū̳";
	pMe->episode_caption8[2]	= "\\??";
	pMe->episode_caption8[3]	= "׸\\  ڳ Ż õ  ġ æ ..  3 ɲ.   ̴  ﲬ.ּ غԳ";
	pMe->episode_caption8[4]	= "\\׶Խô";

	// episode #9
	pMe->episode_caption9[0]	= "׸\\߳~   ϴ   Ǵ±.  η ʰ  ٶ.ħ  ڳ ȣ̰ ٸ  . Ļ Ʈ   ູϰ  ٶ.";
	pMe->episode_caption9[1]	= "\\.";
	pMe->episode_caption9[2]	= "׸\\ 쳪";
	pMe->episode_caption9[3]	= "\\ȣ̰ ߼....׻......";
	pMe->episode_caption9[4]	= "׸\\̷.. ȹٷ !  ڳ.ٽ  غ Ƴ?  ٽ  ޿ ϴ  ...ƴ   Գ";

	// episode #10
	pMe->episode_caption10[0]	= "׸\\! ڳ  ɷϴ°? Ϸ Ʋ ϳ. Ź ı⿡ ϸ    !!";

	// episode #11
	pMe->episode_caption11[0]	= "׸\\ڳװ ȹ  ð ̳. δ Ҽ ִٳ *Ű ۵ϰ";

	// episode #12
	pMe->episode_caption12[0]	= "׸\\ڳװ ȹ  帱 ̳.  ϵ ť ոɼ~ *Ű ۵ϰ";

	// episode #13
	pMe->episode_caption13[0]	= "׸\\ڳװ ȹ  ź ̳.    ų  ִٳ. *Ű ۵ϰ";

	// episode #14
	pMe->episode_caption14[0]	= "׸\\ڳװ ȹ   ̳.    . *Ű ۵ϰ";

	pMe->episode_showed		= FALSE;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// tutorial
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	pMe->tutorial_backDraw		= FALSE;
	pMe->tutorial_trashShowed	= FALSE;
	pMe->tutorial_findShowed	= FALSE;
	pMe->tutorial_digShowed		= FALSE;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// tutorial
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	pMe->daily_backDraw			= FALSE;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// level factor setting
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


	// â۱  [丮]

	pMe->story_trashFactor[0][TRASH_WHOLETIME]	= 20000 + 5000;
	pMe->story_trashFactor[0][TRASH_TRASHGAP]	= 1500;
	pMe->story_trashFactor[0][TRASH_PONGPONG]	= 10;
	pMe->story_trashFactor[0][TRASH_WINDOW]		= 3;
	pMe->story_trashFactor[0][TRASH_DESTSCORE]	= 4;

	pMe->story_trashFactor[1][TRASH_WHOLETIME]	= 19000 + 5000;
	pMe->story_trashFactor[1][TRASH_TRASHGAP]	= 1500;
	pMe->story_trashFactor[1][TRASH_PONGPONG]	= 10;
	pMe->story_trashFactor[1][TRASH_WINDOW]		= 3;
	pMe->story_trashFactor[1][TRASH_DESTSCORE]	= 4;

	pMe->story_trashFactor[2][TRASH_WHOLETIME]	= 16000 + 5000;
	pMe->story_trashFactor[2][TRASH_TRASHGAP]	= 1500;
	pMe->story_trashFactor[2][TRASH_PONGPONG]	= 10;
	pMe->story_trashFactor[2][TRASH_WINDOW]		= 3;
	pMe->story_trashFactor[2][TRASH_DESTSCORE]	= 5;

	pMe->story_trashFactor[3][TRASH_WHOLETIME]	= 23000 + 5000;
	pMe->story_trashFactor[3][TRASH_TRASHGAP]	= 1500;
	pMe->story_trashFactor[3][TRASH_PONGPONG]	= 11;
	pMe->story_trashFactor[3][TRASH_WINDOW]		= 3;
	pMe->story_trashFactor[3][TRASH_DESTSCORE]	= 6;

	pMe->story_trashFactor[4][TRASH_WHOLETIME]	= 22000 + 5000;
	pMe->story_trashFactor[4][TRASH_TRASHGAP]	= 1500;
	pMe->story_trashFactor[4][TRASH_PONGPONG]	= 11;
	pMe->story_trashFactor[4][TRASH_WINDOW]		= 3;
	pMe->story_trashFactor[4][TRASH_DESTSCORE]	= 7;

	pMe->story_trashFactor[5][TRASH_WHOLETIME]	= 21000 + 5000;
	pMe->story_trashFactor[5][TRASH_TRASHGAP]	= 1500;
	pMe->story_trashFactor[5][TRASH_PONGPONG]	= 11;
	pMe->story_trashFactor[5][TRASH_WINDOW]		= 3;
	pMe->story_trashFactor[5][TRASH_DESTSCORE]	= 8;

	pMe->story_trashFactor[6][TRASH_WHOLETIME]	= 25000 + 5000;
	pMe->story_trashFactor[6][TRASH_TRASHGAP]	= 1500;
	pMe->story_trashFactor[6][TRASH_PONGPONG]	= 12;
	pMe->story_trashFactor[6][TRASH_WINDOW]		= 3;
	pMe->story_trashFactor[6][TRASH_DESTSCORE]	= 10;

	pMe->story_trashFactor[7][TRASH_WHOLETIME]	= 23000 + 5000;
	pMe->story_trashFactor[7][TRASH_TRASHGAP]	= 1500;
	pMe->story_trashFactor[7][TRASH_PONGPONG]	= 12;
	pMe->story_trashFactor[7][TRASH_WINDOW]		= 3;
	pMe->story_trashFactor[7][TRASH_DESTSCORE]	= 11;

	pMe->story_trashFactor[8][TRASH_WHOLETIME]	= 28000 + 5000;
	pMe->story_trashFactor[8][TRASH_TRASHGAP]	= 1500;
	pMe->story_trashFactor[8][TRASH_PONGPONG]	= 10;
	pMe->story_trashFactor[8][TRASH_WINDOW]		= 3;
	pMe->story_trashFactor[8][TRASH_DESTSCORE]	= 12;

	pMe->story_trashFactor[9][TRASH_WHOLETIME]	= 30000 + 5000;
	pMe->story_trashFactor[9][TRASH_TRASHGAP]	= 1500;
	pMe->story_trashFactor[9][TRASH_PONGPONG]	= 10;
	pMe->story_trashFactor[9][TRASH_WINDOW]		= 3;
	pMe->story_trashFactor[9][TRASH_DESTSCORE]	= 13;

	pMe->story_trashFactor[10][TRASH_WHOLETIME]	= 32000 + 5000;
	pMe->story_trashFactor[10][TRASH_TRASHGAP]	= 1500;
	pMe->story_trashFactor[10][TRASH_PONGPONG]	= 10;
	pMe->story_trashFactor[10][TRASH_WINDOW]	= 3;
	pMe->story_trashFactor[10][TRASH_DESTSCORE]	= 14;

	pMe->story_trashFactor[11][TRASH_WHOLETIME]	= 36000 + 5000;
	pMe->story_trashFactor[11][TRASH_TRASHGAP]	= 1500;
	pMe->story_trashFactor[11][TRASH_PONGPONG]	= 10;
	pMe->story_trashFactor[11][TRASH_WINDOW]	= 3;
	pMe->story_trashFactor[11][TRASH_DESTSCORE]	= 16;

	pMe->story_trashFactor[12][TRASH_WHOLETIME]	= 38000 + 5000;
	pMe->story_trashFactor[12][TRASH_TRASHGAP]	= 1500;
	pMe->story_trashFactor[12][TRASH_PONGPONG]	= 9;
	pMe->story_trashFactor[12][TRASH_WINDOW]	= 3;
	pMe->story_trashFactor[12][TRASH_DESTSCORE]	= 18;

	pMe->story_trashFactor[13][TRASH_WHOLETIME]	= 40000 + 5000;
	pMe->story_trashFactor[13][TRASH_TRASHGAP]	= 1500;
	pMe->story_trashFactor[13][TRASH_PONGPONG]	= 9;
	pMe->story_trashFactor[13][TRASH_WINDOW]	= 3;
	pMe->story_trashFactor[13][TRASH_DESTSCORE] 	= 20;

	pMe->story_trashFactor[14][TRASH_WHOLETIME]   	= 45000 + 5000;
	pMe->story_trashFactor[14][TRASH_TRASHGAP]    	= 1500;
	pMe->story_trashFactor[14][TRASH_PONGPONG]    	= 8;
	pMe->story_trashFactor[14][TRASH_WINDOW]      	= 3;
	pMe->story_trashFactor[14][TRASH_DESTSCORE]   	= 24;


	// ˿[丮]
 
	pMe->story_findFactor[0][FIND_WHOLETIME]	= 15000 + 5000; //ѽð
	pMe->story_findFactor[0][FIND_MOVEGAP]		= 300; // ̴ ð 
	pMe->story_findFactor[0][FIND_INPUTTIME]	= 2000; // Է ð
	pMe->story_findFactor[0][FIND_MOVEMAX]		= 1; // ã  
	pMe->story_findFactor[0][FIND_SPOTMAX]		= 3; // ÿ  Ʈ ִ
	pMe->story_findFactor[0][FIND_DESTSCORE]	= 2; //   ãƳ ϴ

	pMe->story_findFactor[1][FIND_WHOLETIME]	= 15000 + 5000;
	pMe->story_findFactor[1][FIND_MOVEGAP]		= 300;
	pMe->story_findFactor[1][FIND_INPUTTIME]	= 2000;
	pMe->story_findFactor[1][FIND_MOVEMAX]		= 1;
	pMe->story_findFactor[1][FIND_SPOTMAX]		= 3;
	pMe->story_findFactor[1][FIND_DESTSCORE]	= 3;

	pMe->story_findFactor[2][FIND_WHOLETIME]	= 20000 + 5000;
	pMe->story_findFactor[2][FIND_MOVEGAP]		= 300;
	pMe->story_findFactor[2][FIND_INPUTTIME]	= 2000;
	pMe->story_findFactor[2][FIND_MOVEMAX]	  	= 2;
	pMe->story_findFactor[2][FIND_SPOTMAX]		= 3;
	pMe->story_findFactor[2][FIND_DESTSCORE]	= 4;

	pMe->story_findFactor[3][FIND_WHOLETIME]	= 25000 + 5000;
	pMe->story_findFactor[3][FIND_MOVEGAP]		= 300;
	pMe->story_findFactor[3][FIND_INPUTTIME]	= 2000;
	pMe->story_findFactor[3][FIND_MOVEMAX]	 	= 2;
	pMe->story_findFactor[3][FIND_SPOTMAX]		= 4;
	pMe->story_findFactor[3][FIND_DESTSCORE]	= 4;

	pMe->story_findFactor[4][FIND_WHOLETIME]	= 33000 + 5000;
	pMe->story_findFactor[4][FIND_MOVEGAP]		= 300;
	pMe->story_findFactor[4][FIND_INPUTTIME]	= 2000;
	pMe->story_findFactor[4][FIND_MOVEMAX]		= 3;
	pMe->story_findFactor[4][FIND_SPOTMAX]		= 4;
	pMe->story_findFactor[4][FIND_DESTSCORE]	= 4;

	pMe->story_findFactor[5][FIND_WHOLETIME]	= 32000 + 5000;
	pMe->story_findFactor[5][FIND_MOVEGAP]		= 300;
	pMe->story_findFactor[5][FIND_INPUTTIME]	= 1000;
	pMe->story_findFactor[5][FIND_MOVEMAX]		= 4;
	pMe->story_findFactor[5][FIND_SPOTMAX]		= 5;
	pMe->story_findFactor[5][FIND_DESTSCORE]	= 4;

	pMe->story_findFactor[6][FIND_WHOLETIME]	= 30000 + 5000;
	pMe->story_findFactor[6][FIND_MOVEGAP]		= 300;
	pMe->story_findFactor[6][FIND_INPUTTIME]	= 1000;
	pMe->story_findFactor[6][FIND_MOVEMAX]		= 4;
	pMe->story_findFactor[6][FIND_SPOTMAX]		= 5;
	pMe->story_findFactor[6][FIND_DESTSCORE]	= 5;

	pMe->story_findFactor[7][FIND_WHOLETIME]	= 30000 + 5000;
	pMe->story_findFactor[7][FIND_MOVEGAP]		= 300;
	pMe->story_findFactor[7][FIND_INPUTTIME]	= 1000;
	pMe->story_findFactor[7][FIND_MOVEMAX]		= 4;
	pMe->story_findFactor[7][FIND_SPOTMAX]		= 6;
	pMe->story_findFactor[7][FIND_DESTSCORE]	= 5;

	pMe->story_findFactor[8][FIND_WHOLETIME]	= 30000 + 5000;
	pMe->story_findFactor[8][FIND_MOVEGAP]		= 300;
	pMe->story_findFactor[8][FIND_INPUTTIME]	= 1000;
	pMe->story_findFactor[8][FIND_MOVEMAX]		= 5;
	pMe->story_findFactor[8][FIND_SPOTMAX]		= 6;
	pMe->story_findFactor[8][FIND_DESTSCORE]	= 5;

	pMe->story_findFactor[9][FIND_WHOLETIME]	= 35000 + 5000;
	pMe->story_findFactor[9][FIND_MOVEGAP]		= 300;
	pMe->story_findFactor[9][FIND_INPUTTIME]	= 1000;
	pMe->story_findFactor[9][FIND_MOVEMAX]		= 5;
	pMe->story_findFactor[9][FIND_SPOTMAX]		= 6;
	pMe->story_findFactor[9][FIND_DESTSCORE]	= 6; 

	pMe->story_findFactor[10][FIND_WHOLETIME]	= 34000 + 5000;
	pMe->story_findFactor[10][FIND_MOVEGAP]		= 300;
	pMe->story_findFactor[10][FIND_INPUTTIME]	= 1000;
	pMe->story_findFactor[10][FIND_MOVEMAX]		= 5;
	pMe->story_findFactor[10][FIND_SPOTMAX]		= 6;
	pMe->story_findFactor[10][FIND_DESTSCORE]	= 6;

	pMe->story_findFactor[11][FIND_WHOLETIME]	= 33000 + 5000;
	pMe->story_findFactor[11][FIND_MOVEGAP]		= 300;
	pMe->story_findFactor[11][FIND_INPUTTIME]	= 1000;
	pMe->story_findFactor[11][FIND_MOVEMAX]		= 5;
	pMe->story_findFactor[11][FIND_SPOTMAX]		= 6;
	pMe->story_findFactor[11][FIND_DESTSCORE]	= 6;

	pMe->story_findFactor[12][FIND_WHOLETIME]	= 29000 + 5000;
	pMe->story_findFactor[12][FIND_MOVEGAP]		= 300;
	pMe->story_findFactor[12][FIND_INPUTTIME]	= 1000;
	pMe->story_findFactor[12][FIND_MOVEMAX]		= 5;
	pMe->story_findFactor[12][FIND_SPOTMAX]		= 6;
	pMe->story_findFactor[12][FIND_DESTSCORE]	= 6;

	pMe->story_findFactor[13][FIND_WHOLETIME]	= 28000 + 5000;
	pMe->story_findFactor[13][FIND_MOVEGAP]		= 300;
	pMe->story_findFactor[13][FIND_INPUTTIME]	= 1000;
	pMe->story_findFactor[13][FIND_MOVEMAX]		= 5;
	pMe->story_findFactor[13][FIND_SPOTMAX]		= 6;
	pMe->story_findFactor[13][FIND_DESTSCORE]	= 6;

	pMe->story_findFactor[14][FIND_WHOLETIME]	= 27000 + 5000;
	pMe->story_findFactor[14][FIND_MOVEGAP]		= 300;
	pMe->story_findFactor[14][FIND_INPUTTIME]	= 1000;
	pMe->story_findFactor[14][FIND_MOVEMAX]		= 5;
	pMe->story_findFactor[14][FIND_SPOTMAX]		= 6;
	pMe->story_findFactor[14][FIND_DESTSCORE]	= 6;


	// â۱[Ѹ]	

	pMe->endless_trashFactor[0][TRASH_WHOLETIME]	= 20000 + 10000 ;
	pMe->endless_trashFactor[0][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[0][TRASH_PONGPONG]	= 10;
	pMe->endless_trashFactor[0][TRASH_WINDOW]	= 3;
	pMe->endless_trashFactor[0][TRASH_DESTSCORE]	= 4;

	pMe->endless_trashFactor[1][TRASH_WHOLETIME]	= 19000  + 10000;
	pMe->endless_trashFactor[1][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[1][TRASH_PONGPONG]	= 10;
	pMe->endless_trashFactor[1][TRASH_WINDOW]	= 3;
	pMe->endless_trashFactor[1][TRASH_DESTSCORE]	= 4;

	pMe->endless_trashFactor[2][TRASH_WHOLETIME]	= 18000 + 10000;
	pMe->endless_trashFactor[2][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[2][TRASH_PONGPONG]	= 10;
	pMe->endless_trashFactor[2][TRASH_WINDOW]	= 3;
	pMe->endless_trashFactor[2][TRASH_DESTSCORE]	= 5;

	pMe->endless_trashFactor[3][TRASH_WHOLETIME]	= 17000 + 10000;
	pMe->endless_trashFactor[3][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[3][TRASH_PONGPONG]	= 10;
	pMe->endless_trashFactor[3][TRASH_WINDOW]	= 3;
	pMe->endless_trashFactor[3][TRASH_DESTSCORE]	= 5;

	pMe->endless_trashFactor[4][TRASH_WHOLETIME]	= 16000 + 10000;
	pMe->endless_trashFactor[4][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[4][TRASH_PONGPONG]	= 10;
	pMe->endless_trashFactor[4][TRASH_WINDOW]	= 3;
	pMe->endless_trashFactor[4][TRASH_DESTSCORE]	= 5;

	pMe->endless_trashFactor[5][TRASH_WHOLETIME]	= 24000 + 10000;
	pMe->endless_trashFactor[5][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[5][TRASH_PONGPONG]	= 11;
	pMe->endless_trashFactor[5][TRASH_WINDOW]	= 3;
	pMe->endless_trashFactor[5][TRASH_DESTSCORE]	= 6;

	pMe->endless_trashFactor[6][TRASH_WHOLETIME]	= 23000 + 10000;
	pMe->endless_trashFactor[6][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[6][TRASH_PONGPONG]	= 11;
	pMe->endless_trashFactor[6][TRASH_WINDOW]	= 3;
	pMe->endless_trashFactor[6][TRASH_DESTSCORE]	= 6;

	pMe->endless_trashFactor[7][TRASH_WHOLETIME]	= 22000 + 10000;
	pMe->endless_trashFactor[7][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[7][TRASH_PONGPONG]	= 11;
	pMe->endless_trashFactor[7][TRASH_WINDOW]	= 3;
	pMe->endless_trashFactor[7][TRASH_DESTSCORE]	= 7;

	pMe->endless_trashFactor[8][TRASH_WHOLETIME]	= 21000 + 10000;
	pMe->endless_trashFactor[8][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[8][TRASH_PONGPONG]	= 11;
	pMe->endless_trashFactor[8][TRASH_WINDOW]	= 3;
	pMe->endless_trashFactor[8][TRASH_DESTSCORE]	= 8;

	pMe->endless_trashFactor[9][TRASH_WHOLETIME]	= 20000 + 10000;
	pMe->endless_trashFactor[9][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[9][TRASH_PONGPONG]	= 11;
	pMe->endless_trashFactor[9][TRASH_WINDOW]	= 3;
	pMe->endless_trashFactor[9][TRASH_DESTSCORE]	= 9;

	pMe->endless_trashFactor[10][TRASH_WHOLETIME]	= 26000 + 10000;
	pMe->endless_trashFactor[10][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[10][TRASH_PONGPONG]	= 12;
	pMe->endless_trashFactor[10][TRASH_WINDOW]		= 3;
	pMe->endless_trashFactor[10][TRASH_DESTSCORE]	= 10;

	pMe->endless_trashFactor[11][TRASH_WHOLETIME]	= 25000 + 10000;
	pMe->endless_trashFactor[11][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[11][TRASH_PONGPONG]	= 12;
	pMe->endless_trashFactor[11][TRASH_WINDOW]		= 3;
	pMe->endless_trashFactor[11][TRASH_DESTSCORE]	= 10;

	pMe->endless_trashFactor[12][TRASH_WHOLETIME]	= 24000 + 10000;
	pMe->endless_trashFactor[12][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[12][TRASH_PONGPONG]	= 12;
	pMe->endless_trashFactor[12][TRASH_WINDOW]		= 3;
	pMe->endless_trashFactor[12][TRASH_DESTSCORE]	= 10;

	pMe->endless_trashFactor[13][TRASH_WHOLETIME]	= 23000 + 10000;
	pMe->endless_trashFactor[13][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[13][TRASH_PONGPONG]	= 12;
	pMe->endless_trashFactor[13][TRASH_WINDOW]		= 3;
	pMe->endless_trashFactor[13][TRASH_DESTSCORE]   = 11;

	pMe->endless_trashFactor[14][TRASH_WHOLETIME]   = 22000 + 10000;
	pMe->endless_trashFactor[14][TRASH_TRASHGAP]    = 1500;
	pMe->endless_trashFactor[14][TRASH_PONGPONG]    = 12;
	pMe->endless_trashFactor[14][TRASH_WINDOW]      = 3;
	pMe->endless_trashFactor[14][TRASH_DESTSCORE]   = 11;

	pMe->endless_trashFactor[15][TRASH_WHOLETIME]	= 28000 + 10000;
	pMe->endless_trashFactor[15][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[15][TRASH_PONGPONG]	= 10;
	pMe->endless_trashFactor[15][TRASH_WINDOW]		= 3;
	pMe->endless_trashFactor[15][TRASH_DESTSCORE]	= 12;

	pMe->endless_trashFactor[16][TRASH_WHOLETIME]	= 30000 + 10000;
	pMe->endless_trashFactor[16][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[16][TRASH_PONGPONG]	= 10;
	pMe->endless_trashFactor[16][TRASH_WINDOW]		= 3;
	pMe->endless_trashFactor[16][TRASH_DESTSCORE]	= 13;

	pMe->endless_trashFactor[17][TRASH_WHOLETIME]	= 32000 + 10000;
	pMe->endless_trashFactor[17][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[17][TRASH_PONGPONG]	= 10;
	pMe->endless_trashFactor[17][TRASH_WINDOW]		= 3;
	pMe->endless_trashFactor[17][TRASH_DESTSCORE]	= 14;

	pMe->endless_trashFactor[18][TRASH_WHOLETIME]	= 34000 + 10000;
	pMe->endless_trashFactor[18][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[18][TRASH_PONGPONG]	= 10;
	pMe->endless_trashFactor[18][TRASH_WINDOW]		= 3;
	pMe->endless_trashFactor[18][TRASH_DESTSCORE]	= 15;

	pMe->endless_trashFactor[19][TRASH_WHOLETIME]	= 36000 + 10000;
	pMe->endless_trashFactor[19][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[19][TRASH_PONGPONG]	= 10;
	pMe->endless_trashFactor[19][TRASH_WINDOW]		= 3;
	pMe->endless_trashFactor[19][TRASH_DESTSCORE]	= 16;

	pMe->endless_trashFactor[20][TRASH_WHOLETIME]	= 38000 + 10000;
	pMe->endless_trashFactor[20][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[20][TRASH_PONGPONG]	= 9;
	pMe->endless_trashFactor[20][TRASH_WINDOW]		= 3;
	pMe->endless_trashFactor[20][TRASH_DESTSCORE]	= 17;

	pMe->endless_trashFactor[21][TRASH_WHOLETIME]	= 38000 + 10000;
	pMe->endless_trashFactor[21][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[21][TRASH_PONGPONG]	= 9;
	pMe->endless_trashFactor[21][TRASH_WINDOW]		= 3;
	pMe->endless_trashFactor[21][TRASH_DESTSCORE]	= 18;

	pMe->endless_trashFactor[22][TRASH_WHOLETIME]	= 39000 + 10000;
	pMe->endless_trashFactor[22][TRASH_TRASHGAP]	= 1500; 
	pMe->endless_trashFactor[22][TRASH_PONGPONG]	= 9;
	pMe->endless_trashFactor[22][TRASH_WINDOW]		= 3;
	pMe->endless_trashFactor[22][TRASH_DESTSCORE]	= 19;

	pMe->endless_trashFactor[23][TRASH_WHOLETIME]	= 40000 + 10000;
	pMe->endless_trashFactor[23][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[23][TRASH_PONGPONG]	= 9;
	pMe->endless_trashFactor[23][TRASH_WINDOW]		= 3;
	pMe->endless_trashFactor[23][TRASH_DESTSCORE]	= 20;

	pMe->endless_trashFactor[24][TRASH_WHOLETIME]	= 40000 + 10000;
	pMe->endless_trashFactor[24][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[24][TRASH_PONGPONG]	= 9;
	pMe->endless_trashFactor[24][TRASH_WINDOW]		= 3;
	pMe->endless_trashFactor[24][TRASH_DESTSCORE]	= 21;

	pMe->endless_trashFactor[25][TRASH_WHOLETIME]	= 42000 + 10000;
	pMe->endless_trashFactor[25][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[25][TRASH_PONGPONG]	= 8;
	pMe->endless_trashFactor[25][TRASH_WINDOW]		= 3;
	pMe->endless_trashFactor[25][TRASH_DESTSCORE]	= 22;

	pMe->endless_trashFactor[26][TRASH_WHOLETIME]	= 45000 + 10000;
	pMe->endless_trashFactor[26][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[26][TRASH_PONGPONG]	= 8;
	pMe->endless_trashFactor[26][TRASH_WINDOW]		= 3;
	pMe->endless_trashFactor[26][TRASH_DESTSCORE]	= 24;

	pMe->endless_trashFactor[27][TRASH_WHOLETIME]	= 54000 + 10000;
	pMe->endless_trashFactor[27][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[27][TRASH_PONGPONG]	= 8;
	pMe->endless_trashFactor[27][TRASH_WINDOW]		= 3;
	pMe->endless_trashFactor[27][TRASH_DESTSCORE]	= 26;

	pMe->endless_trashFactor[28][TRASH_WHOLETIME]	= 57000 + 10000;
	pMe->endless_trashFactor[28][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[28][TRASH_PONGPONG]	= 8;
	pMe->endless_trashFactor[28][TRASH_WINDOW]		= 3;
	pMe->endless_trashFactor[28][TRASH_DESTSCORE]	= 28;

	pMe->endless_trashFactor[29][TRASH_WHOLETIME]	= 60000 + 10000;
	pMe->endless_trashFactor[29][TRASH_TRASHGAP]	= 1500;
	pMe->endless_trashFactor[29][TRASH_PONGPONG]	= 8;
	pMe->endless_trashFactor[29][TRASH_WINDOW]		= 3;
	pMe->endless_trashFactor[29][TRASH_DESTSCORE]	= 30;


	// ˿[Ѹ]
	
	pMe->endless_findFactor[0][FIND_WHOLETIME]		= 15000 + 10000; //ѽð
	pMe->endless_findFactor[0][FIND_MOVEGAP]		= 300; // ̴ ð 
	pMe->endless_findFactor[0][FIND_INPUTTIME]		= 2000; // Է ð
	pMe->endless_findFactor[0][FIND_MOVEMAX]		= 1; // ã  
	pMe->endless_findFactor[0][FIND_SPOTMAX]		= 3; // ÿ  Ʈ ִ
	pMe->endless_findFactor[0][FIND_DESTSCORE]		= 2; //   ãƳ ϴ

	pMe->endless_findFactor[1][FIND_WHOLETIME]		= 15000 + 10000;
	pMe->endless_findFactor[1][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[1][FIND_INPUTTIME]		= 2000;
	pMe->endless_findFactor[1][FIND_MOVEMAX]		= 1;
	pMe->endless_findFactor[1][FIND_SPOTMAX]		= 3;
	pMe->endless_findFactor[1][FIND_DESTSCORE]		= 3;

	pMe->endless_findFactor[2][FIND_WHOLETIME]		= 20000 + 10000;
	pMe->endless_findFactor[2][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[2][FIND_INPUTTIME]		= 2000;
	pMe->endless_findFactor[2][FIND_MOVEMAX]		= 2;
	pMe->endless_findFactor[2][FIND_SPOTMAX]		= 3;
	pMe->endless_findFactor[2][FIND_DESTSCORE]		= 4;

	pMe->endless_findFactor[3][FIND_WHOLETIME]		= 25000 + 10000;
	pMe->endless_findFactor[3][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[3][FIND_INPUTTIME]		= 2000;
	pMe->endless_findFactor[3][FIND_MOVEMAX]		= 2;
	pMe->endless_findFactor[3][FIND_SPOTMAX]		= 4;
	pMe->endless_findFactor[3][FIND_DESTSCORE]		= 4;

	pMe->endless_findFactor[4][FIND_WHOLETIME]		= 25000 + 10000;
	pMe->endless_findFactor[4][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[4][FIND_INPUTTIME]		= 2000;
	pMe->endless_findFactor[4][FIND_MOVEMAX]		= 3;
	pMe->endless_findFactor[4][FIND_SPOTMAX]		= 4;
	pMe->endless_findFactor[4][FIND_DESTSCORE]		= 4;

	pMe->endless_findFactor[5][FIND_WHOLETIME]		= 33000 + 10000;
	pMe->endless_findFactor[5][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[5][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[5][FIND_MOVEMAX]		= 3;
	pMe->endless_findFactor[5][FIND_SPOTMAX]		= 4;
	pMe->endless_findFactor[5][FIND_DESTSCORE]		= 4;

	pMe->endless_findFactor[6][FIND_WHOLETIME]		= 32000 + 10000;
	pMe->endless_findFactor[6][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[6][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[6][FIND_MOVEMAX]		= 4;
	pMe->endless_findFactor[6][FIND_SPOTMAX]		= 5;
	pMe->endless_findFactor[6][FIND_DESTSCORE]		= 4;

	pMe->endless_findFactor[7][FIND_WHOLETIME]		= 31000 + 10000;
	pMe->endless_findFactor[7][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[7][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[7][FIND_MOVEMAX]		= 4;
	pMe->endless_findFactor[7][FIND_SPOTMAX]		= 5;
	pMe->endless_findFactor[7][FIND_DESTSCORE]		= 5;

	pMe->endless_findFactor[8][FIND_WHOLETIME]		= 30000 + 10000;
	pMe->endless_findFactor[8][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[8][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[8][FIND_MOVEMAX]		= 4;
	pMe->endless_findFactor[8][FIND_SPOTMAX]		= 5;
	pMe->endless_findFactor[8][FIND_DESTSCORE]		= 5;

	pMe->endless_findFactor[9][FIND_WHOLETIME]		= 30000 + 10000;
	pMe->endless_findFactor[9][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[9][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[9][FIND_MOVEMAX]		= 4;
	pMe->endless_findFactor[9][FIND_SPOTMAX]		= 6;
	pMe->endless_findFactor[9][FIND_DESTSCORE]		= 5; 

	pMe->endless_findFactor[10][FIND_WHOLETIME]		= 30000 + 10000;
	pMe->endless_findFactor[10][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[10][FIND_INPUTTIME]		= 1000 + 10000;
	pMe->endless_findFactor[10][FIND_MOVEMAX]		= 4;
	pMe->endless_findFactor[10][FIND_SPOTMAX]		= 6;
	pMe->endless_findFactor[10][FIND_DESTSCORE]		= 5;

	pMe->endless_findFactor[11][FIND_WHOLETIME]		= 30000 + 10000;
	pMe->endless_findFactor[11][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[11][FIND_INPUTTIME]		= 1000 + 10000;
	pMe->endless_findFactor[11][FIND_MOVEMAX]		= 5;
	pMe->endless_findFactor[11][FIND_SPOTMAX]		= 6;
	pMe->endless_findFactor[11][FIND_DESTSCORE]		= 5;

	pMe->endless_findFactor[12][FIND_WHOLETIME]		= 35000 + 10000;
	pMe->endless_findFactor[12][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[12][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[12][FIND_MOVEMAX]		= 5;
	pMe->endless_findFactor[12][FIND_SPOTMAX]		= 6;
	pMe->endless_findFactor[12][FIND_DESTSCORE]		= 6;

	pMe->endless_findFactor[13][FIND_WHOLETIME]		= 34000 + 10000;
	pMe->endless_findFactor[13][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[13][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[13][FIND_MOVEMAX]		= 5;
	pMe->endless_findFactor[13][FIND_SPOTMAX]		= 6;
	pMe->endless_findFactor[13][FIND_DESTSCORE]		= 6;

	pMe->endless_findFactor[14][FIND_WHOLETIME]		= 33000 + 10000;
	pMe->endless_findFactor[14][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[14][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[14][FIND_MOVEMAX]		= 5;
	pMe->endless_findFactor[14][FIND_SPOTMAX]		= 6;
	pMe->endless_findFactor[14][FIND_DESTSCORE]		= 6;

	pMe->endless_findFactor[15][FIND_WHOLETIME]		= 29000 + 10000;
	pMe->endless_findFactor[15][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[15][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[15][FIND_MOVEMAX]		= 5;
	pMe->endless_findFactor[15][FIND_SPOTMAX]		= 6;
	pMe->endless_findFactor[15][FIND_DESTSCORE]		= 6;

	pMe->endless_findFactor[16][FIND_WHOLETIME]		= 29000 + 10000;
	pMe->endless_findFactor[16][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[16][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[16][FIND_MOVEMAX]		= 5;
	pMe->endless_findFactor[16][FIND_SPOTMAX]		= 6;
	pMe->endless_findFactor[16][FIND_DESTSCORE]		= 6;

	pMe->endless_findFactor[17][FIND_WHOLETIME]		= 29000 + 10000;
	pMe->endless_findFactor[17][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[17][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[17][FIND_MOVEMAX]		= 5;
	pMe->endless_findFactor[17][FIND_SPOTMAX]		= 6;
	pMe->endless_findFactor[17][FIND_DESTSCORE]		= 6;

	pMe->endless_findFactor[18][FIND_WHOLETIME]		= 29000 + 10000;
	pMe->endless_findFactor[18][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[18][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[18][FIND_MOVEMAX]		= 5;
	pMe->endless_findFactor[18][FIND_SPOTMAX]		= 6;
	pMe->endless_findFactor[18][FIND_DESTSCORE]		= 6;

	pMe->endless_findFactor[19][FIND_WHOLETIME]		= 29000 + 10000;
	pMe->endless_findFactor[19][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[19][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[19][FIND_MOVEMAX]		= 5;
	pMe->endless_findFactor[19][FIND_SPOTMAX]		= 6;
	pMe->endless_findFactor[19][FIND_DESTSCORE]		= 6;

	pMe->endless_findFactor[20][FIND_WHOLETIME]		= 28000 + 10000;
	pMe->endless_findFactor[20][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[20][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[20][FIND_MOVEMAX]		= 5;
	pMe->endless_findFactor[20][FIND_SPOTMAX]		= 6;
	pMe->endless_findFactor[20][FIND_DESTSCORE]		= 6;

	pMe->endless_findFactor[21][FIND_WHOLETIME]		= 28000 + 10000;
	pMe->endless_findFactor[21][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[21][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[21][FIND_MOVEMAX]		= 5;
	pMe->endless_findFactor[21][FIND_SPOTMAX]		= 6;
	pMe->endless_findFactor[21][FIND_DESTSCORE]		= 6;

	pMe->endless_findFactor[22][FIND_WHOLETIME]		= 28000 + 10000;
	pMe->endless_findFactor[22][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[22][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[22][FIND_MOVEMAX]		= 5;
	pMe->endless_findFactor[22][FIND_SPOTMAX]		= 6;
	pMe->endless_findFactor[22][FIND_DESTSCORE]		= 6;

	pMe->endless_findFactor[23][FIND_WHOLETIME]		= 28000 + 10000;
	pMe->endless_findFactor[23][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[23][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[23][FIND_MOVEMAX]		= 5;
	pMe->endless_findFactor[23][FIND_SPOTMAX]		= 6;
	pMe->endless_findFactor[23][FIND_DESTSCORE]		= 6;

	pMe->endless_findFactor[24][FIND_WHOLETIME]		= 28000 + 10000;
	pMe->endless_findFactor[24][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[24][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[24][FIND_MOVEMAX]		= 5;
	pMe->endless_findFactor[24][FIND_SPOTMAX]		= 6;
	pMe->endless_findFactor[24][FIND_DESTSCORE]		= 6;

	pMe->endless_findFactor[25][FIND_WHOLETIME]		= 27000 + 10000;
	pMe->endless_findFactor[25][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[25][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[25][FIND_MOVEMAX]		= 5;
	pMe->endless_findFactor[25][FIND_SPOTMAX]		= 6;
	pMe->endless_findFactor[25][FIND_DESTSCORE]		= 6;

	pMe->endless_findFactor[26][FIND_WHOLETIME]		= 27000 + 10000;
	pMe->endless_findFactor[26][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[26][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[26][FIND_MOVEMAX]		= 5;
	pMe->endless_findFactor[26][FIND_SPOTMAX]		= 6;
	pMe->endless_findFactor[26][FIND_DESTSCORE]		= 6;

	pMe->endless_findFactor[27][FIND_WHOLETIME]		= 27000 + 10000;
	pMe->endless_findFactor[27][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[27][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[27][FIND_MOVEMAX]		= 5;
	pMe->endless_findFactor[27][FIND_SPOTMAX]		= 6;
	pMe->endless_findFactor[27][FIND_DESTSCORE]		= 6;

	pMe->endless_findFactor[28][FIND_WHOLETIME]		= 27000 + 10000;
	pMe->endless_findFactor[28][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[28][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[28][FIND_MOVEMAX]		= 5;
	pMe->endless_findFactor[28][FIND_SPOTMAX]		= 6;
	pMe->endless_findFactor[28][FIND_DESTSCORE]		= 6;

	pMe->endless_findFactor[29][FIND_WHOLETIME]		= 27000 + 10000;
	pMe->endless_findFactor[29][FIND_MOVEGAP]		= 300;
	pMe->endless_findFactor[29][FIND_INPUTTIME]		= 1000;
	pMe->endless_findFactor[29][FIND_MOVEMAX]		= 5;
	pMe->endless_findFactor[29][FIND_SPOTMAX]		= 6;
	pMe->endless_findFactor[29][FIND_DESTSCORE]		= 6;

	// ı(丮,Ѹ)

	pMe->endless_digFactor[0][DIG_WHOLETIME]		= 25000 + 20000;
	pMe->endless_digFactor[0][DIG_GUARDNUM]			= 1;
	pMe->endless_digFactor[0][DIG_GUARDGAP]			= 800;	
	pMe->endless_digFactor[0][DIG_DESTDIRT]			= 40;

	pMe->endless_digFactor[1][DIG_WHOLETIME]		= 24000 + 20000;
	pMe->endless_digFactor[1][DIG_GUARDNUM]			= 1;
	pMe->endless_digFactor[1][DIG_GUARDGAP]			= 800;
	pMe->endless_digFactor[1][DIG_DESTDIRT]			= 45;

	pMe->endless_digFactor[2][DIG_WHOLETIME]		= 23000 + 20000;
	pMe->endless_digFactor[2][DIG_GUARDNUM]			= 1;
	pMe->endless_digFactor[2][DIG_GUARDGAP]			= 700;
	pMe->endless_digFactor[2][DIG_DESTDIRT]			= 50;

	pMe->endless_digFactor[3][DIG_WHOLETIME]		= 20000 + 20000;
	pMe->endless_digFactor[3][DIG_GUARDNUM]			= 1;
	pMe->endless_digFactor[3][DIG_GUARDGAP]			= 600;
	pMe->endless_digFactor[3][DIG_DESTDIRT]			= 60;

	pMe->endless_digFactor[4][DIG_WHOLETIME]		= 30000 + 20000;
	pMe->endless_digFactor[4][DIG_GUARDNUM]			= 1;
	pMe->endless_digFactor[4][DIG_GUARDGAP]			= 600;
	pMe->endless_digFactor[4][DIG_DESTDIRT]			= 65;

	pMe->endless_digFactor[5][DIG_WHOLETIME]		= 29000 + 20000;
	pMe->endless_digFactor[5][DIG_GUARDNUM]			= 1;
	pMe->endless_digFactor[5][DIG_GUARDGAP]			= 600;
	pMe->endless_digFactor[5][DIG_DESTDIRT]			= 70;

	pMe->endless_digFactor[6][DIG_WHOLETIME]		= 28000 + 20000;
	pMe->endless_digFactor[6][DIG_GUARDNUM]			= 1;
	pMe->endless_digFactor[6][DIG_GUARDGAP]			= 600;
	pMe->endless_digFactor[6][DIG_DESTDIRT]			= 75;

	pMe->endless_digFactor[7][DIG_WHOLETIME]		= 30000 + 20000;
	pMe->endless_digFactor[7][DIG_GUARDNUM]			= 1;
	pMe->endless_digFactor[7][DIG_GUARDGAP]			= 500;
	pMe->endless_digFactor[7][DIG_DESTDIRT]			= 80;

	pMe->endless_digFactor[8][DIG_WHOLETIME]		= 29000 + 20000;
	pMe->endless_digFactor[8][DIG_GUARDNUM]			= 1;
	pMe->endless_digFactor[8][DIG_GUARDGAP]			= 500;
	pMe->endless_digFactor[8][DIG_DESTDIRT]			= 85;

	pMe->endless_digFactor[9][DIG_WHOLETIME]		= 28000 + 20000;
	pMe->endless_digFactor[9][DIG_GUARDNUM]			= 1;
	pMe->endless_digFactor[9][DIG_GUARDGAP]			= 500; 
	pMe->endless_digFactor[9][DIG_DESTDIRT]			= 90;

	pMe->endless_digFactor[10][DIG_WHOLETIME]		= 35000 + 20000;
	pMe->endless_digFactor[10][DIG_GUARDNUM]		= 1;
	pMe->endless_digFactor[10][DIG_GUARDGAP]		= 500;
	pMe->endless_digFactor[10][DIG_DESTDIRT]		= 95;

	pMe->endless_digFactor[11][DIG_WHOLETIME]		= 35000 + 20000;
	pMe->endless_digFactor[11][DIG_GUARDNUM]		= 1;
	pMe->endless_digFactor[11][DIG_GUARDGAP]		= 400;
	pMe->endless_digFactor[11][DIG_DESTDIRT]		= 105;

	pMe->endless_digFactor[12][DIG_WHOLETIME]		= 35000 + 20000;
	pMe->endless_digFactor[12][DIG_GUARDNUM]		= 1;
	pMe->endless_digFactor[12][DIG_GUARDGAP]		= 400;
	pMe->endless_digFactor[12][DIG_DESTDIRT]		= 115;

	pMe->endless_digFactor[13][DIG_WHOLETIME]		= 35000 + 20000;
	pMe->endless_digFactor[13][DIG_GUARDNUM]		= 1;
	pMe->endless_digFactor[13][DIG_GUARDGAP]		= 400;
	pMe->endless_digFactor[13][DIG_DESTDIRT]		= 125;

	pMe->endless_digFactor[14][DIG_WHOLETIME]		= 45000 + 20000;
	pMe->endless_digFactor[14][DIG_GUARDNUM]		= 2;
	pMe->endless_digFactor[14][DIG_GUARDGAP]		= 400;
	pMe->endless_digFactor[14][DIG_DESTDIRT]		= 84;

	pMe->endless_digFactor[15][DIG_WHOLETIME]		= 44000 + 20000;
	pMe->endless_digFactor[15][DIG_GUARDNUM]		= 2;
	pMe->endless_digFactor[15][DIG_GUARDGAP]		= 400;
	pMe->endless_digFactor[15][DIG_DESTDIRT]		= 88;

	pMe->endless_digFactor[16][DIG_WHOLETIME]		= 43000 + 20000;
	pMe->endless_digFactor[16][DIG_GUARDNUM]		= 2;
	pMe->endless_digFactor[16][DIG_GUARDGAP]		= 300;
	pMe->endless_digFactor[16][DIG_DESTDIRT]		= 88;

	pMe->endless_digFactor[17][DIG_WHOLETIME]		= 42000 + 20000;
	pMe->endless_digFactor[17][DIG_GUARDNUM]		= 2;
	pMe->endless_digFactor[17][DIG_GUARDGAP]		= 300;
	pMe->endless_digFactor[17][DIG_DESTDIRT]		= 92;

	pMe->endless_digFactor[18][DIG_WHOLETIME]		= 41000 + 20000;
	pMe->endless_digFactor[18][DIG_GUARDNUM]		= 2;
	pMe->endless_digFactor[18][DIG_GUARDGAP]		= 300;
	pMe->endless_digFactor[18][DIG_DESTDIRT]		= 92;

	pMe->endless_digFactor[19][DIG_WHOLETIME]		= 40000 + 20000;
	pMe->endless_digFactor[19][DIG_GUARDNUM]		= 2;
	pMe->endless_digFactor[19][DIG_GUARDGAP]		= 300;
	pMe->endless_digFactor[19][DIG_DESTDIRT]		= 96;


}

// change global game state.
void SETSTATE(CMoso* pMe,byte state)
{
	pMe->gPrevState		= pMe->gState;
	pMe->gState			= state;
}


// Namo Tick & Draw
void namoTick(CMoso* pMe)
{
	if( pMe->imgHappyLogo1.bitmap == NULL )
	{
		loadImage(pMe,&pMe->imgHappyLogo1,MOSO_RES_FILE,IDB_HAPPYLOGO1);
		loadImage(pMe,&pMe->imgHappyLogo2,MOSO_RES_FILE,IDB_HAPPYLOGO2);
		loadImage(pMe,&pMe->imgHappyLogo3,MOSO_RES_FILE,IDB_HAPPYLOGO3);
		loadImage(pMe,&pMe->imgHappyLogo4,MOSO_RES_FILE,IDB_HAPPYLOGO4);
		loadImage(pMe,&pMe->imgHappyLogo5,MOSO_RES_FILE,IDB_HAPPYLOGO5);

		pMe->logoState	= HAPPYLOGO_STATE1;			
		pMe->logoFrame	= pMe->logoState1Frame;
		pMe->startTime	= GET_UPTIMEMS();
	}
}

void namoDraw(CMoso* pMe)
{
	int x,y,dx,dy;

	setScreen(pMe);	

	if( pMe->logoState == HAPPYLOGO_STATE1 ) {
		if( (GET_UPTIMEMS() - pMe->startTime) > pMe->logoTimeGap ) {
			pMe->startTime = GET_UPTIMEMS();
			--pMe->logoFrame;
		}

		fillRect(pMe,0,0,pMe->canvas_width,pMe->canvas_height,RGB(255,255,255));

		x = 0;
		y = pMe->canvas_height/2 - pMe->logoHeight/2;
		dx = pMe->canvas_width;
		dy = pMe->logoHeight;
		setClip(pMe,x,y,dx,dy);		

		x = pMe->canvas_width/2 + 4;
		y = pMe->canvas_height/2 - 2*pMe->logoFrame;
		drawImage2(pMe,&pMe->imgHappyLogo1,x,y,GFX_VCENTER|GFX_RIGHT);


		x = pMe->canvas_width/2 + 4;
		y = pMe->canvas_height/2 + 2*pMe->logoFrame;
		drawImage2(pMe,&pMe->imgHappyLogo2,x,y,GFX_VCENTER|GFX_LEFT);

		if( pMe->logoFrame == 0 ) {
			pMe->logoState	= HAPPYLOGO_STATE2;
			pMe->logoFrame	= pMe->logoState2Frame;
			pMe->startTime	= GET_UPTIMEMS();
		}
	}
	else if( pMe->logoState == HAPPYLOGO_STATE2 ) {
		if( (GET_UPTIMEMS() - pMe->startTime) > pMe->logoTimeGap ) {
			pMe->startTime = GET_UPTIMEMS();
			--pMe->logoFrame;
		}

		//  ׸ ׷ Ѵ.  Ž   .
		fillRect(pMe,0,0,pMe->canvas_width,pMe->canvas_height,RGB(255,255,255));
		drawImage2(pMe,&pMe->imgHappyLogo1,pMe->canvas_width/2 + 4,pMe->canvas_height/2,GFX_VCENTER|GFX_RIGHT);	// ΰ 
		drawImage2(pMe,&pMe->imgHappyLogo2,pMe->canvas_width/2 + 4,pMe->canvas_height/2,GFX_VCENTER|GFX_LEFT);	// ΰ 
		// 

		x = pMe->canvas_width/2 - 25;
		y = pMe->canvas_height/2 + 9;
		dx = 2*(pMe->logoState2Frame - pMe->logoFrame);
		dy = 4;

		setClip(pMe,x,y,dx,dy);
		drawImage2(pMe,&pMe->imgHappyLogo3,x,y,GFX_TOP|GFX_LEFT);

		if( pMe->logoFrame == 0 ) {
			pMe->logoState	= HAPPYLOGO_STATE3;
			pMe->logoFrame	= pMe->logoState3Frame;
			pMe->startTime	= GET_UPTIMEMS();
		}
	}
	else if( pMe->logoState == HAPPYLOGO_STATE3 ) {
		if( (GET_UPTIMEMS() - pMe->startTime) > pMe->logoTimeGap ) {
			pMe->startTime = GET_UPTIMEMS();
			--pMe->logoFrame;
		}

		//  ׸ ׷ Ѵ.  Ž   .
		fillRect(pMe,0,0,pMe->canvas_width,pMe->canvas_height,RGB(255,255,255));
		drawImage2(pMe,&pMe->imgHappyLogo1,pMe->canvas_width/2 + 4,pMe->canvas_height/2,GFX_VCENTER|GFX_RIGHT);		// ΰ 
		drawImage2(pMe,&pMe->imgHappyLogo2,pMe->canvas_width/2 + 4,pMe->canvas_height/2,GFX_VCENTER|GFX_LEFT);		// ΰ 
		drawImage2(pMe,&pMe->imgHappyLogo3,pMe->canvas_width/2 - 25,pMe->canvas_height/2 + 9,GFX_TOP|GFX_LEFT);	// ԰ 
		// 


		x = pMe->canvas_width/2 + 50;
		y = pMe->canvas_height/2 - 9;
		dx = 2*(pMe->logoState2Frame - pMe->logoFrame);
		dy = 10;

		if( pMe->logoFrame == 2 ) {
			setClip(pMe,x,y,dx,dy);
			drawImage2(pMe,&pMe->imgHappyLogo4,x,y,GFX_TOP|GFX_LEFT);
		}
		else if( pMe->logoFrame == 1 ) {
			setClip(pMe,x,y,dx,dy);
			drawImage2(pMe,&pMe->imgHappyLogo5,x,y,GFX_TOP|GFX_LEFT);
		}

		if( pMe->logoFrame == 0 ) {
			setClip(pMe,x,y,dx,dy);
			drawImage2(pMe,&pMe->imgHappyLogo5,x,y,GFX_TOP|GFX_LEFT);

			pMe->logoState	= HAPPYLOGO_STATE4;
			pMe->logoFrame	= pMe->logoState2Frame;
			pMe->startTime	= GET_UPTIMEMS();
		}
	}
	else if( pMe->logoState == HAPPYLOGO_STATE4 ) {
		if( (GET_UPTIMEMS() - pMe->startTime) > 3000 ||
			 (pMe->keyCurr != GKEY_NONE) ) {
			//System.out.println("ٸ State Ѿ.");

			//
			freeImage(pMe,&pMe->imgHappyLogo1);
			freeImage(pMe,&pMe->imgHappyLogo2);
			freeImage(pMe,&pMe->imgHappyLogo3);
			freeImage(pMe,&pMe->imgHappyLogo4);
			freeImage(pMe,&pMe->imgHappyLogo5);
		
			// prevent constant key input
			pMe->keyCurr = GKEY_NONE;
  
			SETSTATE(pMe,STATE_DAUM);
		}
	}
	

}
//=====================================

// Daum Tick & Draw
void daumTick(CMoso* pMe)
{
	if( pMe->imgTemp.bitmap == NULL )
	{
		loadImage(pMe,&pMe->imgTemp,MOSO_RES_FILE,IDB_STAFFDAUM);

		pMe->startTime = GET_UPTIMEMS();
	}
}

void daumDraw(CMoso* pMe)
{
	int y;

	setScreen(pMe);
	fillRect(pMe,0,0,pMe->canvas_width,pMe->canvas_height,RGB(0,0,0));

	setColor(pMe,255,255,255);
	y = (pMe->canvas_height < 180) ? 20 : 50; // 1,2,3   ġ 5 ٸ ġ ش.
	drawImage2(pMe,&pMe->imgTemp,pMe->canvas_midx,y,GFX_HCENTER|GFX_TOP);


	y += pMe->imgTemp.info.cy + 10;
	drawString(pMe,"www.daum.net",pMe->canvas_midx,y,GFX_CENTER);

	y += pMe->font_h;
	drawString(pMe,"Published by Daum",pMe->canvas_midx,y,GFX_CENTER);

	y += pMe->font_h;
	drawString(pMe,"All rights reserved",pMe->canvas_midx,y,GFX_CENTER);

	if( GET_UPTIMEMS() - pMe->startTime > LOGOSHOW || pMe->keyCurr & GKEY_ANYKEY )
	{
		// prevent constant key input
		pMe->keyCurr = GKEY_NONE;

		freeImage(pMe,&pMe->imgTemp);
		SETSTATE(pMe,STATE_INTRO);
	}
}
//=====================================


// Intro Tick & Draw
void introTick(CMoso* pMe)
{
	if( pMe->imgTemp.bitmap == NULL )
	{
		if( pMe->canvas_height < 130 )
			loadImage(pMe,&pMe->imgTemp,MOSO_RES_FILE,IDB_INTRO1);
		else if( pMe->canvas_height < 160 )
			loadImage(pMe,&pMe->imgTemp,MOSO_RES_FILE,IDB_INTRO2);
		else
			loadImage(pMe,&pMe->imgTemp,MOSO_RES_FILE,IDB_INTRO3);


		pMe->startTime = GET_UPTIMEMS();
	}
}

void introDraw(CMoso* pMe)
{
	setScreen(pMe);

	fillRect(pMe,0,0,pMe->canvas_width,pMe->canvas_height,RGB(0,0,0));

	//  
	drawImage2(pMe,&pMe->imgTemp,pMe->canvas_midx,0,GFX_HCENTER|GFX_TOP);

	setColor(pMe,255,255,255);
	drawString(pMe,pMe->vstr,pMe->canvas_midx,pMe->canvas_height- pMe->font_h,GFX_HCENTER|GFX_TOP);

	//if( GET_UPTIMEMS() - pMe->startTime > LOGOSHOW || pMe->keyCurr & GKEY_ANYKEY)
	if( pMe->keyCurr & GKEY_ANYKEY)
	{
		// prevent constant key input
		pMe->keyCurr = GKEY_NONE;

		freeImage(pMe,&pMe->imgTemp);
		SETSTATE(pMe,STATE_MENULOAD);

		//LogHeapStatsToFile(pMe,1);
	}
}
//=====================================


// Load Tick & Draw
void menuloadTick(CMoso* pMe)
{
	switch( pMe->loadState )
	{
		// read number image and get number of images will be read.
		case LSTATE_NUMIMAGE : 
			// get number of resources will be read.
			// and set flag to zero.
			pMe->numResource	= pMe->imgNum;
			pMe->currRead		= 0;
			pMe->totalRead		= 0;

			// change state.
			pMe->loadState		= LSTATE_SOUND;
			break;

		case LSTATE_SOUND:
			//   ϸ  κ ʿ ..
//			GameSound_InitAllSounds(pMe);

			pMe->currRead	= 0;
			pMe->loadState	= LSTATE_GAMEIMAGE;
			break;

		// read game image when loadState 2
		case LSTATE_GAMEIMAGE:
			// if load game image have done, move to further state.
			if( pMe->currRead >= pMe->imgNum )
			{
				// free image 
				freeImage(pMe,&pMe->imgLoadBg);
				freeImage(pMe,&pMe->imgLoading);
				freeImage(pMe,&pMe->imgLoadbar);
				freeImage(pMe,&pMe->imgLoadbarBg);


				///*
				// 
				// go next global game sate when load resource done.

				//LogHeapStatsToFile(pMe,2);

				menuInit(pMe);
				SETSTATE(pMe,STATE_MENU);
				//*/

				//  Ǽҵ  Ǵ Ȯغ ..
				/*
				episodeInit(pMe,6);
				SETSTATE(pMe,STATE_EPISODE);
				*/


				//selectInit(pMe);
				//SETSTATE(pMe,STATE_SELECT);

				
			}
			else
			{
				int resID;
				resID = pMe->resIDGame[pMe->currRead];
				loadImage(pMe,&pMe->imgGame[pMe->currRead],MOSO_RES_FILE,resID);

				// go next image
				pMe->currRead++;
				pMe->totalRead++;
			}
			break;
	}
}

void menuloadDraw(CMoso* pMe)
{
	int percent;
	int i,j;
	int x,y,dx,dy;
	int nx,ny;

	if( pMe->load_backDraw == FALSE ) 
	{
		loadImage(pMe,&pMe->imgLoadBg,MOSO_RES_FILE,IDB_STATUSBG);
		loadImage(pMe,&pMe->imgLoading,MOSO_RES_FILE,IDB_TXTLOADING);
		loadImage(pMe,&pMe->imgLoadbar,MOSO_RES_FILE,IDB_GAUGELOADING);
		loadImage(pMe,&pMe->imgLoadbarBg,MOSO_RES_FILE,IDB_GAUGELOADINGBG);		


		setScreen(pMe);

		dx = pMe->imgLoadBg.info.cx;
		dy = pMe->imgLoadBg.info.cy;

		nx = pMe->canvas_width / dx;
		ny = pMe->canvas_height / dy;

		for(i=0;i<=nx;++i)
			for(j=0;j<=ny;++j)
				drawImage2(pMe,&pMe->imgLoadBg,i*dx,j*dy,GFX_LEFTTOP);

		// draw loading text
		x = pMe->canvas_midx;
		y = pMe->canvas_midy;		
		drawImage2(pMe,&pMe->imgLoading,x,y,GFX_CENTER);


		dx = pMe->imgLoadbarBg.info.cx;
		dy = pMe->imgLoadbarBg.info.cy;
		x	= pMe->canvas_midx - dx/2;
		y	= pMe->canvas_midy + dy;

		// draw gauge background
		setClip(pMe,0,0,dx,dy);
		setClip(pMe,x,y,dx,dy);
		drawImage2(pMe,&pMe->imgLoadbar,x,y,GFX_LEFT);

		pMe->load_backDraw = TRUE;
	}

	// draw gauge
	dx	= pMe->imgLoadbarBg.info.cx;
	dy	= pMe->imgLoadbarBg.info.cy;
	x	= pMe->canvas_midx - dx/2;
	y	= pMe->canvas_midy + dy;


	percent = (pMe->totalRead << 8) / pMe->numResource;
	percent = ( percent *  dx ) >> 8;

	setClip(pMe,x,y,percent,dy);
	drawImage2(pMe,&pMe->imgLoadbarBg,x,y,GFX_LEFT);


	// prevent constant key input
	pMe->keyCurr = GKEY_NONE;
}
//=====================================


void morningepisodeTick(CMoso* pMe)
{
#if CHEAT_SKIP_EPISODE
	selectInit(pMe);
	SETSTATE(pMe,STATE_SELECT);
	return;
#endif

	switch(pMe->story_day)
	{
		// 1 day
		case 0:
			episodeInit(pMe,1);
			SETSTATE(pMe,STATE_EPISODE);
			break;

		// 3 day
		case 2:
			episodeInit(pMe,3);
			SETSTATE(pMe,STATE_EPISODE);
			break;

		default:
			selectInit(pMe);
			SETSTATE(pMe,STATE_SELECT);
			break;
	}
}

void morningepisodeDraw(CMoso* pMe)
{
}

void nightepisodeTick(CMoso* pMe)
{
#if CHEAT_SKIP_EPISODE
	digInit(pMe);
	SETSTATE(pMe,STATE_DIG);
	return;
#endif

	//  10 ʹٸ   2 ȴٴ  Ѵ.
	if( pMe->story_stage == 10 && !pMe->story_2guard ) {	// 11 ° ̰   ٸ.
		pMe->story_2guard = TRUE;

		episodeInit(pMe,5);
		SETSTATE(pMe,STATE_EPISODE);
		return;
	}

	//  19 ʹٸ   3 ȴٴ  Ѵ.
	if( pMe->story_stage == 18 && !pMe->story_3guard ) {	// 19 ° ̰   ٸ.
		pMe->story_3guard = TRUE;

		episodeInit(pMe,8);
		SETSTATE(pMe,STATE_EPISODE);
		return;
	}


	switch(pMe->story_day)
	{
		// 1 day
		case 0:
			episodeInit(pMe,2);
			SETSTATE(pMe,STATE_EPISODE);
			break;

		// 7 day
		case 6:
			episodeInit(pMe,4);
			SETSTATE(pMe,STATE_EPISODE);
			break;
/*
		// 11 day
		case 10:
			episodeInit(pMe,5);
			SETSTATE(pMe,STATE_EPISODE);
			break;
			*/

		// 14 day
		case 13:
			episodeInit(pMe,6);
			SETSTATE(pMe,STATE_EPISODE);
			break;

		// 18 day
		case 17:
			episodeInit(pMe,7);
			SETSTATE(pMe,STATE_EPISODE);
			break;
/*
		// 20 day
		case 19:
			episodeInit(pMe,8);
			SETSTATE(pMe,STATE_EPISODE);
			break;
			*/

		default:
			digInit(pMe);
			SETSTATE(pMe,STATE_DIG);
			break;
	}
}

void nightepisodeDraw(CMoso* pMe)
{
}

void episodeTick(CMoso* pMe)
{
}

void episodeInit(CMoso* pMe,int episode)
{
	if( pMe->episode_init == FALSE )
	{
		int img1,img2,img3;

		pMe->episode_init = TRUE;		

		switch( episode )
		{
			// episode #1
			case 1:
				img1 = IDB_EPISODEHERO;
				img2 = IDB_EPISODEGUARD;
				img3 = IDB_EPISODEBG;

				pMe->episode_text		= pMe->episode_caption1;
				pMe->episode_lineNum	= EPISODE1_NUMLINE;
				pMe->episode_Direction	= EPISODE_LEFT;
				break;

			// episode #2
			case 2:
				img1 = IDB_EPISODEHERO;
				img2 = IDB_EPISODESHADOW;
				img3 = IDB_EPISODEWEAPON;

				pMe->episode_text		= pMe->episode_caption2;
				pMe->episode_lineNum	= EPISODE2_NUMLINE;
				pMe->episode_Direction	= EPISODE_LEFT;
				break;

			// episode #3
			case 3:
				img1 = IDB_EPISODEHERO;
				img2 = IDB_EPISODESHADOW;
				img3 = IDB_EPISODEITEM;

				pMe->episode_text		= pMe->episode_caption3;
				pMe->episode_lineNum	= EPISODE3_NUMLINE;
				pMe->episode_Direction	= EPISODE_RIGHT;
				break;

			// episode #4
			case 4:
				img1 = IDB_EPISODEHERO;
				img2 = IDB_EPISODESHADOW;
				img3 = IDB_EPISODEBG;

				pMe->episode_text		= pMe->episode_caption4;
				pMe->episode_lineNum	= EPISODE4_NUMLINE;
				pMe->episode_Direction	= EPISODE_LEFT;
				break;

			// episode #5
			case 5:
				img1 = IDB_EPISODEHERO;
				img2 = IDB_EPISODESHADOW;
				img3 = IDB_EPISODECRY;

				pMe->episode_text		= pMe->episode_caption5;
				pMe->episode_lineNum	= EPISODE5_NUMLINE;
				pMe->episode_Direction	= EPISODE_RIGHT;
				break;

			// episode #6
			case 6:
				img1 = IDB_EPISODEHERO;
				img2 = IDB_EPISODESHADOW;
				img3 = IDB_EPISODEFIELD;

				pMe->episode_text		= pMe->episode_caption6;
				pMe->episode_lineNum	= EPISODE6_NUMLINE;
				pMe->episode_Direction	= EPISODE_LEFT;
				break;

			// episode #7
			case 7:
				img1 = IDB_EPISODEHERO;
				img2 = IDB_EPISODESHADOW;
				img3 = IDB_EPISODEREST;

				pMe->episode_text		= pMe->episode_caption7;
				pMe->episode_lineNum	= EPISODE7_NUMLINE;
				pMe->episode_Direction	= EPISODE_RIGHT;
				break;


			// episode #8
			case 8:
				img1 = IDB_EPISODEHERO;
				img2 = IDB_EPISODESHADOW;
				img3 = IDB_EPISODEFINAL;

				pMe->episode_text		= pMe->episode_caption8;
				pMe->episode_lineNum	= EPISODE8_NUMLINE;
				pMe->episode_Direction	= EPISODE_LEFT;
				break;


			// episode #9
			case 9:
				img1 = IDB_EPISODEHERO;
				img2 = IDB_EPISODESHADOW;
				img3 = IDB_EPISODEEND;

				pMe->episode_text		= pMe->episode_caption9;
				pMe->episode_lineNum	= EPISODE9_NUMLINE;
				pMe->episode_Direction	= EPISODE_RIGHT;
				break;

			// episode #10
			case 10:
				img1 = IDB_EPISODEHERO;
				img2 = IDB_EPISODESHADOW;
				img3 = IDB_EPISODEBG;

				pMe->episode_text		= pMe->episode_caption10;
				pMe->episode_lineNum	= EPISODE10_NUMLINE;
				pMe->episode_Direction	= EPISODE_RIGHT;
				break;

			// episode #11
			case 11:
				img1 = IDB_EPISODEHERO;
				img2 = IDB_EPISODESHADOW;
				img3 = IDB_RESULTITEM1;

				pMe->episode_text		= pMe->episode_caption11;
				pMe->episode_lineNum	= EPISODE11_NUMLINE;
				pMe->episode_Direction	= EPISODE_RIGHT;
				break;

			// episode #12
			case 12:
				img1 = IDB_EPISODEHERO;
				img2 = IDB_EPISODESHADOW;
				img3 = IDB_RESULTITEM2;

				pMe->episode_text		= pMe->episode_caption12;
				pMe->episode_lineNum	= EPISODE12_NUMLINE;
				pMe->episode_Direction	= EPISODE_RIGHT;
				break;

			// episode #13
			case 13:
				img1 = IDB_EPISODEHERO;
				img2 = IDB_EPISODESHADOW;
				img3 = IDB_RESULTITEM3;

				pMe->episode_text		= pMe->episode_caption13;
				pMe->episode_lineNum	= EPISODE13_NUMLINE;
				pMe->episode_Direction	= EPISODE_RIGHT;
				break;

			// episode #14
			case 14:
				img1 = IDB_EPISODEHERO;
				img2 = IDB_EPISODESHADOW;
				img3 = IDB_RESULTITEM4;

				pMe->episode_text		= pMe->episode_caption14;
				pMe->episode_lineNum	= EPISODE14_NUMLINE;
				pMe->episode_Direction	= EPISODE_RIGHT;
				break;
		}


		loadImage(pMe,&pMe->episode_leftImage,MOSO_RES_FILE,img1);
		loadImage(pMe,&pMe->episode_rightImage,MOSO_RES_FILE,img2);
		loadImage(pMe,&pMe->episode_bgImage,MOSO_RES_FILE,img3);

		pMe->episode_leftstep	= pMe->episode_leftImage.info.cx/4;
		pMe->episode_rightstep	= pMe->episode_rightImage.info.cx/4;

		pMe->episode_backDraw	= FALSE;
		pMe->startTime			= GET_UPTIMEMS();

		pMe->episode_line		= 0; //   Ѹ  ߶..
		pMe->episode_ani		= -1;


		// ġ .
		pMe->episode_left_x = 0;
		pMe->episode_left_y = pMe->canvas_height - EPISODE_HEIGHT;
		pMe->episode_right_x = pMe->canvas_width;
		pMe->episode_right_y = pMe->canvas_height - EPISODE_HEIGHT;
		pMe->episode_dx = pMe->canvas_width;	// ణ ġ ڵ ־ 7 ش.
		pMe->episode_dy = EPISODE_HEIGHT;
	}
}

void episodeEnd(CMoso* pMe)
{
	pMe->episode_init = FALSE;

	freeImage(pMe,&pMe->episode_leftImage);
	freeImage(pMe,&pMe->episode_rightImage);
	freeImage(pMe,&pMe->episode_bgImage);
}

void episodeDraw(CMoso* pMe)
{
	int x,y,dx,dy;

	setScreen(pMe);
	episodeDrawBg(pMe);

	if( pMe->episode_leftImage.bitmap != NULL )
	{
		//  ȭ ȳ.
		if( pMe->episode_line < pMe->episode_lineNum )
		{
			// ִϸ̼   ʾҴٸ..
			if( pMe->episode_ani < EPISODE_ANIMATION )
			{
				// ð .
				//if( GET_UPTIMEMS() - pMe->startTime > 500 )
				//{
					if( pMe->episode_Direction == EPISODE_LEFT )
					{                                                                                  
						x = pMe->episode_left_x + pMe->episode_ani*pMe->episode_leftstep;
						y = pMe->episode_left_y;
						dx = pMe->episode_leftImage.info.cx;
						dy = pMe->episode_leftImage.info.cy;

						// -1   ѹ ĳ  ׷ .
						if( pMe->episode_ani != -1 )
						{
							setClip(pMe,x-dx,y-dy,dx,dy);
							pMe->episode_backDraw = FALSE;
							episodeDrawBg(pMe);
						}


						pMe->episode_ani++;
						setScreen(pMe);
						drawImage2(pMe,
								  &pMe->episode_leftImage,
								  pMe->episode_left_x + pMe->episode_ani*pMe->episode_leftstep,
								  pMe->episode_left_y,
								  GFX_RIGHT|GFX_BOTTOM);
					}
					else if( pMe->episode_Direction == EPISODE_RIGHT )
					{
						x = pMe->episode_right_x - pMe->episode_ani*pMe->episode_rightstep;
						y = pMe->episode_right_y;
						dx = pMe->episode_rightImage.info.cx;
						dy = pMe->episode_rightImage.info.cy;

						if( pMe->episode_ani != -1 )
						{
							setClip(pMe,x,y-dy,dx,dy);
							pMe->episode_backDraw = FALSE;
							episodeDrawBg(pMe);
						}

						pMe->episode_ani++;
						setScreen(pMe);
						drawImage2(pMe,
								  &pMe->episode_rightImage,
								  pMe->episode_right_x - pMe->episode_ani*pMe->episode_rightstep,
								  pMe->episode_right_y,
								  GFX_LEFT|GFX_BOTTOM);						

					}

					pMe->startTime = GET_UPTIMEMS();
					//pMe->episode_ani++;
				//}
				return;
			}

			// ִϸ̼   ȭ ֱ.
			else
			{
				// ִϸ̼  ٸ ĳ͵ ش.
				//     ⼭ ׷  ȴ.
				if( pMe->episode_Direction == EPISODE_LEFT )
				{
					drawImage2(pMe,
							  &pMe->episode_leftImage,
							  pMe->episode_left_x + pMe->episode_ani*pMe->episode_leftstep,
							  pMe->episode_left_y,
							  GFX_RIGHT|GFX_BOTTOM);
				}
				else if( pMe->episode_Direction == EPISODE_RIGHT )
				{
						drawImage2(pMe,
								  &pMe->episode_rightImage,
								  pMe->episode_right_x - pMe->episode_ani*pMe->episode_rightstep,
								  pMe->episode_right_y,
								  GFX_LEFT|GFX_BOTTOM);	
				}

				setColor(pMe,255,255,255);
				initText(pMe,
						 pMe->episode_text[pMe->episode_line],
						 pMe->episode_dx-7,
						 pMe->episode_dy,GFX_LEFT);				
				drawText(pMe,
						 pMe->episode_left_x,
						 pMe->episode_left_y+2,
						 pMe->episode_dx-7,
						 pMe->episode_dy,
						 FALSE);
			}
		}	
		// Ǽҵ尡 ٸ..
		// ⼭   ..
		else if( pMe->episode_line == pMe->episode_lineNum )
		{
			episodeEnd(pMe);

			if( pMe->gPrevState	== STATE_MORNINGEPISODE )
			{
				selectInit(pMe);
				SETSTATE(pMe,STATE_SELECT);
			}
			else if( pMe->gPrevState == STATE_NIGHTEPISODE )
			{
				digInit(pMe);
				SETSTATE(pMe,STATE_DIG);
			}
			//   â Ȥ ˿  ϰ  ̽
			//  ȹ    ̴̽.
			else if( pMe->gPrevState == STATE_TRASH || pMe->gPrevState == STATE_FIND )
			{
				SETSTATE(pMe,STATE_NIGHTEPISODE);
			}
			//    İ     Ǽҵ  ִµ ׶   .
			else if( pMe->gPrevState == STATE_DIG )
			{
				SETSTATE(pMe,STATE_DAILY);
			}
			//      Ǽҵ尡   ߻ ̴.
			// ̶ ޴ ư ȴ.
			else if( pMe->gPrevState == STATE_ANISTORY )
			{
				gotoMenu(pMe,MSTATE_MAIN);
				SETSTATE(pMe,STATE_MENU);
			}

			return;
		}

		// ڰ Ű ٸ..
		if( pMe->keyCurr & GKEY_SOFT3 )
		{
			int x,y,dx,dy;
			int idx,idy; // image dx, image dy

			pMe->text_Draw = FALSE;
		
			// ؽƮ   ڸ ش.
			setClip(pMe,
					 pMe->episode_left_x,
					 pMe->episode_left_y,
					 pMe->episode_dx,
					 pMe->episode_dy );
			pMe->episode_backDraw = FALSE;
			episodeDrawBg(pMe);

			// ȭ  ̸..
			if( pMe->text_reachEnd == TRUE )
			{
				// ؽƮ  Ǿ ִ ..
				stopText(pMe);

				
				// ׷ ִ ĳ  ش.
				if( pMe->episode_line != pMe->episode_lineNum )
				{
					if( pMe->episode_Direction == EPISODE_LEFT )
					{
						idx = pMe->episode_leftImage.info.cx;
						idy = pMe->episode_leftImage.info.cy;

						x = pMe->episode_left_x;
						y = pMe->episode_left_y - idy;
						dx = idx;
						dy = idy;				
					}
					else// if( pMe->episode_Direction == EPISODE_RIGHT )
					{
						idx = pMe->episode_rightImage.info.cx;
						idy = pMe->episode_rightImage.info.cy;

						x = pMe->episode_right_x - idx;
						y = pMe->episode_right_y - idy;
						dx = idx;
						dy = idy;
					}
					setClip(pMe,x,y,dx,dy);
					pMe->episode_backDraw = FALSE;
					episodeDrawBg(pMe);
				}


				pMe->episode_ani = -1;
				pMe->episode_Direction = ( pMe->episode_Direction == EPISODE_LEFT ) ? EPISODE_RIGHT : EPISODE_LEFT;


				// ȭ Ѵܰ Ų.
				pMe->episode_line++;
			}

			// prevent constant key input
			pMe->keyCurr = GKEY_NONE;


				

			//freeImage(pMe,&pMe->imgTemp);
			//SETSTATE(pMe,STATE_DAUM);
		}
	}
}


void episodeDrawBg(CMoso* pMe)
{
	int i,j;
	int dx,dy,nx,ny;

	if( pMe->episode_backDraw == FALSE )
	{
		pMe->episode_backDraw = TRUE;

		// draw bg
		dx = pMe->imgGame[IMG_STATUSBG].info.cx;
		dy = pMe->imgGame[IMG_STATUSBG].info.cy;

		nx = pMe->canvas_width / dx;
		ny = pMe->canvas_height / dy;

		for(i=0;i<=nx;++i)
			for(j=0;j<=ny;++j)
				drawImage(pMe,IMG_STATUSBG,i*dx,j*dy,GFX_LEFTTOP);

		if( pMe->canvas_height < 130 )
			drawImage2(pMe,&pMe->episode_bgImage,pMe->canvas_midx,pMe->canvas_height - EPISODE_HEIGHT,GFX_HCENTER|GFX_BOTTOM);
		else if( pMe->canvas_height < 160 ) 
			drawImage2(pMe,&pMe->episode_bgImage,pMe->canvas_midx,pMe->canvas_height - EPISODE_HEIGHT - 5,GFX_HCENTER|GFX_BOTTOM);
		else
			drawImage2(pMe,&pMe->episode_bgImage,pMe->canvas_midx,pMe->canvas_height - EPISODE_HEIGHT - 25,GFX_HCENTER|GFX_BOTTOM);

		fillRect(pMe,
				 pMe->episode_left_x,
				 pMe->episode_left_y,
				 pMe->episode_dx,
				 pMe->episode_dy,
				 RGB(0,0,0));

		// draw textbox
		dx = pMe->imgGame[IMG_BOXHORZ].info.cx;
		nx = pMe->episode_dx / dx;
		for(i=0;i<=nx;i++) drawImage(pMe,IMG_BOXHORZ,i*dx,pMe->episode_left_y,GFX_LEFT|GFX_TOP);
		for(i=0;i<=nx;i++) drawImage(pMe,IMG_BOXHORZ,i*dx,pMe->episode_left_y+pMe->episode_dy,GFX_LEFT|GFX_BOTTOM);

		dy = pMe->imgGame[IMG_BOXVERT].info.cy;
		ny = pMe->episode_dy / dy;
		for(i=0;i<=ny;i++) drawImage(pMe,IMG_BOXVERT,pMe->episode_left_x,pMe->episode_left_y+i*dy,GFX_LEFT|GFX_TOP);
		for(i=0;i<=ny;i++) drawImage(pMe,IMG_BOXVERT,pMe->episode_right_x,pMe->episode_left_y+i*dy,GFX_RIGHT|GFX_TOP);


		drawImage(pMe,IMG_BOXEDGELT,pMe->episode_left_x,pMe->episode_left_y,GFX_LEFT|GFX_TOP);
		drawImage(pMe,IMG_BOXEDGERT,pMe->episode_right_x,pMe->episode_left_y,GFX_RIGHT|GFX_TOP);
		drawImage(pMe,IMG_BOXEDGELB,pMe->episode_left_x,pMe->episode_left_y+pMe->episode_dy,GFX_LEFT|GFX_BOTTOM);
		drawImage(pMe,IMG_BOXEDGERB,pMe->episode_right_x,pMe->episode_left_y+pMe->episode_dy,GFX_RIGHT|GFX_BOTTOM);

	}
}


void startdayTick(CMoso* pMe)
{
}

void startdayDraw(CMoso* pMe)
{
	// Ⱓ Ҵµ.
	if( pMe->story_day < GAME_STORY_DAY )
	{
		//  ʹٸ 
		if( pMe->story_stage == GAME_STORY_STAGE )
		{
			//  .
			// STATE_ANISTORY ϶ anistory_type    Ѵ.
			pMe->anistory_type = 1;	// happyend
			SETSTATE(pMe,STATE_ANISTORY);	
			return;
		}
	}
	// Ⱓ 
	else
	{	
		//  .
		// STATE_ANISTORY ϶ anistory_type    Ѵ.
		pMe->anistory_type = 2;	// badend
		SETSTATE(pMe,STATE_ANISTORY);	

		return;
	}

	// ð ..
	if( pMe->startday_init == FALSE )
	{
		int x,y;

		pMe->startday_init = TRUE;

		pMe->startTime = GET_UPTIMEMS();

		setScreen(pMe);
		fillRect(pMe,0,0,pMe->canvas_width,pMe->canvas_height,RGB(0,0,0));
/*
		x = 50;
		y = 60;
		drawGNumber(pMe,pMe->story_day+1,x,y,GNUM_TYPE1);
		drawImage(pMe,IMG_TXTDAY,x,y,GFX_LEFT);
		*/

		x = pMe->canvas_midx;
		y = pMe->canvas_midy-pMe->font_h;

		x -= 5;
		drawGNumber(pMe,pMe->story_day+1,x,y,GNUM_TYPE1);

		x += 5;
		drawImage(pMe,IMG_TXTDAY,x,y,GFX_LEFT);

		

		return;
	}

	// 2   Ѿ.
	if( GET_UPTIMEMS() - pMe->startTime > 2000 )
	{
		pMe->startday_init = FALSE;

		trashInit(pMe);
		SETSTATE(pMe,STATE_MORNINGEPISODE);
	}
}

void selectInit(CMoso* pMe)
{
	int g1,g2; // game1, game2
	pMe->select_backDraw	= FALSE;
	// ó hand  trash game  Ų.
	pMe->select_select		= FALSE;



	pMe->select_title_x		= 1;
	pMe->select_title_y		= 1;
	pMe->select_trash_x		= 25;
	pMe->select_trash_y		= 23;
	pMe->select_str1_x		= 45;
	pMe->select_str1_y		= 53;
	pMe->select_find_x		= 25;
	pMe->select_find_y		= 68;
	pMe->select_str2_x		= 45;
	pMe->select_str2_y		= 98;

	// ȭ  
	if( pMe->canvas_height > 130 && pMe->canvas_height < 160 )
	{
        pMe->select_trash_y       += 20;
        pMe->select_find_y        += 20;
        pMe->select_str1_y        += 20;
        pMe->select_str2_y        += 20;
	}
	else if( pMe->canvas_height > 160 && pMe->canvas_height < 220 )
	{
		pMe->select_title_x		+= 25;
		pMe->select_title_y		+= 25;
		pMe->select_trash_x		+= 30;
		pMe->select_trash_y		+= 40;
		pMe->select_find_x		+= 30;
		pMe->select_find_y		+= 40;
		pMe->select_str1_x		+= 30;
		pMe->select_str1_y		+= 40;
		pMe->select_str2_x		+= 30;
		pMe->select_str2_y		+= 40;
	}

	// ù° , ι°   .
	g1 = getRand(pMe,3);	
	if( getRand(pMe,2) )	g2 = g1 + 1;	// 1 ̸
	else					g2 = g1 - 1;	// 0 ̸		
	if( g2 > 2 )			g2 = 0;
	else if( g2 < 0 )		g2 = 2;


	// ù° ι°   ̾. ȶҰ ũ  Ѵ.
	if( pMe->story_day == 0 ) 
	{
		pMe->select_game1 = 0;
		pMe->select_game2 = 1;
	}
	else if( pMe->story_day == 1 ) 
	{
		pMe->select_game1 = 1;
		pMe->select_game2 = 0;
	}
	// °   ̴.
	// ֳ?   ̺Ʈ   ϰŵ..
	else if( pMe->story_day == 2 )
	{
		pMe->select_game1 = 2;
		pMe->select_game2 = 2;
	}
	//   ʹ .
	else
	{
		pMe->select_game1	= g1;
		pMe->select_game2	= g2;
	}

//    
#if CHEAT_STORY_ONLYITEM
	pMe->select_game1	= 2;
	pMe->select_game2	= 2;
#endif

}

void selectTick(CMoso* pMe)
{
}

void selectDraw(CMoso* pMe)
{
	int i,j,x,y,dx,dy;


	if( pMe->select_backDraw == FALSE )
	{
		Image imgTitle,imgTrash,imgFind;
		char temp1[20],temp2[20];

		imgTitle.bitmap = NULL;
		imgTitle.src	= NULL;
		imgTrash.bitmap = NULL;
		imgTrash.src	= NULL;
		imgFind.bitmap	= NULL;
		imgFind.src		= NULL;


		loadImage(pMe,&imgTitle,MOSO_RES_FILE,IDB_SELECTTITLE);
		loadImage(pMe,&imgTrash,MOSO_RES_FILE,IDB_SELECTTRASH);
		loadImage(pMe,&imgFind,MOSO_RES_FILE,IDB_SELECTFIND);
		
		setScreen(pMe);
		// draw bg
		dx = pMe->imgGame[IMG_STATUSBG].info.cx;
		dy = pMe->imgGame[IMG_STATUSBG].info.cy;

		x = pMe->canvas_width / dx;
		y = pMe->canvas_height / dy;

		for(i=0;i<=x;++i)
			for(j=0;j<=y;++j)
				drawImage(pMe,IMG_STATUSBG,i*dx,j*dy,GFX_LEFTTOP);


		// draw trash,find image
		drawImage2(pMe,&imgTitle,pMe->select_title_x,pMe->select_title_y,GFX_LEFT);
		drawImage2(pMe,&imgTrash,pMe->select_trash_x,pMe->select_trash_y,GFX_LEFT);
		drawImage2(pMe,&imgFind,pMe->select_find_x,pMe->select_find_y,GFX_LEFT);

		
		// draw string
		switch( pMe->select_game1 )
		{
			case 0:
				SPRINTF(temp1,"%s","ȶ ");
				break;
			case 1:
				SPRINTF(temp1,"%s","ũ ");
				break;
			case 2:
				SPRINTF(temp1,"%s"," ȹ");
				break;
		}
		// draw string
		switch( pMe->select_game2 )
		{
			case 0:
				SPRINTF(temp2,"%s","ȶ ");
				break;
			case 1:
				SPRINTF(temp2,"%s","ũ ");
				break;
			case 2:
				SPRINTF(temp2,"%s"," ȹ");
				break;
		}


		setColor(pMe,255,255,255);
		drawString(pMe,temp1,pMe->select_str1_x,pMe->select_str1_y,GFX_LEFT);
		drawString(pMe,temp2,pMe->select_str2_x,pMe->select_str2_y,GFX_LEFT);

		// ȭ 
		if( pMe->canvas_height < 160 )
			x = 2;
		else
			x = 20;
		// draw hand
		if( pMe->select_select == FALSE )
			drawImage(pMe,IMG_MENUHAND,x,pMe->select_trash_y,GFX_LEFT);
		else
			drawImage(pMe,IMG_MENUHAND,x,pMe->select_find_y,GFX_LEFT);

		freeImage(pMe,&imgTitle);
		freeImage(pMe,&imgTrash);
		freeImage(pMe,&imgFind);

		pMe->select_backDraw = TRUE;
	}

	// ڰ Ű ٸ..
	if( pMe->keyCurr & GKEY_UP || pMe->keyCurr & GKEY_DOWN )
	{
		pMe->select_select = !pMe->select_select;

		// ȭ 
		if( pMe->canvas_height < 160 )
			x = 2;
		else
			x = 20;
		y = pMe->select_trash_y;
		setClip(pMe,x,y,20,pMe->canvas_height);
		
		// draw bg
		dx = pMe->imgGame[IMG_STATUSBG].info.cx;
		dy = pMe->imgGame[IMG_STATUSBG].info.cy;

		x = pMe->canvas_width / dx;
		y = pMe->canvas_height / dy;

		for(i=0;i<=x;++i)
			for(j=0;j<=y;++j)
				drawImage(pMe,IMG_STATUSBG,i*dx,j*dy,GFX_LEFTTOP);

		// ȭ 
		if( pMe->canvas_height < 160 )
			x = 2;
		else
			x = 20;

		if( pMe->select_select == FALSE )
			drawImage(pMe,IMG_MENUHAND,x,pMe->select_trash_y,GFX_LEFT);
		else
			drawImage(pMe,IMG_MENUHAND,x,pMe->select_find_y,GFX_LEFT);
	}
	else if(pMe->keyCurr & GKEY_SOFT3 )
	{
		// if choose trash game
		if( pMe->select_select == FALSE ) {
			pMe->select_mission = pMe->select_game1;

			trashInit(pMe);
			SETSTATE(pMe,STATE_TRASH);
		}
		// if choose find game
		else {
			pMe->select_mission = pMe->select_game2;

			findInit(pMe);
			SETSTATE(pMe,STATE_FIND);
		}
	}

	// prevent constant key input
	pMe->keyCurr = GKEY_NONE;
}

void dailyTick(CMoso* pMe)
{
}

void dailyDraw(CMoso* pMe)
{
	int i,j;
	int x,y,dx,dy;
	int percent;
	int item;

	if( pMe->daily_backDraw == FALSE )
	{
		pMe->daily_backDraw = TRUE;

		setScreen(pMe);

		// draw bg
		dx = pMe->imgGame[IMG_STATUSBG].info.cx;
		dy = pMe->imgGame[IMG_STATUSBG].info.cy;

		x = pMe->canvas_width / dx;
		y = pMe->canvas_height / dy;

		for(i=0;i<=x;++i)
			for(j=0;j<=y;++j)
				drawImage(pMe,IMG_STATUSBG,i*dx,j*dy,GFX_LEFTTOP);


		// draw total score
		drawImage(pMe,IMG_TXTSCORE,0,0,GFX_LEFT);

		// draw progress text
		x = 5;
		y = pMe->imgGame[IMG_TXTSKIP].info.cy + 10;

		// ȭ  
		if( pMe->canvas_height > 160 ) {
			x += 30;
			y += 10;
		}
		setColor(pMe,255,255,255);
		drawString(pMe,"Next Item :",x,y,GFX_LEFT);
		if( pMe->story_itemNum > 0 ) 
		{
			item = pMe->story_item[pMe->story_itemNum-1];
			drawImage(pMe,IMG_DIGICONITEM1 + item,x+80,y,GFX_LEFT);
		}
 		else {
			drawString(pMe,"None",x+80,y,GFX_LEFT|GFX_TOP);
		} 

		// draw percent
		y += pMe->font_h+5;

		// ȭ  
		if( pMe->canvas_height > 160 ) {
			y += 10;
		}
		drawGNumber(pMe,GAME_STORY_STAGE-pMe->story_stage,x+12,y+2,GNUM_TYPE3);
		drawString(pMe,"  .",x+12,y,GFX_LEFT);

		// draw calendar
		drawImage(pMe,IMG_CALENDAR,pMe->canvas_width,0,GFX_RIGHT);

		// draw day
		x = pMe->canvas_width - 8;
		y = 7;
		drawGNumber(pMe,pMe->story_day+1,x,y,GNUM_TYPE2);		


		// draw progress img
		x = 5;
		if( pMe->canvas_height < 130 )
			y = 50;
		else if( pMe->canvas_height < 160 )
			y = 65;
		else {
			x = 35;
			y = 95;
		}
		drawImage(pMe,IMG_DAILYPROGRESS,x,y,GFX_LEFT);


		// draw actor icon
		percent = (pMe->story_stage << 8) / GAME_STORY_STAGE; 
		percent = (percent * 90) >> 8;
		x += percent;
		drawImage(pMe,IMG_DIGICON1P,x,y,GFX_LEFT);



		// draw lv 1 2 3 4 5 
		x = 2 + pMe->imgGame[IMG_TXTWEAPONLV].info.cx;
		y = pMe->canvas_height 
			- pMe->imgGame[IMG_TXTSKIP].info.cy 
			- pMe->imgGame[IMG_GAUGELEVEL].info.cy - 3
			- pMe->imgGame[IMG_GAUGELEVEL].info.cy
			- pMe->imgGame[IMG_DAILYLV].info.cy;

		if( pMe->canvas_height > 160 ) {
			x += 30;
			y -= 10;
		}
		drawImage(pMe,IMG_DAILYLV,x,y,GFX_LEFT);

		// draw powerlv text
		setScreen(pMe);
		x = 2;
		y = pMe->canvas_height 
			- pMe->imgGame[IMG_TXTSKIP].info.cy 
			- pMe->imgGame[IMG_GAUGELEVEL].info.cy - 3
			- pMe->imgGame[IMG_GAUGELEVEL].info.cy;

		if( pMe->canvas_height > 160 ) {
			x += 30;
			y -= 10;
		}

		drawImage(pMe,IMG_TXTPOWERLV,x,y,GFX_LEFT);

		// draw power gauge
		x = x + pMe->imgGame[IMG_TXTWEAPONLV].info.cx;		
		releaseGauge(pMe); //  .
		setGauge(pMe,x,y,10,IMG_GAUGELEVEL,IMG_GAUGELEVELBG,GAUGE_HORZ);
		drawGauge(pMe,pMe->story_power,0);

		// draw weaponlv text
		setScreen(pMe);
		x = 2;
		y = pMe->canvas_height 
			- pMe->imgGame[IMG_TXTSKIP].info.cy 
			- pMe->imgGame[IMG_GAUGELEVEL].info.cy - 3;		

		if( pMe->canvas_height > 160 ) {
			x += 30;
			y -= 10;
		}

		drawImage(pMe,IMG_TXTWEAPONLV,x,y,GFX_LEFT);
		
		// draw weapon gauge
		x = x + pMe->imgGame[IMG_TXTWEAPONLV].info.cx;
		releaseGauge(pMe); //  .
		setGauge(pMe,x,y,10,IMG_GAUGELEVEL,IMG_GAUGELEVELBG,GAUGE_HORZ);
		drawGauge(pMe,pMe->story_weapon,0);


		// draw skip
		setScreen(pMe);
		x = pMe->canvas_width - pMe->imgGame[IMG_TXTSKIP].info.cx;
		y = pMe->canvas_height - pMe->imgGame[IMG_TXTSKIP].info.cy;
		drawImage(pMe,IMG_TXTSKIP,x,y,GFX_LEFT);

			/*
		// draw total score
		drawImage(pMe,IMG_TXTSCORE,0,0,GFX_LEFT);

		// draw progress text
		x = 5;
		y = pMe->imgGame[IMG_TXTSKIP].info.cy + 10;
		setColor(pMe,255,255,255);
		drawString(pMe,"Next Item :",x,y,GFX_LEFT);
		if( pMe->story_itemNum > 0 ) 
		{
			item = pMe->story_item[pMe->story_itemNum-1];
			drawImage(pMe,IMG_DIGICONITEM1 + item,70,y,GFX_LEFT);
		}


		// draw percent
		y += pMe->font_h+5;
		drawGNumber(pMe,GAME_STORY_STAGE-pMe->story_stage,x+12,y,GNUM_TYPE3);
		drawString(pMe,"  .",x+12,y,GFX_LEFT);

		// draw calendar
		drawImage(pMe,IMG_CALENDAR,pMe->canvas_width,0,GFX_RIGHT);

		// draw day
		x = pMe->canvas_width - 8;
		y = 7;
		drawGNumber(pMe,pMe->story_day+1,x,y,GNUM_TYPE2);		


		// draw progress img
		x = 5;
		if( pMe->canvas_height < 130 )
			y = 50;
		else 
			y = 65;
		drawImage(pMe,IMG_DAILYPROGRESS,x,y,GFX_LEFT);

		// draw actor icon
		percent = (pMe->story_stage << 8) / GAME_STORY_STAGE; 
		percent = (percent * 90) >> 8;
		x += percent;
		drawImage(pMe,IMG_DIGICON1P,x,y,GFX_LEFT);

		// draw lv 1 2 3 4 5 
		x = 2 + pMe->imgGame[IMG_TXTWEAPONLV].info.cx;
		y = pMe->canvas_height 
			- pMe->imgGame[IMG_TXTSKIP].info.cy 
			- pMe->imgGame[IMG_GAUGELEVEL].info.cy - 3
			- pMe->imgGame[IMG_GAUGELEVEL].info.cy
			- pMe->imgGame[IMG_DAILYLV].info.cy;
		drawImage(pMe,IMG_DAILYLV,x,y,GFX_LEFT);

		// draw powerlv text
		setScreen(pMe);
		x = 2;
		y = pMe->canvas_height 
			- pMe->imgGame[IMG_TXTSKIP].info.cy 
			- pMe->imgGame[IMG_GAUGELEVEL].info.cy - 3
			- pMe->imgGame[IMG_GAUGELEVEL].info.cy;
		drawImage(pMe,IMG_TXTPOWERLV,x,y,GFX_LEFT);

		// draw power gauge
		x = x + pMe->imgGame[IMG_TXTWEAPONLV].info.cx;		
		releaseGauge(pMe); //  .
		setGauge(pMe,x,y,10,IMG_GAUGELEVEL,IMG_GAUGELEVELBG,GAUGE_HORZ);
		drawGauge(pMe,pMe->story_power,0);

		// draw weaponlv text
		setScreen(pMe);
		x = 2;
		y = pMe->canvas_height 
			- pMe->imgGame[IMG_TXTSKIP].info.cy 
			- pMe->imgGame[IMG_GAUGELEVEL].info.cy - 3;		
		drawImage(pMe,IMG_TXTWEAPONLV,x,y,GFX_LEFT);
		
		// draw weapon gauge
		x = x + pMe->imgGame[IMG_TXTWEAPONLV].info.cx;
		releaseGauge(pMe); //  .
		setGauge(pMe,x,y,10,IMG_GAUGELEVEL,IMG_GAUGELEVELBG,GAUGE_HORZ);
		drawGauge(pMe,pMe->story_weapon,0);


		// draw skip
		setScreen(pMe);
		x = pMe->canvas_width - pMe->imgGame[IMG_TXTSKIP].info.cx;
		y = pMe->canvas_height - pMe->imgGame[IMG_TXTSKIP].info.cy;
		drawImage(pMe,IMG_TXTSKIP,x,y,GFX_LEFT);
		*/
	}

	// ڰ # Ű ٸ..
	if( pMe->keyCurr & GKEY_POUND )
	{
		pMe->daily_backDraw = FALSE;

		// Ϸ  ϰ
		pMe->story_day++;
		//   ϰ.
		saveData(pMe);

		SETSTATE(pMe,STATE_STARTDAY);

		pMe->keyCurr = GKEY_NONE;
	}
}

void tutorialTick(CMoso* pMe)
{
	// skip Ű ٸ..
	if( pMe->keyCurr & GKEY_POUND )
	{
		if( pMe->gPrevState  == STATE_TRASH )
		{
			trashInit(pMe);
			SETSTATE(pMe,STATE_TRASH);
		}
		else if( pMe->gPrevState  == STATE_FIND )
		{
			findInit(pMe);
			SETSTATE(pMe,STATE_FIND);
		}
		else if( pMe->gPrevState  == STATE_DIG )
		{
			digInit(pMe);
			SETSTATE(pMe,STATE_DIG);
		}

		// ʱȭ   ׷.
		pMe->tutorial_backDraw = FALSE;
		stopText(pMe);
	}
	pMe->keyCurr = GKEY_NONE;
}


void tutorialDraw(CMoso* pMe)
{
	char* tuto=NULL;
	int x,y,dx,dy;


	if( pMe->gPrevState == STATE_TRASH )		tuto = pMe->tutorial_trashstory;
	else if( pMe->gPrevState == STATE_FIND )	tuto = pMe->tutorial_findstory;
	else if( pMe->gPrevState == STATE_DIG )		tuto = pMe->tutorial_digstory;

	setScreen(pMe);
	tutorialDrawBg(pMe);

	dx	= pMe->canvas_width;
	dy	= pMe->canvas_height - pMe->imgGame[IMG_TXTTUTORIAL].info.cy;
	x	= 0;
	y	= pMe->imgGame[IMG_TXTTUTORIAL].info.cy;

	setColor(pMe,255,255,255);
	initText(pMe,tuto,dx,dy,GFX_LEFT);
	drawText(pMe,x,y,dx,dy,FALSE);
}

void tutorialDrawBg(CMoso* pMe)
{
	int x,y,dx,dy;
	int i,j;

	if( pMe->tutorial_backDraw == FALSE )
	{
		pMe->tutorial_backDraw = TRUE;		

		// draw bg
		dx = pMe->imgGame[IMG_STATUSBG].info.cx;
		dy = pMe->imgGame[IMG_STATUSBG].info.cy;

		x = pMe->canvas_width / dx;
		y = pMe->canvas_height / dy;

		for(i=0;i<=x;++i)
			for(j=0;j<=y;++j)
				drawImage(pMe,IMG_STATUSBG,i*dx,j*dy,GFX_LEFTTOP);

		x = pMe->canvas_midx;
		y = 0;
		drawImage(pMe,IMG_TXTTUTORIAL,x,y,GFX_HCENTER|GFX_TOP);
	}

	// draw skip txt
	drawImage(pMe,IMG_TXTSKIP,pMe->canvas_width,pMe->canvas_height,GFX_RIGHT|GFX_BOTTOM);
}


void anistoryTick(CMoso* pMe)
{
	if( pMe->imgTemp.bitmap == NULL )
	{
		pMe->anistory_backDraw = FALSE;
		switch( pMe->anistory_type )
		{
			case 0: // prologue
				pMe->anistory_img	= IDB_PROLOGUE;
				pMe->anistory_story	= "ѷα\\  𸣰 Ұ  ӱ ϰ  ѿ Ű ͵ ڶ ڽ   ٴ  ȹ ˰ Ǿ  ̻  ϰ Ⱓ   ư   ġ ߴ.\\ \\ \\ ";
				break;
			case 1: // happyend1
				pMe->anistory_img = IDB_HAPPYEND1;
				pMe->anistory_story	= "   Ǿ 30 ٰ  Ż⿡ ߴ.\\\"...޿ ׸ Ẕ̇! ϸ͸     û߾. ̷ Ż⿡ ϴٴ ...  ȸ   ó  Ұ ǰ ׷   ̴ ȸ ...ٵ...   ܾ  ?\"\\ \\ \\ ";
				break;
			case 2:	// badend
				pMe->anistory_img = IDB_BADEND1;
				pMe->anistory_story	= "30     Ͽ    .\\\"... 忡  ͵ µ...   ȴٴ ᱹ   ̷    ΰ...̿  ٽ ¾ٸ ε ڵ鿡 ູ Ǳ ٷ߰ڱ...    ; ٵ...\"\\ \\ \\ ";
				break;
		}
		pMe->anistory_backDraw = FALSE;
		loadImage(pMe,&pMe->imgTemp,MOSO_RES_FILE,pMe->anistory_img);

		pMe->startTime = GET_UPTIMEMS();
		return;
	}

	// # Ű ٸ.
	if((pMe->keyCurr & GKEY_POUND) != 0)
	{
		// prevent constant key input
		pMe->keyCurr = GKEY_NONE;

		//    ´.
		freeImage(pMe,&pMe->imgTemp);
		stopAnitext(pMe);
		pMe->anistory_backDraw = FALSE;


		setScreen(pMe);
		// 丮  ٸ  state   ϳ.
		switch( pMe->anistory_type )
		{
			case 0: // prologue
				SETSTATE(pMe,STATE_STARTDAY);
				break;
			case 1: // happyend
				episodeInit(pMe,9);
				SETSTATE(pMe,STATE_EPISODE);
				break;
			case 2:	// badend
				gotoMenu(pMe,MSTATE_MAIN);
				SETSTATE(pMe,STATE_MENU);
				break;
		}
	}
}

void anistoryDraw(CMoso* pMe)
{
	int i,j;
	int x,y,dx,dy,nx,ny;		// text dx, text dy

	// if image have loaded.
	if( pMe->imgTemp.bitmap != NULL )
	{
		setScreen(pMe);
		// draw bg
		if( pMe->anistory_backDraw == FALSE )
		{
			pMe->anistory_backDraw = TRUE;

			dx = pMe->imgGame[IMG_STATUSBG].info.cx;
			dy = pMe->imgGame[IMG_STATUSBG].info.cy;

			nx = pMe->canvas_width / dx;
			ny = pMe->canvas_height / dy;

			for(i=0;i<=nx;++i)
				for(j=0;j<=ny;++j)
					drawImage(pMe,IMG_STATUSBG,i*dx,j*dy,GFX_LEFTTOP);

			// draw prologue image
			drawImage2(pMe,&pMe->imgTemp,pMe->canvas_midx,0,GFX_HCENTER);
		}

		//   ̹ 
		x	= 0;
		y	= pMe->imgTemp.info.cy;
		dx	= pMe->canvas_width;
		dy	= pMe->canvas_height - y;

		setColor(pMe,255,255,255);
		initAnitext(pMe,pMe->anistory_story,500,dx,GFX_LEFT);		
		if( drawAnitext(pMe,x,y,dx,dy) )
		{				
			// prevent constant key input
			pMe->keyCurr = GKEY_NONE;

			freeImage(pMe,&pMe->imgTemp);
			stopAnitext(pMe);

			// 丮  ٸ  state   ϳ.
			switch( pMe->anistory_type )
			{
				case 0: // prologue
					SETSTATE(pMe,STATE_STARTDAY);
					break;
				case 1: // happyend
					episodeInit(pMe,9);
					SETSTATE(pMe,STATE_EPISODE);
					break;
				case 2:	// badend
					gotoMenu(pMe,MSTATE_MAIN);
					SETSTATE(pMe,STATE_MENU);
					break;
			}			
		}

		drawImage(pMe,IMG_TXTSKIP,pMe->canvas_width,pMe->canvas_height,GFX_RIGHT|GFX_BOTTOM);
	}
}

void drawForkAni(CMoso* pMe,int y) {
	int x,x2,dx,dy;
	y -=2 ; // ġ 
	if( pMe->canvas_height < 160 ) {
		x = pMe->menu_panx + pMe->menu_pandx/2 - 50;	
		x2 = pMe->menu_panx + pMe->menu_pandx/2 + 50;
	}
	else {
		x = pMe->menu_panx + pMe->menu_pandx/2 - 70;	
		x2 = pMe->menu_panx + pMe->menu_pandx/2 + 70;
	}

	dx= pMe->imgGame[IMG_LFORK].info.cx + 4;
	dy= pMe->imgGame[IMG_LFORK].info.cy;

	setClip(pMe,x-dx/2,0,dx,pMe->canvas_height);
	pMe->menu_panDraw = FALSE;
	menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,FALSE);
	drawImage(pMe,IMG_LFORK,x+pMe->menuHand,y+3,GFX_CENTER);


	setClip(pMe,x2-dx/2,0,dx,pMe->canvas_height);
	pMe->menu_panDraw = FALSE;
	menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,FALSE);
	drawImage(pMe,IMG_RFORK,x2+(pMe->menuHand*-1),y+3,GFX_CENTER);

	if( GET_UPTIMEMS() - pMe->forkTime > 250 || pMe->forkTime == 0 ) {
		pMe->forkTime = GET_UPTIMEMS();
		pMe->menuHand = pMe->menuHand * -1;
	}
}
