#include "moso.h"
#include "save.h"

boolean saveData(CMoso* pMe)
{
	int i;
	IFile * pFile;
	if (ISHELL_CreateInstance(pMe->a.m_pIShell, AEECLSID_FILEMGR, (void **) &pMe->fileMgr) != SUCCESS) 
		return 0;
	

	pFile = IFILEMGR_OpenFile(pMe->fileMgr, SAVE_FILE, _OFM_READWRITE);

	// failed to open the file
	if (pFile == NULL) 
	{	
		// create the file
		pFile = IFILEMGR_OpenFile(pMe->fileMgr, SAVE_FILE, _OFM_CREATE);
		if (pFile == NULL) 
		{
			IFILEMGR_Release(pMe->fileMgr);
			pMe->fileMgr = NULL;
			return 0;
		}
	}

	if (IFILE_Seek(pFile, _SEEK_START, 0) != SUCCESS) 
	{
		IFILE_Release(pFile);
		IFILEMGR_Release(pMe->fileMgr);
		pMe->fileMgr = NULL;
		return 0;
	}


	MEMSET(pMe->sd, 0, sizeof(byte)*NUM_SAVE);
	pMe->sd[SD_CONFIG_SOUND]		= pMe->config_isSound; 
	pMe->sd[SD_CONFIG_VIBRATION]	= pMe->config_isVibration; 

	pMe->sd[SD_STORY_DAY]			= pMe->story_day; 
	pMe->sd[SD_STORY_STAGE]			= pMe->story_stage; 
	pMe->sd[SD_STORY_TRASHSTAGE]	= pMe->story_trashstage; 	
	pMe->sd[SD_STORY_FINDSTAGE]		= pMe->story_findstage; 	
	pMe->sd[SD_STORY_POWER]			= pMe->story_power; 
	pMe->sd[SD_STORY_WEAPON]		= pMe->story_weapon;


	pMe->sd[SD_STORY_ITEMNUM]		= pMe->story_itemNum; 	
	for(i=0;i<GAME_STORY_DAY;i++)	//   ִ ÷ ð̴. ִ 30ϱ ÷   ִ.
		pMe->sd[SD_STORY_ITEM1+i] = pMe->story_item[i];


	pMe->sd[SD_ENDLESS_TRASHLV]		= pMe->endless_trashlv; 
	pMe->sd[SD_ENDLESS_FINDLV]		= pMe->endless_findlv; 
	pMe->sd[SD_ENDLESS_DIGLV]		= pMe->endless_diglv; 


	IFILE_Write(pFile, pMe->sd, sizeof(byte)*NUM_SAVE);

	IFILE_Release(pFile);
	IFILEMGR_Release(pMe->fileMgr);
	pMe->fileMgr = NULL;

	return 1;
}

boolean loadData(CMoso* pMe)
{
	int i;
	IFile * pFile;

	if (ISHELL_CreateInstance(pMe->a.m_pIShell, AEECLSID_FILEMGR, (void **) &pMe->fileMgr) != SUCCESS) 
		return 0;


	pFile = IFILEMGR_OpenFile(pMe->fileMgr, SAVE_FILE, _OFM_READ);

	// failed to open the file
	if (pFile == NULL) 
	{	
		IFILEMGR_Release(pMe->fileMgr);
		pMe->fileMgr = NULL;
		return 0;
	}

	if (IFILE_Read(pFile, pMe->sd, sizeof(byte)*NUM_SAVE) != sizeof(byte)*NUM_SAVE) 
	{
		IFILE_Release(pFile);
		IFILEMGR_Release(pMe->fileMgr);
		pMe->fileMgr = NULL;
		return 0;
	}

	pMe->config_isSound		= pMe->sd[SD_CONFIG_SOUND];
	pMe->config_isVibration	= pMe->sd[SD_CONFIG_VIBRATION];

	pMe->story_day			= pMe->sd[SD_STORY_DAY];
	pMe->story_stage		= pMe->sd[SD_STORY_STAGE];
	pMe->story_trashstage	= pMe->sd[SD_STORY_TRASHSTAGE];
	pMe->story_findstage	= pMe->sd[SD_STORY_FINDSTAGE];
	pMe->story_power		= pMe->sd[SD_STORY_POWER];
	pMe->story_weapon		= pMe->sd[SD_STORY_WEAPON];


	pMe->story_itemNum		= pMe->sd[SD_STORY_ITEMNUM];
	for(i=0;i<GAME_STORY_DAY;i++)	//   ִ ÷ ð̴. ִ 30ϱ ÷   ִ.
		pMe->story_item[i] = pMe->sd[SD_STORY_ITEM1+i];

	pMe->endless_trashlv	= pMe->sd[SD_ENDLESS_TRASHLV];	
	pMe->endless_findlv		= pMe->sd[SD_ENDLESS_FINDLV];
	pMe->endless_diglv		= pMe->sd[SD_ENDLESS_DIGLV];


	IFILE_Release(pFile);
	IFILEMGR_Release(pMe->fileMgr);
	pMe->fileMgr = NULL;

	return 1;
}
