#include "moso.h"
#include "menu.h"
#include "trash.h"
#include "find.h"
#include "happysnd.h"
#include "save.h"

// Trash Tick & Draw
void trashTick(CMoso* pMe)
{
	// 丮  ..
	if( pMe->gameMode == GAMEMODE_STORY )
	{
		// ù̸ Ʃ丮 ش.
		if( pMe->story_trashstage == 0 && pMe->tutorial_trashShowed == FALSE )
		{
			pMe->tutorial_trashShowed = TRUE;

			SETSTATE(pMe,STATE_TUTORIAL);
			return;
		}		
	}	

	//  ޴ ȣ (  ð   ʴٸ..    ٸ Ű Է  ʴ´.)
	if( pMe->keyCurr & GKEY_BACK && pMe->trash_state != TSTATE_END)
	{
		gotoMenu(pMe,MSTATE_GAMEMENU);
		SETSTATE(pMe,STATE_MENU);

		// ⼭ FALSE   ƿ  ٽ ׷..
		pMe->trash_backDraw = FALSE;
		pMe->trash_redraw	= TRUE;

		pMe->keyCurr = GKEY_NONE;
		return;
	}


#if CHEAT_ENDLESS_LEVELJUMP
	if( pMe->gameMode == GAMEMODE_ENDLESS) 
	{
		// Ѹ_ġƮŰ   ׳ ö󰡹.
		if( pMe->keyCurr & GKEY_SOFT3 )
		{					
			pMe->endless_trashlv++;

			if( pMe->endless_trashlv < ENDLESS_LEVELEND ) 
			{
				trashInit(pMe);
				gotoTrash(pMe,TSTATE_READY);
			}
			else
			{
				pMe->endless_trashlv = 0;

				gotoMenu(pMe,MSTATE_MAIN);
				SETSTATE(pMe,STATE_MENU);
			}
		}
	}
#endif

	switch(pMe->trash_state)
	{
		case TSTATE_READY:
			{
				uint32	tickTime;
				int x,y,dx,dy;

				setScreen(pMe);
				trashDrawBg(pMe);
				trashDrawHand(pMe);
				trashDrawScore(pMe);
				trashDrawTime(pMe);
				trashDrawPongPong(pMe);
				trashDrawDay(pMe);

				tickTime = GET_UPTIMEMS();

				x = pMe->canvas_midx;
				y = pMe->canvas_midy;

				dx = pMe->imgGame[IMG_START].info.cx;
				dy = pMe->imgGame[IMG_START].info.cy;


				if( pMe->trash_ready == FALSE )
				{
					pMe->trash_temp		= tickTime;
					pMe->trash_ready	= TRUE;
					pMe->trash_startAni	= 1;
					break;
				}
				if( tickTime - pMe->trash_temp > 300 && pMe->trash_startAni == 1 )
				{
					pMe->trash_temp		= tickTime;
					pMe->trash_startAni	= 2;

					setClip(pMe,x-dx/2,y-dy/2,dx,dy);					
					drawImage(pMe,IMG_START,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);			
				}
				else if( tickTime - pMe->trash_temp > 300 && pMe->trash_startAni == 2 )
				{
					pMe->trash_temp	= tickTime;
					pMe->trash_startAni	= 3;

					setClip(pMe,x-dx/2,y-dy/2,dx,dy);					
					pMe->trash_backDraw = FALSE;
					trashDrawBg(pMe);
				}
				else if( tickTime - pMe->trash_temp > 300 && pMe->trash_startAni == 3 )
				{
					pMe->trash_temp	= tickTime;
					pMe->trash_startAni	= 4;

					setClip(pMe,x-dx/2,y-dy/2,dx,dy);					
					drawImage(pMe,IMG_START,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);			
				}
				else if( tickTime - pMe->trash_temp > 300 && pMe->trash_startAni == 4 )
				{
					pMe->trash_temp	= tickTime;
					pMe->trash_startAni	= 5;

					setClip(pMe,x-dx/2,y-dy/2,dx,dy);					
					pMe->trash_backDraw = FALSE;
					trashDrawBg(pMe);
				}
				else if( pMe->trash_startAni == 5 )
				{
					gotoTrash(pMe,TSTATE_START);
				}
			}
			break;


		case TSTATE_START:
			{
				uint32	tickTime;
				int		destArea;
				int		pollute;
				int i;

				setScreen(pMe);

				//  ޴ ȣ ϰ   ٽ ׷  ȴ.
				if( pMe->trash_redraw )
				{
					trashDrawBg(pMe);
					trashDrawHand(pMe);
					for(i=0;i<9;i++)
						trashDrawTrash(pMe,i);

					pMe->trash_redraw = FALSE;
				}

				//  ׷ְ...
				
				//trashDrawBg(pMe);


				tickTime = GET_UPTIMEMS();

				if( pMe->trash_startTime == 0 )
				{
					pMe->trash_startTime	= tickTime;
					pMe->trash_trashStart	= tickTime;

					
					break;
				}




				pMe->trash_currTime = tickTime - pMe->trash_startTime;

				// whole game time is under trash_wholeTime
				if( pMe->trash_currTime < pMe->trash_wholeTime )
				{
					//  ߰Ѵ.
					if( tickTime - pMe->trash_trashStart > pMe->trash_trashGap )
					{
						pMe->trash_trashStart = tickTime;

						destArea	= getRand(pMe,9);
						pollute		= getRand(pMe,3);
						pollute		= (pollute==0) ? 6 : pollute*2; // ᱹ 2,4,6 ̷  .

						//  â ƴϰ.
						if( pMe->trash_window[destArea] != 0 )
						{
							// Ⱑ  â̶  .
							if( pMe->trash_hole[destArea] == 0 )
								pMe->trash_hole[destArea] = pollute;

							//  ٽ ׷ְ     𸣴 յ ٽ ׸.
							trashDrawTrash(pMe,destArea);
							trashDrawHand(pMe);
						}


						// // penalty when whole trash number of one hole exceed 3.
						//if( pMe->trash_hole[destArea] >= 2 )
						//	pMe->trash_score--;						
					}

					if( pMe->keyCurr & GKEY_0 )
					{
						sfx_play(pMe,SND_TRASHWATER,FALSE);
						//pMe->trash_pongpong = 10;

						//  äֱ.
						pMe->trash_currPong += 2;
						if( pMe->trash_currPong > pMe->trash_maxPong )
							pMe->trash_currPong = pMe->trash_maxPong;

						//  ٽ ׷ش.
						trashDrawHand(pMe);

						//   ִϸ̼ ׸
						pMe->trash_pongAni++;
					}

					else if( pMe->keyCurr & GKEY_NUMBER )
					{
						int temp = GET_UPTIMEMS();
						//  ð  â   ְ Ѵ.
						if( temp - pMe->trash_cleanGap > 250 ) 
						{ 
							pMe->trash_cleanGap = temp;
							
							if( pMe->keyCurr & GKEY_1 )			pMe->trash_handCurr = 0;
							else if( pMe->keyCurr & GKEY_2 )	pMe->trash_handCurr = 1;
							else if( pMe->keyCurr & GKEY_3 )	pMe->trash_handCurr = 2;
							else if( pMe->keyCurr & GKEY_4 )	pMe->trash_handCurr = 3;
							else if( pMe->keyCurr & GKEY_5 )	pMe->trash_handCurr = 4;
							else if( pMe->keyCurr & GKEY_6 )	pMe->trash_handCurr = 5;
							else if( pMe->keyCurr & GKEY_7 )	pMe->trash_handCurr = 6;
							else if( pMe->keyCurr & GKEY_8 )	pMe->trash_handCurr = 7;
							else if( pMe->keyCurr & GKEY_9 )	pMe->trash_handCurr = 8;



							//  ̴ ִϸ̼.
							// ̰     .
							pMe->trash_AniPrev = pMe->trash_AniCurr;

							// â   ʰ &    .
							if( pMe->trash_window[pMe->trash_handCurr] > 0 &&
								pMe->trash_handPrev == pMe->trash_handCurr )
							{
								pMe->trash_AniCurr++;
								if( pMe->trash_AniCurr == 2)
									pMe->trash_AniCurr = 0;


								// Ⱑ ִٸ..
								if( pMe->trash_hole[pMe->trash_handCurr] > 0 )
								{
									sfx_play(pMe,SND_TRASHGLASS2,FALSE);

									//  ִٸ.
									if( pMe->trash_currPong != 0 )
									{
										pMe->trash_hole[pMe->trash_handCurr]--;

										//  ġ  Ͽٸ  ߰
										if( pMe->trash_hole[pMe->trash_handCurr] == 0 )
										{
											//   Ѹ      ϴ ̴.
											pMe->endless_trashscore += 100;


											sfx_play(pMe,SND_TRASHHO,FALSE);
											pMe->trash_currScore--;

											//   ġٸ  ~!
											if( pMe->trash_currScore == 0 )
											{
												gotoTrash(pMe,TSTATE_RESULT);
											}
										}
									}
								}
								// Ⱑ ٸ.
								else if( pMe->trash_hole[pMe->trash_handCurr] == 0 )
								{
									sfx_play(pMe,SND_TRASHCLEAN,FALSE);

									// µ ٸ â  -1
									if( pMe->trash_window[pMe->trash_handCurr] > 0 )
									{
										pMe->trash_window[pMe->trash_handCurr]--;

										// ݰ  ¦  ֱ.
										if( pMe->config_isVibration == 1 )
											sfx_vib(pMe,200);

										// â ٸ 
										if( pMe->trash_window[pMe->trash_handCurr] == 0 )
										{
											//  Ҹ  ְ.
											sfx_play(pMe,SND_TRASHGLASS1,FALSE);

	//										// â   .
	//										gotoTrash(pMe,TSTATE_RESULT);										
										}
									}
								}
								
								//  پ.
								pMe->trash_currPong -= 1;
								if( pMe->trash_currPong < 0 )
									pMe->trash_currPong = 0;

							}

							//   ְ  ִ ġ ٽ ׷ش.
							trashEraseHand(pMe,pMe->trash_handPrev);	
							trashUpdateBg(pMe,pMe->trash_handCurr);

							pMe->trash_handPrev = pMe->trash_handCurr;
						}
					}	
				}
				else
				{
					gotoTrash(pMe,TSTATE_RESULT);
				}

#if CHEAT_STORY_STAGECLEAR
				if( pMe->gameMode == GAMEMODE_STORY) 
				{
					// ӽð Ҵµ  ߾ٸ .
					if( pMe->keyCurr == GKEY_SOFT3 ) 
					{
						pMe->trash_end = FALSE;
						pMe->trash_currScore = 0;
						gotoTrash(pMe,TSTATE_RESULT);
					}
				}
#endif
				trashDrawScore(pMe);
				trashDrawTime(pMe);
				trashDrawPongPong(pMe);
				trashDrawDay(pMe);
			}

			break;

		case TSTATE_RESULT:
			gotoTrash(pMe,TSTATE_END);
			break;

		case TSTATE_END:
			{
				uint32 tickTime;
				int x,y,dx,dy;

				tickTime = GET_UPTIMEMS();

				// 
				if( pMe->trash_end == FALSE )
				{
					pMe->trash_temp = tickTime;
					pMe->trash_end = TRUE;
					break;
				}

				if( pMe->gameMode == GAMEMODE_STORY )
				{
					//  ð   ش.
					if( tickTime - pMe->trash_temp < 3000 )
					{
						//    Ǹ  ƾ   ʿ䰡 ִ.
						trashDrawBg(pMe);
						if( pMe->trash_resultbackDraw == FALSE )
						{
							if( pMe->trash_currScore == 0 ) { // ̼ Ŭ   ȭ
								int item;
								Image imgCircle,imgText,imgIcon;
								char temp1[20],temp2[20];

								// ⼭ weapon  power   ȹ ش.
								imgCircle.bitmap	= NULL;
								imgCircle.src		= NULL;
								imgText.bitmap		= NULL;
								imgText.src			= NULL;
								imgCircle.bitmap	= NULL;
								imgCircle.src		= NULL;
								imgIcon.bitmap		= NULL;
								imgIcon.src			= NULL;


								loadImage(pMe,&imgCircle,MOSO_RES_FILE,IDB_RESULTCIRCLE);
								if( pMe->select_mission == 0 ) { // mission  POWER	
									loadImage(pMe,&imgText,MOSO_RES_FILE,IDB_TXTPOWER);
									loadImage(pMe,&imgIcon,MOSO_RES_FILE,IDB_RESULTPOWER);	
									SPRINTF(temp1,"%s","ȶ Ŀ +3");
									SPRINTF(temp2,"%s","Ͽϴ.");
									pMe->story_power++;
								}
								else if( pMe->select_mission == 1 ) { // mission  WEAPON
									loadImage(pMe,&imgText,MOSO_RES_FILE,IDB_TXTWEAPON);
									loadImage(pMe,&imgIcon,MOSO_RES_FILE,IDB_RESULTWEAPON);	
									SPRINTF(temp1,"%s","ũ Ŀ +3");
									SPRINTF(temp2,"%s","Ͽϴ.");
		
									pMe->story_weapon++;
								}
								else if( pMe->select_mission == 2 ) { // mission  ITEM
									//   
									item = getRand(pMe,4);

									loadImage(pMe,&imgText,MOSO_RES_FILE,IDB_TXTITEM);
									loadImage(pMe,&imgIcon,MOSO_RES_FILE,IDB_RESULTITEM1+item);	
									if( item == 0 )		SPRINTF(temp1,"%s","ð ");
									else if( item == 1 )SPRINTF(temp1,"%s","帱 ");
									else if( item == 2 )SPRINTF(temp1,"%s","ź ");
									else if( item == 3 )SPRINTF(temp1,"%s"," ");									
									SPRINTF(temp2,"%s","ȹϿϴ.");
									

									//  ϳ ÷ֱ.
									pMe->story_item[pMe->story_itemNum] = item;
									pMe->story_itemNum++;
								}

								setScreen(pMe);

								// draw white rect
								x	= pMe->trash_resultup_x-5;
								y	= pMe->trash_resultup_y-5;
								dx	= pMe->trash_resultup_dx+10;
								dy	= pMe->trash_resultup_dy+pMe->trash_resultdn_dy+10;			

		
								fillRect(pMe,x,y,dx,dy,RGB(255,255,255));

								// draw black rect
								x	= pMe->trash_resultup_x;
								y	= pMe->trash_resultup_y;
								dx	= pMe->trash_resultup_dx;
								dy	= pMe->trash_resultup_dy;					
								fillRect(pMe,x,y,dx,dy,RGB(0,0,0));

								// draw gray rect
								x	= pMe->trash_resultdn_x;
								y	= pMe->trash_resultdn_y;
								dx	= pMe->trash_resultdn_dx;
								dy	= pMe->trash_resultdn_dy;					
								fillRect(pMe,x,y,dx,dy,RGB(92,92,92));

								x	= pMe->trash_resultup_x+pMe->trash_resultup_dx;
								y	= pMe->trash_resultup_y;
								drawImage2(pMe,&imgCircle,x,y,GFX_RIGHT|GFX_TOP);

								x	= pMe->trash_resultup_x - 2;
								y	= pMe->trash_resultup_y - 2;
								drawImage2(pMe,&imgText,x,y,GFX_LEFT|GFX_TOP);

								x	= pMe->trash_resultup_x+pMe->trash_resultup_dx + 2;
								y	= pMe->trash_resultup_y - 2;
								drawImage2(pMe,&imgIcon,x,y,GFX_RIGHT|GFX_TOP);


								drawString(pMe,temp1,pMe->trash_resultdn_x,pMe->trash_resultdn_y,GFX_LEFT);
								drawString(pMe,temp2,pMe->trash_resultdn_x,pMe->trash_resultdn_y+pMe->font_h,GFX_LEFT);

								freeImage(pMe,&imgText);
								freeImage(pMe,&imgCircle);
								freeImage(pMe,&imgIcon);							
							}

							else {	// ̼     ȭ.
								Image img;
								img.bitmap	= NULL;
								img.src		= NULL;

								setScreen(pMe);
								x	= pMe->trash_resultup_x-5;
								y	= pMe->trash_resultup_y-5;
								dx	= pMe->trash_resultup_dx+10;
								dy	= pMe->trash_resultup_dy+pMe->trash_resultdn_dy+10;
								fillRect(pMe,x,y,dx,dy,RGB(255,255,255));


								x	= pMe->trash_resultup_x;
								y	= pMe->trash_resultup_y;
								dx	= pMe->trash_resultup_dx;
								dy	= pMe->trash_resultup_dy+pMe->trash_resultdn_dy;
								fillRect(pMe,x,y,dx,dy,RGB(0,0,0));


								x	= (x + dx)/2;
								y	= (y + dy)/2;
								loadImage(pMe,&img,MOSO_RES_FILE,IDB_TXTMISSIONFAIL);								
								drawImage2(pMe,&img,x,y,GFX_CENTER);
								freeImage(pMe,&img);
							}
							pMe->trash_resultbackDraw = TRUE;
						}
					}					
					else 
					{
						//  Ѱ ÷ ش.
						// ⼭  ʰ ߿ ı   ش.
						pMe->story_trashstage++;

						//    ̼ Ŭ   ۿ   episode  ش.
						if( pMe->trash_currScore == 0 && pMe->select_mission == 2)
						{
							int item = pMe->story_item[pMe->story_itemNum-1];

							if( item == 0 )		episodeInit(pMe,11);	// ð
							else if( item == 1 )episodeInit(pMe,12);	// 帱
							else if( item == 2 )episodeInit(pMe,13);	// ź
							else if( item == 3 )episodeInit(pMe,14);	// 							
							SETSTATE(pMe,STATE_EPISODE);
						}
						// ƴ  ı Ѿ.
						else 
						{
							SETSTATE(pMe,STATE_NIGHTEPISODE);
						}
					}

					trashDrawScore(pMe);
					trashDrawTime(pMe);
					trashDrawPongPong(pMe);
					trashDrawDay(pMe);
				}

				//   : , θ ְ ޴ Ȥ  Ѵ.
				else if( pMe->gameMode == GAMEMODE_ENDLESS )
				{
					//  ð   ش.
					if( tickTime - pMe->trash_temp < 1000 )
					{
						x = pMe->canvas_midx;
						y = pMe->canvas_midy;

						dx = pMe->imgGame[IMG_TXTSUCCESS].info.cx;
						dy = pMe->imgGame[IMG_TXTSUCCESS].info.cy;

						setClip(pMe,x-dx/2,y-dy/2,dx,dy);				

						if( pMe->trash_currScore == 0 )
							drawImage(pMe,IMG_TXTSUCCESS,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);					
						else
							drawImage(pMe,IMG_TXTFAILURE,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);	
					}
					// 
					else 
					{
						// ߴٸ..
						if( pMe->trash_currScore == 0 )
						{
							// level ̰
							pMe->endless_trashlv++;

							//  ϰ.
							saveData(pMe);

							//     ٸ..
							if( pMe->endless_trashlv == ENDLESS_LEVELEND )
							{
								pMe->endless_trashlv = 0;
								saveData(pMe);

								// ŷ  Ȯâ .
								gotoMenu(pMe,MSTATE_PUTRANKINGCONFIRM);
								SETSTATE(pMe,STATE_MENU);
							}
							else
							{
								trashReset(pMe);
								gotoTrash(pMe,TSTATE_READY);
							}
						}
						// ߴٸ ޴ .
						else
						{
							// ŷ  Ȯâ .
							gotoMenu(pMe,MSTATE_PUTRANKINGCONFIRM);
							SETSTATE(pMe,STATE_MENU);
						}
					}
				}
			}
			break;
	}

	pMe->keyCurr = GKEY_NONE;
}


void trashDraw(CMoso* pMe)
{
	switch(pMe->trash_state)
	{
		case TSTATE_READY:
			break;
		case TSTATE_START:
			break;
		case TSTATE_RESULT:
			break;
		case TSTATE_END:
			break;
	}
}
//=====================================


// 
void trashInit(CMoso* pMe)
{
	int gap_x,gap_y,i;
	int dx,dy;

	//  ʱȭ
	pMe->endless_trashscore	= 0;

	// set character's position
	if( pMe->canvas_height < 160 )
	{
		dy = pMe->imgGame[IMG_TRASHPONG1].info.cy;
		gap_x = (pMe->canvas_width)/3;
		gap_y = (pMe->canvas_height-STATUS_HEIGHT-dy)/3;
		for(i=0;i<9;i++)
		{
			pMe->trash_x[i]	= gap_x * (i%3) + (gap_x/2);
			pMe->trash_y[i]	= gap_y * (i/3) + (gap_y/2);
		}
	}
	else
	{
		dy = pMe->imgGame[IMG_TRASHPONG1].info.cy;
		gap_x = (128)/3;
		gap_y = (144-STATUS_HEIGHT-dy)/3;
		for(i=0;i<9;i++)
		{
			pMe->trash_x[i]	= 25 + gap_x * (i%3) + (gap_x/2);
			pMe->trash_y[i]	= 40 + gap_y * (i/3) + (gap_y/2);
		}
	}


	//  ̹  ġ 
	dx = pMe->imgGame[IMG_TRASHPONG1].info.cx;
	dy = pMe->imgGame[IMG_TRASHPONG1].info.cy;
	pMe->trash_pong_x		= 1;
	pMe->trash_pong_y		= pMe->canvas_height - STATUS_HEIGHT - dy - 1;
	pMe->trash_pongbar_x	= pMe->trash_pong_x + dx - 5;
	pMe->trash_pongbar_y	= pMe->trash_pong_y + 5;


	// status bar ġ ..
	pMe->trash_status_x		= 0;
	pMe->trash_status_y		= pMe->canvas_height-STATUS_HEIGHT;

	// ȭ  
	if( pMe->canvas_height > 160 )
		pMe->trash_status_x += 20;


	pMe->trash_window_x		= pMe->trash_status_x;
	pMe->trash_window_y		= pMe->trash_status_y + 4;
	pMe->trash_multiply_x	= pMe->trash_status_x + 23;
	pMe->trash_multiply_y	= pMe->trash_status_y + 10;
	pMe->trash_remain_x		= pMe->trash_status_x + 61;
	pMe->trash_remain_y		= pMe->trash_status_y + 3;

	// ȭ  
	if( pMe->canvas_height > 160 )
		pMe->trash_status_x += 10;


	pMe->trash_time_x		= pMe->trash_status_x + 63;
	pMe->trash_time_y		= pMe->trash_status_y + 3;
	pMe->trash_clock_x		= pMe->trash_status_x + 70;
	pMe->trash_clock_y		= pMe->trash_status_y + 18;
	pMe->trash_point_x		= pMe->trash_status_x + 93;
	pMe->trash_point_y		= pMe->trash_status_y + 18;

	// ȭ  
	if( pMe->canvas_height > 160 )
		pMe->trash_status_x += 15;


	pMe->trash_calendar_x	= pMe->trash_status_x + 96;
	pMe->trash_calendar_y	= pMe->trash_status_y + 3;
	pMe->trash_day_x		= pMe->trash_status_x + 113;
	pMe->trash_day_y		= pMe->trash_status_y + 10;
	pMe->trash_lv_x			= pMe->trash_status_x + 118;
	pMe->trash_lv_y			= pMe->trash_status_y + 13;


	// result ġ 
	pMe->trash_resultup_x	= 10;
	pMe->trash_resultup_y	= 10;
	pMe->trash_resultup_dx	= 100;
	pMe->trash_resultup_dy	= 40;

	// ȭ  
	if( pMe->canvas_height > 160 ) 
	{
		pMe->trash_resultup_x += 30;
		pMe->trash_resultup_y += 40;
	}

	pMe->trash_resultdn_x	= pMe->trash_resultup_x;
	pMe->trash_resultdn_y	= pMe->trash_resultup_y + pMe->trash_resultup_dy;
	pMe->trash_resultdn_dx	= 100;
	pMe->trash_resultdn_dy	= 35;




	pMe->trash_AniCurr	= 0;



	pMe->trash_backDraw = FALSE;
	pMe->trash_redraw	= FALSE;
	pMe->trash_state	= TSTATE_READY;


	pMe->trash_resultbackDraw = FALSE;
	// set guage
//	setGuage(pMe,pMe->trash_scorebar_x,pMe->trash_scorebar_y,7,IMG_GUAGE,GUAGE_HORZ);	// for score
//	setGuage(pMe,pMe->trash_timebar_x,pMe->trash_timebar_y,TRASH_WHOLETIME,IMG_GUAGE2,GUAGE_HORZ);	// for time
	
	trashReset(pMe);
}


void trashReset(CMoso* pMe)
{
	int lv,weight;

	// level value setting
	switch(pMe->gameMode)
	{
		case GAMEMODE_STORY:
			lv = pMe->story_trashstage;
			if( lv > 14 ) lv = 14;

			pMe->trash_wholeTime	= pMe->story_trashFactor[lv][TRASH_WHOLETIME];
			pMe->trash_trashGap		= pMe->story_trashFactor[lv][TRASH_TRASHGAP];
			pMe->trash_maxPong		= pMe->story_trashFactor[lv][TRASH_PONGPONG];
			MEMSET(pMe->trash_window,pMe->story_trashFactor[lv][TRASH_WINDOW],9);
			pMe->trash_destScore	= pMe->story_trashFactor[lv][TRASH_DESTSCORE];

			break;

		case GAMEMODE_ENDLESS:
			weight	= (int)(pMe->endless_trashlv / 30);
			lv		= pMe->endless_trashlv % 30;


			// 1 ~ 90 Ǳ ̷  ϰ
			if( pMe->endless_trashlv < 90 )
			{
				pMe->trash_wholeTime	= pMe->endless_trashFactor[lv][TRASH_WHOLETIME];
				pMe->trash_trashGap		= pMe->endless_trashFactor[lv][TRASH_TRASHGAP];
				pMe->trash_maxPong		= pMe->endless_trashFactor[lv][TRASH_PONGPONG];
				MEMSET(pMe->trash_window,pMe->endless_trashFactor[lv][TRASH_WINDOW],9);
				pMe->trash_destScore	= pMe->endless_trashFactor[lv][TRASH_DESTSCORE];
				pMe->trash_destScore	+= weight;
			}
			// 90 ~ 100      10 ÷ ϰ Ѵ.
			else
			{
				//     10 ÷ Ѵ.
				pMe->trash_wholeTime	= pMe->endless_trashFactor[29][TRASH_WHOLETIME];
				pMe->trash_trashGap		= pMe->endless_trashFactor[29][TRASH_TRASHGAP];
				pMe->trash_maxPong		= pMe->endless_trashFactor[29][TRASH_PONGPONG];
				MEMSET(pMe->trash_window,pMe->endless_trashFactor[29][TRASH_WINDOW],9);
				pMe->trash_destScore	= pMe->endless_trashFactor[29][TRASH_DESTSCORE];
				pMe->trash_destScore	+= weight;
			}		
			break;
	}

#if CHEAT_ENDLESS_ONESECOND
	pMe->trash_wholeTime = CHEAT_ENDLESS_ONESECOND;
#endif

	MEMSET(pMe->trash_hole,0,9);


	pMe->trash_ready		= FALSE;
	pMe->trash_end			= FALSE;

	pMe->trash_pongAni		= 0;
	pMe->trash_handCurr		= 0;
	pMe->trash_handPrev		= 0;


	pMe->trash_startTime	= 0;
	pMe->trash_currTime		= 0;
	pMe->trash_currScore	= pMe->trash_destScore;
	pMe->trash_currPong		= pMe->trash_maxPong;

	pMe->trash_cleanGap		= 0;

	releaseGauge(pMe);
	setGauge(pMe,pMe->trash_pongbar_x,pMe->trash_pongbar_y,pMe->trash_maxPong,IMG_GAUGEPONG,-1,GAUGE_HORZ);	// for pongpong
}


void trashDrawBg(CMoso* pMe)
{
	if( pMe->trash_backDraw == FALSE ) 
	{
		int i,j;
		int dx,dy;
		int nx,ny;


		dx = pMe->imgGame[IMG_TRASHBG].info.cx;
		dy = pMe->imgGame[IMG_TRASHBG].info.cy;

		nx = pMe->canvas_width / dx;
		ny = pMe->canvas_height / dy;

		for(i=0;i<=nx;++i)
			for(j=0;j<=ny;++j)
				drawImage(pMe,IMG_TRASHBG,i*dx,j*dy,GFX_LEFTTOP);

		// â ׷ش.
		for(i=0;i<10;i++)
			trashDrawWindow(pMe,i);

		// draw status bar
		trashDrawStatus(pMe);


		// ȭ  
		if( pMe->canvas_height > 160 )
		{
			int y = pMe->imgGame[IMG_TRASHBGTOP].info.cy;

			drawImage(pMe,IMG_TRASHBGTOP,0,0,GFX_LEFT);
			drawImage(pMe,IMG_TRASHBGLEFT,0,y,GFX_LEFT);
			drawImage(pMe,IMG_TRASHBGRIGHT,pMe->canvas_width,y,GFX_RIGHT);
			drawImage(pMe,IMG_TRASHBGLEFT1,0,pMe->canvas_height-STATUS_HEIGHT,GFX_LEFT|GFX_BOTTOM);
			drawImage(pMe,IMG_TRASHBGRIGHT1,pMe->canvas_width,pMe->canvas_height-STATUS_HEIGHT,GFX_RIGHT|GFX_BOTTOM);
		}

		pMe->trash_backDraw = TRUE;
	}
}

void trashDrawStatus(CMoso* pMe)
{
	int i;
	int dx,dy;
	int nx;

	int x,y;

	//  ġ
	x = 0;
	y = pMe->canvas_height - STATUS_HEIGHT;

	dx = pMe->imgGame[IMG_STATUSBG].info.cx;
	dy = pMe->imgGame[IMG_STATUSBG].info.cy;

	nx = pMe->canvas_width / dx;

	for(i=0;i<=nx;++i)
		drawImage(pMe,IMG_STATUSBG,x+i*dx,y,GFX_LEFTTOP);


	// draw window icon
	x = pMe->trash_window_x; y = pMe->trash_window_y;
	drawImage(pMe,IMG_TRASHMINIWIN,x,y,GFX_LEFTTOP);


	// draw multiply
	x = pMe->trash_multiply_x; y = pMe->trash_multiply_y;
	drawImage(pMe,IMG_TRASHMULTIPLY,x,y,GFX_LEFTTOP);


	// draw time
	x = pMe->trash_time_x; y = pMe->trash_time_y;
	drawImage(pMe,IMG_TIME,x,y,GFX_LEFTTOP);


	// draw time guage
	x = pMe->trash_clock_x; y = pMe->trash_clock_y-1;
	dx = pMe->trash_point_x - pMe->trash_clock_x;
	dy = 2;
	fillRect(pMe,x,y,dx,dy,RGB(255,255,255));

	// draw clock
	x = pMe->trash_clock_x; y = pMe->trash_clock_y;
	drawImage(pMe,IMG_CLOCK,x,y,GFX_CENTER);

	switch(pMe->gameMode)
	{
		case GAMEMODE_STORY:
			x = pMe->trash_calendar_x; y = pMe->trash_calendar_y;
			drawImage(pMe,IMG_CALENDAR,x,y,GFX_LEFTTOP);
			break;

		case GAMEMODE_ENDLESS:
			x = pMe->trash_calendar_x; y = pMe->trash_calendar_y;
			drawImage(pMe,IMG_TXTLV,x,y,GFX_LEFTTOP);
			break;
	}
}


void trashUpdateBg(CMoso* pMe,int dest)
{
	int x,y,dx,dy;

	x = pMe->trash_x[dest];
	y = pMe->trash_y[dest];
	dx = pMe->imgGame[IMG_TRASHWIN1].info.cx;
	dy = pMe->imgGame[IMG_TRASHWIN1].info.cy;

	setClip(pMe,x-dx/2,y-dy/2,dx,dy);
	pMe->trash_backDraw = FALSE;
	trashDrawBg(pMe);
	trashDrawWindow(pMe,dest);
	trashDrawTrash(pMe,dest);
	trashDrawHand(pMe);	
}

void trashDrawWindow(CMoso* pMe,int dest)
{
	int x,y;
	int window;
	int temp;

	x = pMe->trash_x[dest];
	y = pMe->trash_y[dest];

	temp = pMe->trash_window[dest];
	if( temp == -1 ) temp = 0;
	// â     ׷ش.
	window = IMG_TRASHWIN1 + temp;
	drawImage(pMe,window,x,y,GFX_CENTER);
}

void trashDrawTrash(CMoso* pMe,int dest)
{
	int x,y;
	int pollute;
	int dirtType=1;
	int image=0;

	if( dest != 9 )
	{
		pollute = pMe->trash_hole[dest];

		if( pollute == 0 )
			return;	// ׷ٰ .
		else if( pollute <= 2 )
		{
			dirtType = 1;			
		}
		else if( pollute <= 4 )
		{
			dirtType = 2;
		}
		else if( pollute <= 6 )
		{
			dirtType = 3;
		}

		switch( dirtType )
		{
			case 1:
				image = 0;
				break;
			case 2:
				image = 1;
				break;
			case 3:
				image = 2;
				break;
		}
		image = IMG_TRASHBUG1 + image;

		x = pMe->trash_x[dest];
		y = pMe->trash_y[dest];
		
		setClip(pMe,x-13,y-13,26,26);
		drawImage(pMe,image,x,y,GFX_CENTER);
	}
}

void trashEraseHand(CMoso* pMe,int dest)
{
	int x,y,dx,dy;
	int	move = 3;


	x = pMe->trash_x[dest];
	y = pMe->trash_y[dest];
	dx = pMe->imgGame[IMG_TRASHSON1].info.cx;
	dy = pMe->imgGame[IMG_TRASHSON1].info.cy;
//	y -= 3;	//  ġ 

	if( pMe->trash_AniPrev == 0 )
	{
		x -= move;
		y += move;
	}
	else 
	{
		x += move;
		y -= move;
	}

	setClip(pMe,x-dx/2,y-dy/2,dx,dy);
	pMe->trash_backDraw = FALSE;
	trashDrawBg(pMe);
	trashDrawWindow(pMe,dest);
	trashDrawTrash(pMe,dest);
}

void trashDrawHand(CMoso* pMe)
{
	int x,y,dx,dy;
	int son;
	int	move = 3;

	//   ..
	if( pMe->trash_currPong == 0 )
		son = IMG_TRASHSON0;
	else if( pMe->trash_currPong < 6)
		son = IMG_TRASHSON1;
	else 
		son = IMG_TRASHSON2;

	// ο ִϸ̼ ׸
	x = pMe->trash_x[pMe->trash_handCurr];
	y = pMe->trash_y[pMe->trash_handCurr];
	dx = pMe->imgGame[IMG_TRASHSON1].info.cx;
	dy = pMe->imgGame[IMG_TRASHSON1].info.cy;
//	y -= 3; //  ġ 

	if( pMe->trash_AniCurr == 0 )
	{
		x -= move;
		y += move;
	}
	else 
	{
		x += move;
		y -= move;
	}

	setClip(pMe,x-dx/2,y-dy/2,dx,dy);
	drawImage(pMe,son,x,y,GFX_CENTER);
}

void gotoTrash(CMoso* pMe,byte state)
{
	pMe->trash_state	= state;
	pMe->trash_backDraw = FALSE;
}

void trashDrawTime(CMoso* pMe)
{
	int x,y,dx,dy;
	int percent;
	int timeguage_width = pMe->trash_point_x - pMe->trash_clock_x;

	percent = (pMe->trash_currTime << 8) / pMe->trash_wholeTime; 
	percent = (percent * timeguage_width) >> 8;
	if( percent > timeguage_width ) 
		percent = timeguage_width;


	// redraw bg
	x = pMe->trash_clock_x-5; y = pMe->trash_clock_y-5;	
	dx = 33;
	dy = 10;
	setClip(pMe,x,y,dx,dy);
	pMe->trash_backDraw = FALSE;
	trashDrawBg(pMe);	

	// draw point
	x = pMe->trash_point_x - percent; y = pMe->trash_clock_y;
	drawImage(pMe,IMG_POINT,x,y,GFX_CENTER);
}

void trashDrawPongPong(CMoso* pMe)
{
	int x,y,dx,dy;

	x = pMe->trash_pong_x;
	y = pMe->trash_pong_y;
	dx = pMe->imgGame[IMG_TRASHPONG1].info.cx;
	dy = pMe->imgGame[IMG_TRASHPONG1].info.cy;


	// redraw bg
	setClip(pMe,x,y,dx,dy);
	pMe->trash_backDraw = FALSE;
	trashDrawBg(pMe);


	// draw pong1, pong2
	if( pMe->trash_pongAni % 2 == 0 )
		drawImage(pMe,IMG_TRASHPONG1,pMe->trash_pong_x,pMe->trash_pong_y,GFX_LEFT);
	else
	{
		drawImage(pMe,IMG_TRASHPONG2,pMe->trash_pong_x,pMe->trash_pong_y,GFX_LEFT);
		pMe->trash_pongAni = 0;
	}	

	// redraw bg
	x = pMe->trash_pongbar_x;
	y = pMe->trash_pongbar_y;
	dx = pMe->imgGame[IMG_GAUGEPONG].info.cx;
	dy = pMe->imgGame[IMG_GAUGEPONG].info.cy;


	setClip(pMe,x,y,dx,dy);
	pMe->trash_backDraw = FALSE;
	trashDrawBg(pMe);

	drawGauge(pMe,pMe->trash_currPong,0);
}

void trashDrawScore(CMoso* pMe)
{
	int x,y,dx,dy;

	dx = pMe->imgGame[IMG_NUMBER1].info.cx/10;
	dy = pMe->imgGame[IMG_NUMBER1].info.cy;

	x = pMe->trash_remain_x; y = pMe->trash_remain_y;	
	setClip(pMe,x-dx*2,y,dx*2,dy);	//  2  µȴٰ .
	pMe->trash_backDraw = FALSE;
	trashDrawBg(pMe);	
	drawGNumber(pMe,pMe->trash_currScore,x,y,GNUM_TYPE1);
}


void trashDrawDay(CMoso* pMe)
{
	int x,y,dx,dy;
	int num;

	if( pMe->gameMode == GAMEMODE_STORY )
	{
		x = pMe->trash_day_x;
		y = pMe->trash_day_y;
		num = pMe->story_day+1;
	}
	else// if( pMe->gameMode == GAMEMODE_ENDLESS )
	{
		x = pMe->trash_lv_x;
		y = pMe->trash_lv_y;
		num = pMe->endless_trashlv+1;
	}
		
	dx = pMe->imgGame[IMG_NUMBER2].info.cx/10;
	dy = pMe->imgGame[IMG_NUMBER2].info.cy;

	// redraw bg
	setClip(pMe,x-dx*2,y,dx*2,dy);
	pMe->trash_backDraw = FALSE;
	trashDrawBg(pMe);

	// draw number
	drawGNumber(pMe,num,x,y,GNUM_TYPE2);
}

